/*
    Парус 8 - Панели мониторинга - РО - Редактор настройки регламентированного отчёта
    Дополнительная разметка и вёрстка клиентских элементов
*/

//---------------------
//Подключение библиотек
//---------------------

import React from "react"; //Классы React
import { Box, IconButton, Icon, Link } from "@mui/material"; //Интерфейсные компоненты

//---------
//Константы
//---------

//Стили
export const STYLES = {
    BOX_ROW: { display: "flex", justifyContent: "center", alignItems: "center" },
    LINK_STYLE: { component: "button", cursor: "pointer", width: "-webkit-fill-available" }
};

//-----------
//Тело модуля
//-----------

//Генерация представления ячейки c данными показателя раздела регламентированного отчета
export const confSctnMrkCellRender = ({ row, columnDef, onLinkClick, onEditClick, onDeleteClick }) => {
    let data = row[columnDef.name];
    columnDef.name != "SROW_NAME" && data != undefined && columnDef.visible == true
        ? (data = (
              <Box sx={STYLES.BOX_ROW}>
                  <Link sx={STYLES.LINK_STYLE} onClick={() => (onLinkClick ? onLinkClick(row["NRN_" + columnDef.name.substring(5)]) : null)}>
                      {row[columnDef.name]}
                  </Link>
                  <IconButton onClick={() => (onEditClick ? onEditClick(row["NRN_" + columnDef.name.substring(5)], row[columnDef.name]) : null)}>
                      <Icon>edit</Icon>
                  </IconButton>
                  <IconButton onClick={() => (onDeleteClick ? onDeleteClick(row["NRN_" + columnDef.name.substring(5)], row[columnDef.name]) : null)}>
                      <Icon>delete</Icon>
                  </IconButton>
              </Box>
          ))
        : null;
    return { data };
};
