create or replace package PKG_P8PANELS_SAMPLES as

  /*    */
  procedure AGNLIST_GET
  (
    COUT                    out clob    --  
  );

  /*   */
  procedure AGNLIST_INSERT
  (
    SAGNABBR                in varchar2, -- 
    SAGNNAME                in varchar2, -- 
    NRN                     out number   -- .  
  );

  /*   */
  procedure AGNLIST_DELETE
  (
    NRN                     in number   -- .  
  );
  
  /*   */
  procedure DATA_GRID
  (
    NPAGE_NUMBER            in number, --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number, --     (0 - )
    CFILTERS                in clob,   -- 
    CORDERS                 in clob,   -- 
    NINCLUDE_DEF            in number, --       
    COUT                    out clob   --   
  );

  /*  */
  procedure CHART
  (
    COUT                    out clob    --  
  );
  
  /*       */
  procedure GANTT_INIT
  (
    NIDENT                  in out number --     (null -  , !null -        )
  );
  
  /*       */
  procedure GANTT
  (
    NIDENT                  in number,  --  
    COUT                    out clob    --     
  );
  
  /*      */
  procedure GANTT_MODIFY
  (
    NIDENT                  in number,  --  
    NRN                     in number,  -- .  
    DDATE_FROM              in date,    --   
    DDATE_TO                in date     --    
  );
  
end PKG_P8PANELS_SAMPLES;
/
create or replace package body PKG_P8PANELS_SAMPLES as

  /*    */
  procedure AGNLIST_GET
  (
    COUT                    out clob      --  
  )
  is
    NVERSION                PKG_STD.TREF; -- .    
  begin
    NVERSION := GET_SESSION_VERSION(SUNITCODE => 'AGNLIST');
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    PKG_XFAST.DOWN_NODE(SNAME => 'DATA');
    for C in (select TMP.*
                from (select D.*,
                             ROWNUM NROWNUM
                        from (select T.RN      NRN,
                                     T.AGNABBR SAGNABBR,
                                     T.AGNNAME SAGNNAME
                                from AGNLIST T
                               where T.VERSION = NVERSION
                                 and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                                       null
                                        from USERPRIV UP
                                       where UP.CATALOG = T.CRN
                                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                                            UR.ROLEID
                                                             from USERROLES UR
                                                            where UR.AUTHID = UTILIZER)
                                      union all
                                      select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                                       null
                                        from USERPRIV UP
                                       where UP.CATALOG = T.CRN
                                         and UP.AUTHID = UTILIZER)
                               order by T.RN desc) D) TMP
               where TMP.NROWNUM <= 10)
    loop
      PKG_XFAST.DOWN_NODE(SNAME => 'AGENTS');
      PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => C.NRN);
      PKG_XFAST.ATTR(SNAME => 'SAGNABBR', SVALUE => C.SAGNABBR);
      PKG_XFAST.ATTR(SNAME => 'SAGNNAME', SVALUE => C.SAGNNAME);
      PKG_XFAST.UP();
    end loop;
    PKG_XFAST.UP();
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    PKG_XFAST.EPILOGUE();
  end AGNLIST_GET;

  /*   */
  procedure AGNLIST_INSERT
  (
    SAGNABBR                in varchar2,                           -- 
    SAGNNAME                in varchar2,                           -- 
    NRN                     out number                             -- .  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NCRN                    PKG_STD.TREF;                          --   
  begin
    if (SAGNABBR is null) then
      P_EXCEPTION(0, '  .');
    end if;
    if (SAGNABBR is null) then
      P_EXCEPTION(0, '  .');
    end if;
    FIND_ROOT_CATALOG(NCOMPANY => NCOMPANY, SCODE => 'AGNLIST', NCRN => NCRN);
    P_AGNLIST_INSERT(NCOMPANY          => NCOMPANY,
                     CRN               => NCRN,
                     AGNABBR           => SAGNABBR,
                     AGNTYPE           => 0,
                     AGNNAME           => SAGNNAME,
                     AGNIDNUMB         => null,
                     ECONCODE          => null,
                     ORGCODE           => null,
                     AGNFAMILYNAME     => null,
                     AGNFIRSTNAME      => null,
                     AGNLASTNAME       => null,
                     AGNFAMILYNAME_TO  => null,
                     AGNFIRSTNAME_TO   => null,
                     AGNLASTNAME_TO    => null,
                     AGNFAMILYNAME_FR  => null,
                     AGNFIRSTNAME_FR   => null,
                     AGNLASTNAME_FR    => null,
                     AGNFAMILYNAME_AC  => null,
                     AGNFIRSTNAME_AC   => null,
                     AGNLASTNAME_AC    => null,
                     AGNFAMILYNAME_ABL => null,
                     AGNFIRSTNAME_ABL  => null,
                     AGNLASTNAME_ABL   => null,
                     EMP               => 0,
                     EMPPOST           => null,
                     EMPPOST_FROM      => null,
                     EMPPOST_TO        => null,
                     EMPPOST_AC        => null,
                     EMPPOST_ABL       => null,
                     AGNBURN           => null,
                     PHONE             => null,
                     PHONE2            => null,
                     FAX               => null,
                     TELEX             => null,
                     MAIL              => null,
                     IMAGE             => null,
                     DDISCDATE         => null,
                     AGN_COMMENT       => null,
                     NSEX              => 0,
                     SPENSION_NBR      => null,
                     SMEDPOLICY_SER    => null,
                     SMEDPOLICY_NUMB   => null,
                     SPROPFORM         => null,
                     SREASON_CODE      => null,
                     NRESIDENT_SIGN    => 0,
                     STAXPSTATUS       => null,
                     SOGRN             => null,
                     SPRFMLSTS         => null,
                     SPRNATION         => null,
                     SCITIZENSHIP      => null,
                     ADDR_BURN         => null,
                     SPRMLREL          => null,
                     SOKATO            => null,
                     SPFR_NAME         => null,
                     DPFR_FILL_DATE    => null,
                     DPFR_REG_DATE     => null,
                     SPFR_REG_NUMB     => null,
                     SSFR_REG_NUMB     => null,
                     SFULLNAME         => null,
                     SOKFS             => null,
                     SOKOPF            => null,
                     STFOMS            => null,
                     SFSS_REG_NUMB     => null,
                     SFSS_SUBCODE      => null,
                     NCOEFFIC          => 0,
                     DAGNDEATH         => null,
                     NOLD_RN           => null,
                     SOKTMO            => null,
                     SINN_CITIZENSHIP  => null,
                     DTAX_REG_DATE     => null,
                     SORIGINAL_NAME    => null,
                     NIND_BUSINESSMAN  => 0,
                     SFNS_CODE         => null,
                     SCTZNSHP_TYPE     => null,
                     NCONTACT_METHOD   => null,
                     SMF_ID            => null,
                     SOKOGU            => null,
                     NRN               => NRN);
  end AGNLIST_INSERT;

  /*   */
  procedure AGNLIST_DELETE
  (
    NRN                     in number   -- .  
  )
  is
  begin
    P_AGNLIST_DELETE(NCOMPANY => GET_SESSION_COMPANY(), RN => NRN);
  end AGNLIST_DELETE;
  
  /*   */
  procedure DATA_GRID
  (
    NPAGE_NUMBER            in number,                             --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,                             --     (0 - )
    CFILTERS                in clob,                               -- 
    CORDERS                 in clob,                               -- 
    NINCLUDE_DEF            in number,                             --       
    COUT                    out clob                               --   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NIDENT                  PKG_STD.TREF := GEN_IDENT();           --  
    RF                      PKG_P8PANELS_VISUAL.TFILTERS;          -- 
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RAGN_TYPES              PKG_P8PANELS_VISUAL.TCOL_VALS;         --   " "
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    SGROUP                  PKG_STD.TSTRING;                       --   
    SAGNINFO                PKG_STD.TSTRING;                       --   ""
    SAGNNAME                PKG_STD.TSTRING;                       --   ""
    NAGNTYPE                PKG_STD.TREF;                          --   ""
  begin
    /*   */
    RF := PKG_P8PANELS_VISUAL.TFILTERS_FROM_XML(CFILTERS => CFILTERS);
    /*   */
    RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
    /*            */
    PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                             NPAGE_SIZE   => NPAGE_SIZE,
                                             NROW_FROM    => NROW_FROM,
                                             NROW_TO      => NROW_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE(BFIXED_HEADER => true, NFIXED_COLUMNS => 2);
    /*     */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SAGNABBR',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'AgentAbbr',
                                               BVISIBLE   => true,
                                               BORDER     => true,
                                               BFILTER    => true,
                                               NWIDTH     => 150);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID  => RDG,
                                               SNAME       => 'SAGNINFO',
                                               SCAPTION    => '',
                                               SDATA_TYPE  => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE    => true,
                                               BORDER      => false,
                                               BFILTER     => false,
                                               BEXPANDABLE => true,
                                               NWIDTH      => 300);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SAGNNAME',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'AgentName',
                                               BVISIBLE   => true,
                                               BORDER     => true,
                                               BFILTER    => true,
                                               SPARENT    => 'SAGNINFO',
                                               NWIDTH     => 200);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RAGN_TYPES, NVALUE => 0);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RAGN_TYPES, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NAGNTYPE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'AgentType',
                                               BVISIBLE   => true,
                                               BORDER     => true,
                                               BFILTER    => true,
                                               SPARENT    => 'SAGNINFO',
                                               NWIDTH     => 100,
                                               RCOL_VALS  => RAGN_TYPES,
                                               SHINT      => '     :<br>' ||
                                                             '<b style="color:blue"> </b> - ,    ,   ' ||
                                                             '    ,      ,    ' ||
                                                             '        ,    .<br>' ||
                                                             '<b style="color:green"> </b> -   ,    .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SFULLNAME',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SAGNIDNUMB',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select AG.AGNABBR SAGNABBR,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.AGNNAME SAGNNAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.AGNTYPE NAGNTYPE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.FULLNAME SFULLNAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.AGNIDNUMB SAGNIDNUMB');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from AGNLIST AG');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                where exists (select ' || PKG_SQL_BUILD.SET_HINT(SHINT => 'INDEX(UP I_USERPRIV_CATALOG_ROLEID)') || ' null');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                                from USERPRIV UP');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                               where UP."CATALOG" = AG.CRN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                                 and UP.ROLEID in (select ' || PKG_SQL_BUILD.SET_HINT(SHINT => 'INDEX(UR I_USERROLES_AUTHID_FK)') || ' UR.ROLEID');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                                                     from USERROLES UR where UR.AUTHID = UTILIZER())');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                                                    union all');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                                                   select ' || PKG_SQL_BUILD.SET_HINT(SHINT => 'INDEX(UP I_USERPRIV_CATALOG_AUTHID)') || ' null');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                                                     from USERPRIV UP where UP."CATALOG" = AG.CRN and UP.AUTHID = UTILIZER())');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and AG.RN in (select ID from COND_BROKER_IDSMART where IDENT = :NIDENT) %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      PKG_P8PANELS_VISUAL.TFILTERS_SET_QUERY(NIDENT     => NIDENT,
                                             NCOMPANY   => NCOMPANY,
                                             SUNIT      => 'AGNLIST',
                                             SPROCEDURE => 'P_AGNLIST_BASE_COND',
                                             RDATA_GRID => RDG,
                                             RFILTERS   => RF);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => NIDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);      
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 6);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     */
        PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR, IPOSITION => 2, SVALUE => SAGNNAME);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 3, NVALUE => NAGNTYPE);
        if (NAGNTYPE = 0) then
          SGROUP   := 'JUR';
          SAGNINFO := SAGNNAME || ', ';
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_GROUP(RDATA_GRID  => RDG,
                                                   SNAME       => SGROUP,
                                                   SCAPTION    => ' ',
                                                   BEXPANDABLE => true,
                                                   BEXPANDED   => false);
        else
          SGROUP   := 'PERS';
          SAGNINFO := SAGNNAME || ', ';
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_GROUP(RDATA_GRID  => RDG,
                                                   SNAME       => SGROUP,
                                                   SCAPTION    => ' ',
                                                   BEXPANDABLE => true,
                                                   BEXPANDED   => false);
        end if;
        RDG_ROW := PKG_P8PANELS_VISUAL.TROW_MAKE(SGROUP => SGROUP);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SAGNABBR', ICURSOR => ICURSOR, NPOSITION => 1);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SAGNINFO', SVALUE => SAGNINFO);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SAGNNAME', SVALUE => SAGNNAME);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NAGNTYPE', NVALUE => NAGNTYPE);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SFULLNAME', ICURSOR => ICURSOR, NPOSITION => 4);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SAGNIDNUMB', ICURSOR => ICURSOR, NPOSITION => 5);
        /*     */
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end DATA_GRID;
  
  /*  */
  procedure CHART
  (
    COUT                    out clob                                           --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY();             --  
    RCH                     PKG_P8PANELS_VISUAL.TCHART;                        -- 
    RCH_DS                  PKG_P8PANELS_VISUAL.TCHART_DATASET;                --  
    RATTR_VALS              PKG_P8PANELS_VISUAL.TCHART_DATASET_ITEM_ATTR_VALS; --    
  begin
    /*    */
    RCH := PKG_P8PANELS_VISUAL.TCHART_MAKE(STYPE     => PKG_P8PANELS_VISUAL.SCHART_TYPE_BAR,
                                           STITLE    => ' 5    ',
                                           SLGND_POS => PKG_P8PANELS_VISUAL.SCHART_LGND_POS_RIGHT);
    /*    */
    RCH_DS := PKG_P8PANELS_VISUAL.TCHART_DATASET_MAKE(SCAPTION => ' ');
    /*  ,    */
    for C in (select D.SAGENT,
                     D.NSUM
                from (select AG.AGNABBR SAGENT,
                             sum(CN.DOC_SUMTAX * (CN.CURBASE / CN.CURCOURS)) NSUM
                        from CONTRACTS CN,
                             AGNLIST   AG
                       where CN.COMPANY = NCOMPANY
                         and CN.AGENT = AG.RN
                       group by AG.AGNABBR
                       order by 2 desc) D
               where ROWNUM <= 5)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TCHART_ADD_LABEL(RCHART => RCH, SLABEL => C.SAGENT);
      /*       -       ""   */
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                         SNAME      => 'SCOND',
                                                         SVALUE     => 'in_SAGENT',
                                                         BCLEAR     => true);
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                         SNAME      => 'SCOND_VALUE',
                                                         SVALUE     => C.SAGENT);
      /*      */
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ADD_ITEM(RDATASET => RCH_DS, NVALUE => C.NSUM, RATTR_VALS => RATTR_VALS);
    end loop;
    /*      */
    PKG_P8PANELS_VISUAL.TCHART_ADD_DATASET(RCHART => RCH, RDATASET => RCH_DS);
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TCHART_TO_XML(RCHART => RCH, NINCLUDE_DEF => 1);
  end CHART;
  
  /*       */
  procedure GANTT_BASE_CLEAN
  (
    NIDENT                  in number   --  
  )
  is
  begin
    /*        */
    delete from P8PNL_SMPL_GANTT T where T.IDENT = NIDENT;
  end GANTT_BASE_CLEAN;

  /*       */
  procedure GANTT_BASE_INSERT
  (
    NIDENT                  in number,   --  
    NTYPE                   in number,   --   (0 - /, 1 - )
    SNUMB                   in varchar2, --  
    SNAME                   in varchar2, --  
    DDATE_FROM              in date,     --   
    DDATE_TO                in date,     --   
    NSTATE                  in number    --  (0 -  , 1 - )
  )
  is
  begin
    /*   */
    insert into P8PNL_SMPL_GANTT
      (RN, IDENT, type, NUMB, name, DATE_FROM, DATE_TO, STATE)
    values
      (GEN_ID(), NIDENT, NTYPE, SNUMB, SNAME, DDATE_FROM, DDATE_TO, NSTATE);
  end GANTT_BASE_INSERT;
  
  /*       */
  procedure GANTT_BASE_UPDATE
  (
    NIDENT                  in number,   --  
    NRN                     in number,   -- .  
    NTYPE                   in number,   --   (0 - /, 1 - )
    SNUMB                   in varchar2, --  
    SNAME                   in varchar2, --  
    DDATE_FROM              in date,     --   
    DDATE_TO                in date      --   
  )
  is
  begin
    /*   */
    update P8PNL_SMPL_GANTT T
       set T.TYPE      = NTYPE,
           T.NUMB      = SNUMB,
           T.NAME      = SNAME,
           T.DATE_FROM = DDATE_FROM,
           T.DATE_TO   = DDATE_TO
     where T.RN = NRN
       and T.IDENT = NIDENT;
  end GANTT_BASE_UPDATE;
 
  /*       */
  procedure GANTT_INIT
  (
    NIDENT                  in out number                  --     (null -  , !null -        )
  )
  is
    /*  */
    NSTAGE_LEN              constant PKG_STD.TNUMBER := 3; --   ( )
    /*  */
    NYEAR                   PKG_STD.TNUMBER;               --  
    NMONTH                  PKG_STD.TNUMBER;               --   
    DDATE_FROM              PKG_STD.TLDATE;                --   
    DDATE_TO                PKG_STD.TLDATE;                --   
    DDATE_FROM_J            PKG_STD.TLDATE;                --   
    DDATE_TO_J              PKG_STD.TLDATE;                --   
    NSTATE                  PKG_STD.TNUMBER;               --  
  begin
    /*      */
    if (NIDENT is not null) then
      GANTT_BASE_CLEAN(NIDENT => NIDENT);
    else
      /*   ,    */
      NIDENT := GEN_IDENT();
    end if;
    /*    */
    NYEAR := EXTRACT(year from sysdate);
    /*  */
    for ST in 1 .. 12 / NSTAGE_LEN
    loop
      /*    */
      NMONTH     := ST * NSTAGE_LEN - NSTAGE_LEN + 1;
      DDATE_FROM := TO_DATE('01.' || NMONTH || '.' || TO_CHAR(NYEAR), 'dd.mm.yyyy');
      DDATE_TO   := LAST_DAY(ADD_MONTHS(DDATE_FROM, NSTAGE_LEN) - 1);
      /*     ""  */
      if (TRUNC(sysdate) between TRUNC(DDATE_FROM) and TRUNC(DDATE_TO)) then
        NSTATE := 1;
      else
        NSTATE := 0;
      end if;
      /*     */
      GANTT_BASE_INSERT(NIDENT     => NIDENT,
                        NTYPE      => 0,
                        SNUMB      => TO_CHAR(ST),
                        SNAME      => ' ' || TO_CHAR(ST),
                        DDATE_FROM => DDATE_FROM,
                        DDATE_TO   => DDATE_TO,
                        NSTATE     => NSTATE);
      /*  */
      for J in 0 .. NSTAGE_LEN - 1
      loop
        /*    */
        DDATE_FROM_J := ADD_MONTHS(DDATE_FROM, J);
        DDATE_TO_J   := LAST_DAY(ADD_MONTHS(DDATE_FROM, J + 1) - 1);
        /*     ""  */
        if (TRUNC(sysdate) between TRUNC(DDATE_FROM_J) and TRUNC(DDATE_TO_J)) then
          NSTATE := 1;
        else
          NSTATE := 0;
        end if;
        /*    */
        GANTT_BASE_INSERT(NIDENT     => NIDENT,
                          NTYPE      => 1,
                          SNUMB      => TO_CHAR(ST) || '.' || TO_CHAR(J + 1),
                          SNAME      => ' ' || TO_CHAR(J + 1) || '  ' || TO_CHAR(ST),
                          DDATE_FROM => DDATE_FROM_J,
                          DDATE_TO   => DDATE_TO_J,
                          NSTATE     => NSTATE);
      end loop;
    end loop;
  end GANTT_INIT;
  
  /*       */
  procedure GANTT
  (
    NIDENT                  in number,                                --  
    COUT                    out clob                                  --     
  )
  is
    /*  */
    SBG_COLOR_STAGE         constant PKG_STD.TSTRING := 'cadetblue';  --   
    SBG_COLOR_JOB           constant PKG_STD.TSTRING := 'lightgreen'; --   
    /*  */
    RG                      PKG_P8PANELS_VISUAL.TGANTT;               --   
    RGT                     PKG_P8PANELS_VISUAL.TGANTT_TASK;          --        
    STASK_BG_COLOR          PKG_STD.TSTRING;                          --   
  begin
    /*    */
    RG := PKG_P8PANELS_VISUAL.TGANTT_MAKE(STITLE => '  ' || TO_CHAR(EXTRACT(year from sysdate)) || ' ',
                                          NZOOM  => PKG_P8PANELS_VISUAL.NGANTT_ZOOM_MONTH);
    /*      */
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT => RG, SNAME => 'type', SCAPTION => '', BVISIBLE => true);
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT   => RG,
                                             SNAME    => 'state',
                                             SCAPTION => '',
                                             BVISIBLE => false);
    /*     */
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_JOB,
                                              SDESC     => '   .');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_STAGE,
                                              SDESC     => '   .');
    /*   */
    for C in (select T.* from P8PNL_SMPL_GANTT T where T.IDENT = NIDENT order by T.RN)
    loop
      /*    */
      if (C.TYPE = 0) then
        STASK_BG_COLOR := SBG_COLOR_STAGE;
      else
        STASK_BG_COLOR := SBG_COLOR_JOB;
      end if;
      /*   */
      RGT := PKG_P8PANELS_VISUAL.TGANTT_TASK_MAKE(NRN       => C.RN,
                                                  SNUMB     => C.NUMB,
                                                  SCAPTION  => C.NUMB || ' - ' || C.NAME,
                                                  SNAME     => C.NAME,
                                                  DSTART    => C.DATE_FROM,
                                                  DEND      => C.DATE_TO,
                                                  SBG_COLOR => STASK_BG_COLOR);
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG,
                                                   RTASK  => RGT,
                                                   SNAME  => 'type',
                                                   SVALUE => C.TYPE,
                                                   BCLEAR => true);
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG, RTASK => RGT, SNAME => 'state', SVALUE => C.STATE);
      /*     */
      PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK(RGANTT => RG, RTASK => RGT);
    end loop;
    /*    */
    COUT := PKG_P8PANELS_VISUAL.TGANTT_TO_XML(RGANTT => RG);
  end GANTT;
  
  /*      */
  procedure GANTT_MODIFY
  (
    NIDENT                  in number,  --  
    NRN                     in number,  -- .  
    DDATE_FROM              in date,    --   
    DDATE_TO                in date     --    
  )
  is
  begin
    for C in (select T.*
                from P8PNL_SMPL_GANTT T
               where T.RN = NRN
                 and T.IDENT = NIDENT)
    loop
      GANTT_BASE_UPDATE(NIDENT     => C.IDENT,
                        NRN        => C.RN,
                        NTYPE      => C.TYPE,
                        SNUMB      => C.NUMB,
                        SNAME      => C.NAME,
                        DDATE_FROM => TRUNC(DDATE_FROM),
                        DDATE_TO   => TRUNC(DDATE_TO));
    end loop;
  end GANTT_MODIFY;

end PKG_P8PANELS_SAMPLES;
/
