create or replace package PKG_P8PANELS_VISUAL as

  /*  -   */
  SDATA_TYPE_STR            constant PKG_STD.TSTRING := 'STR';  --   ""
  SDATA_TYPE_NUMB           constant PKG_STD.TSTRING := 'NUMB'; --   ""
  SDATA_TYPE_DATE           constant PKG_STD.TSTRING := 'DATE'; --   ""
  
  /*  -   */
  SORDER_DIRECTION_ASC      constant PKG_STD.TSTRING := 'ASC';  --  
  SORDER_DIRECTION_DESC     constant PKG_STD.TSTRING := 'DESC'; --  
  
  /*  -    */
  NGANTT_ZOOM_QUARTER_DAY   constant PKG_STD.TNUMBER := 0; --  
  NGANTT_ZOOM_HALF_DAY      constant PKG_STD.TNUMBER := 1; --  
  NGANTT_ZOOM_DAY           constant PKG_STD.TNUMBER := 2; -- 
  NGANTT_ZOOM_WEEK          constant PKG_STD.TNUMBER := 3; -- 
  NGANTT_ZOOM_MONTH         constant PKG_STD.TNUMBER := 4; -- 
  
  /*  -   */
  SCHART_TYPE_BAR           constant PKG_STD.TSTRING := 'bar';
  SCHART_TYPE_LINE          constant PKG_STD.TSTRING := 'line';
  SCHART_TYPE_PIE           constant PKG_STD.TSTRING := 'pie';
  SCHART_TYPE_DOUGHNUT      constant PKG_STD.TSTRING := 'doughnut';

  /*  -    */  
  SCHART_LGND_POS_LEFT      constant PKG_STD.TSTRING := 'left';
  SCHART_LGND_POS_RIGHT     constant PKG_STD.TSTRING := 'right';
  SCHART_LGND_POS_TOP       constant PKG_STD.TSTRING := 'top';
  SCHART_LGND_POS_BOTTOM    constant PKG_STD.TSTRING := 'bottom';

  /*   -     */
  type TCOL_VAL is record
  (
    SVALUE                  PKG_STD.TLSTRING, --  ()
    NVALUE                  PKG_STD.TLNUMBER, --  ()
    DVALUE                  PKG_STD.TLDATE    --  ()
  );
  
  /*   -      */
  type TCOL_VALS is table of TCOL_VAL;
 
  /*   -     */
  type TCOL_DEF is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SCAPTION                PKG_STD.TSTRING, -- 
    SDATA_TYPE              PKG_STD.TSTRING, --   (.  SDATA_TYPE_*)
    SCOND_FROM              PKG_STD.TSTRING, --     
    SCOND_TO                PKG_STD.TSTRING, --     
    BVISIBLE                boolean,         --  
    BORDER                  boolean,         --  
    BFILTER                 boolean,         --  
    RCOL_VALS               TCOL_VALS,       --  
    SHINT                   PKG_STD.TSTRING, --   
    SPARENT                 PKG_STD.TSTRING, --   
    BEXPANDABLE             boolean,         --  /  
    BEXPANDED               boolean,         -- /  
    NWIDTH                  PKG_STD.TNUMBER  --   (  )
  );
  
  /*   -      */
  type TCOL_DEFS is table of TCOL_DEF;
  
  /*   -  */
  type TCOL is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    RCOL_VAL                TCOL_VAL         -- 
  );

  /*   -   */
  type TCOLS is table of TCOL;
  
  /*   -  */
  type TROW is record
  (
    SGROUP                  PKG_STD.TSTRING, --  
    RCOLS                   TCOLS            -- 
  );
  
  /*   -   */
  type TROWS is table of TROW;

  /*   -  */
  type TGROUP is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SCAPTION                PKG_STD.TSTRING, -- 
    BEXPANDABLE             boolean,         --  /  
    BEXPANDED               boolean          -- / 
  );
  
  /*   -   */
  type TGROUPS is table of TGROUP;
  
  /*   -   */
  type TDATA_GRID is record
  (
    BFIXED_HEADER           boolean,         --  
    NFIXED_COLUMNS          PKG_STD.TNUMBER, --   
    RCOL_DEFS               TCOL_DEFS,       --  
    RGROUPS                 TGROUPS,         --  
    RROWS                   TROWS            --  
  );
  
  /*   -  */
  type TFILTER is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SFROM                   PKG_STD.TSTRING, --  ""
    STO                     PKG_STD.TSTRING  --  ""
  );
  
  /*   -   */
  type TFILTERS is table of TFILTER;
  
  /*   -  */
  type TORDER is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SDIRECTION              PKG_STD.TSTRING  --  (.  SORDER_DIRECTION_*)
  );
  
  /*   -   */
  type TORDERS is table of TORDER;
  
  /*   -       */
  type TGANTT_TASK_ATTR is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SCAPTION                PKG_STD.TSTRING, -- 
    BVISIBLE                boolean          --  
  );
  
  /*   -        */
  type TGANTT_TASK_ATTRS is table of TGANTT_TASK_ATTR;

  /*   -       */
  type TGANTT_TASK_ATTR_VAL is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SVALUE                  PKG_STD.TSTRING  -- 
  );
  
  /*   -        */
  type TGANTT_TASK_ATTR_VALS is table of TGANTT_TASK_ATTR_VAL;
  
  /*   -         */
  type TGANTT_TASK_DEPENDENCIES is table of PKG_STD.TREF;
  
  /*   -     */
  type TGANTT_TASK is record
  (
    NRN                     PKG_STD.TREF,                    -- . 
    SNUMB                   PKG_STD.TSTRING,                 -- 
    SCAPTION                PKG_STD.TSTRING,                 -- 
    SNAME                   PKG_STD.TSTRING,                 -- 
    DSTART                  PKG_STD.TLDATE,                  --  
    DEND                    PKG_STD.TLDATE,                  --  
    NPROGRESS               PKG_STD.TLNUMBER := null,        --  (% )  (null -  )
    SBG_COLOR               PKG_STD.TSTRING := null,         --    (null -      ,  - HTML-, #RRGGBBAA)
    STEXT_COLOR             PKG_STD.TSTRING := null,         --     (null -      ,  - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      PKG_STD.TSTRING := null,         --    (null -      ,  - HTML-, #RRGGBBAA)
    BREAD_ONLY              boolean := null,                 --        (null -     )
    BREAD_ONLY_DATES        boolean := null,                 --      (null -     )
    BREAD_ONLY_PROGRESS     boolean := null,                 --      (null -     )
    RATTR_VALS              TGANTT_TASK_ATTR_VALS := null,   --    (null -    )
    RDEPENDENCIES           TGANTT_TASK_DEPENDENCIES := null --   
  );
  
  /*   -     */
  type TGANTT_TASKS is table of TGANTT_TASK;
  
  /*   -      */
  type TGANTT_TASK_COLOR is record
  (
    SBG_COLOR               PKG_STD.TSTRING := null, --    ( - HTML-, #RRGGBBAA)
    STEXT_COLOR             PKG_STD.TSTRING := null, --     ( - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      PKG_STD.TSTRING := null, --    ( - HTML-, #RRGGBBAA)
    SDESC                   PKG_STD.TSTRING          -- 
  );
  
  /*   -       */
  type TGANTT_TASK_COLORS is table of TGANTT_TASK_COLOR;
  
  /*   -   */
  type TGANTT is record
  (
    STITLE                  PKG_STD.TSTRING := null,             --  (null -  )
    NZOOM                   PKG_STD.TNUMBER := NGANTT_ZOOM_WEEK, --   (.  NGANTT_ZOOM_*)
    BZOOM_BAR               boolean := true,                     --   
    BREAD_ONLY              boolean := false,                    --       
    BREAD_ONLY_DATES        boolean := false,                    --     
    BREAD_ONLY_PROGRESS     boolean := false,                    --     
    RTASK_ATTRS             TGANTT_TASK_ATTRS,                   --    
    RTASK_COLORS            TGANTT_TASK_COLORS,                  --   
    RTASKS                  TGANTT_TASKS                         --  
  );
  
  /*   -      */
  type TCHART_DATASET_ITEM_ATTR_VAL is record
  (
    SNAME                   PKG_STD.TSTRING, -- 
    SVALUE                  PKG_STD.TSTRING  -- 
  );
  
  /*   -       */
  type TCHART_DATASET_ITEM_ATTR_VALS is table of TCHART_DATASET_ITEM_ATTR_VAL;  
  
  /*   -    */
  type TCHART_DATASET_ITEM is record
  (
    NVALUE                  PKG_STD.TLNUMBER,                     --   ,   
    RATTR_VALS              TCHART_DATASET_ITEM_ATTR_VALS := null --    (null -    )
  );
  
  /*   -    */
  type TCHART_DATASET_ITEMS is table of TCHART_DATASET_ITEM;
  
  /*   -    */
  type TCHART_DATASET is record
  (
    SCAPTION                PKG_STD.TSTRING,         -- 
    SBORDER_COLOR           PKG_STD.TSTRING := null, --       (null -      ,  - HTML-, #RRGGBBAA)
    SBG_COLOR               PKG_STD.TSTRING := null, --       (null -      ,  - HTML-, #RRGGBBAA)
    RITEMS                  TCHART_DATASET_ITEMS     --  
  );
  
  /*   -     */
  type TCHART_DATASETS is table of TCHART_DATASET;
  
  /*   -     */
  type TCHART_LABELS is table of PKG_STD.TSTRING;
  
  /*   -  */
  type TCHART is record
  (
    STYPE                   PKG_STD.TSTRING,         --  (.  SCHART_TYPE_*)
    STITLE                  PKG_STD.TSTRING := null, --  (null -  )
    SLGND_POS               PKG_STD.TSTRING := null, --   (null -  , .  SCHART_LGND_POS_*)
    RLABELS                 TCHART_LABELS,           --  
    RDATASETS               TCHART_DATASETS          --  
  );
  
  /*     */
  procedure UTL_ROWS_LIMITS_CALC
  (
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    NROW_FROM               out number, --   
    NROW_TO                 out number  --   
  );
  
  /*        */
  function UTL_COND_NAME_MAKE_FROM
  (
    SNAME                   in varchar2 --  
  ) return                  varchar2;   -- 
  
  /*        */
  function UTL_COND_NAME_MAKE_TO
  (
    SNAME                   in varchar2 --  
  ) return                  varchar2;   -- 
  
  /*     */
  procedure TCOL_VALS_ADD
  (
    RCOL_VALS               in out nocopy TCOL_VALS, --  
    SVALUE                  in varchar2 := null,     --  ()
    NVALUE                  in number := null,       --  ()
    DVALUE                  in date := null,         --  ()
    BCLEAR                  in boolean := false      --    (false -  , true -    )
  );
  
  /*   */
  function TROW_MAKE
  (
    SGROUP                  in varchar2 := null --  
  ) return                  TROW;               --  
  
  /*     */
  procedure TROW_ADD_COL
  (
    RROW                    in out nocopy TROW,  -- 
    SNAME                   in varchar2,         --  
    SVALUE                  in varchar2 := null, --  ()
    NVALUE                  in number := null,   --  ()
    DVALUE                  in date := null,     --  ()
    BCLEAR                  in boolean := false  --    (false -  , true -    )
  );
  
  /*          */
  procedure TROW_ADD_CUR_COLS
  (
    RROW                    in out nocopy TROW, -- 
    SNAME                   in varchar2,        --  
    ICURSOR                 in integer,         -- 
    NPOSITION               in number,          --    
    BCLEAR                  in boolean := false --    (false -  , true -    )
  );
  
  /*          */
  procedure TROW_ADD_CUR_COLN
  (
    RROW                    in out nocopy TROW, -- 
    SNAME                   in varchar2,        --  
    ICURSOR                 in integer,         -- 
    NPOSITION               in number,          --    
    BCLEAR                  in boolean := false --    (false -  , true -    )
  );

  /*    ""       */
  procedure TROW_ADD_CUR_COLD
  (
    RROW                    in out nocopy TROW, -- 
    SNAME                   in varchar2,        --  
    ICURSOR                 in integer,         -- 
    NPOSITION               in number,          --    
    BCLEAR                  in boolean := false --    (false -  , true -    )
  );
  
  /*    */
  function TDATA_GRID_MAKE
  (
    BFIXED_HEADER           in boolean := false, --  
    NFIXED_COLUMNS          in number := 0       --   
  ) return                  TDATA_GRID;          --  
  
  /*         */
  function TDATA_GRID_FIND_COL_DEF
  (
    RDATA_GRID              in TDATA_GRID, --   
    SNAME                   in varchar2    --  
  ) return                  TCOL_DEF;      --   (null -   )
  
  /*       */
  procedure TDATA_GRID_ADD_COL_DEF
  (
    RDATA_GRID              in out nocopy TDATA_GRID,      --   
    SNAME                   in varchar2,                   --  
    SCAPTION                in varchar2,                   --  
    SDATA_TYPE              in varchar2 := SDATA_TYPE_STR, --    (.  SDATA_TYPE_*)
    SCOND_FROM              in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_FROM)
    SCOND_TO                in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_TO)
    BVISIBLE                in boolean := true,            --  
    BORDER                  in boolean := false,           --    
    BFILTER                 in boolean := false,           --    
    RCOL_VALS               in TCOL_VALS := null,          --   
    SHINT                   in varchar2 := null,           --   
    SPARENT                 in varchar2 := null,           --   
    BEXPANDABLE             in boolean := false,           --  /  
    BEXPANDED               in boolean := true,            -- /  
    NWIDTH                  in number := null,             --   (  )
    BCLEAR                  in boolean := false            --        (false -  , true -    )
  );
  
  /*       */
  procedure TDATA_GRID_ADD_GROUP
  (
    RDATA_GRID              in out nocopy TDATA_GRID, --   
    SNAME                   in varchar2,              --  
    SCAPTION                in varchar2,              --  
    BEXPANDABLE             in boolean := false,      --  / 
    BEXPANDED               in boolean := true,       -- / 
    BCLEAR                  in boolean := false       --        (false -  , true -    )
  );
  
  /*       */
  procedure TDATA_GRID_ADD_ROW
  (
    RDATA_GRID              in out nocopy TDATA_GRID, --   
    RROW                    in TROW,                  -- 
    BCLEAR                  in boolean := false       --       (false -  , true -    )
  );

  /*    */
  function TDATA_GRID_TO_XML
  (
    RDATA_GRID              in TDATA_GRID, --   
    NINCLUDE_DEF            in number := 1 --    (0 - , 1 - )
  ) return                  clob;          -- XML-

  
  /*      */
  procedure TFILTER_TO_NUMBER
  (
    RFILTER                 in TFILTER, -- 
    NFROM                   out number, --    
    NTO                     out number  --    
  );

  /*      */
  procedure TFILTER_TO_DATE
  (
    RFILTER                 in TFILTER, -- 
    DFROM                   out date,   --    
    DTO                     out date    --    
  );
  
  /*     */
  function TFILTERS_FIND
  (
    RFILTERS                in TFILTERS, --  
    SNAME                   in varchar2  -- 
  ) return                  TFILTER;     --   (null -   )
  
  /*   */
  function TFILTERS_FROM_XML
  (
    CFILTERS                in clob     --    (BASE64(<filters><name></name><from></from><to></to></filters>...))
  ) return                  TFILTERS;   --  

  /*      */
  procedure TFILTERS_SET_QUERY
  (
    NIDENT                  in number,         --  
    NCOMPANY                in number,         -- .  
    NPARENT                 in number := null, -- .  
    SUNIT                   in varchar2,       --  
    SPROCEDURE              in varchar2,       --    
    RDATA_GRID              in TDATA_GRID,     --   
    RFILTERS                in TFILTERS        --  
  );
  
  /*   */
  function TORDERS_FROM_XML
  (
    CORDERS                 in clob     --    (BASE64(<orders><name></name><direction>ASC/DESC</direction></orders>...))
  ) return                  TORDERS;    --  

  /*      */
  procedure TORDERS_SET_QUERY
  (
    RDATA_GRID              in TDATA_GRID,     --  
    RORDERS                 in TORDERS,        --  
    SPATTERN                in varchar2,       --       
    CSQL                    in out nocopy clob --  
  );
  
  /*      */
  function TGANTT_TASK_MAKE
  (
    NRN                     in number,           -- . 
    SNUMB                   in varchar2,         -- 
    SCAPTION                in varchar2,         -- 
    SNAME                   in varchar2,         --     
    DSTART                  in date,             --  
    DEND                    in date,             --  
    NPROGRESS               in number := null,   --  (% )  (null -  )
    SBG_COLOR               in varchar2 := null, --    (null -      ,  - HTML-, #RRGGBBAA)
    STEXT_COLOR             in varchar2 := null, --     (null -      ,  - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      in varchar2 := null, --    (null -      ,  - HTML-, #RRGGBBAA)
    BREAD_ONLY              in boolean := null,  --        (null -     )
    BREAD_ONLY_DATES        in boolean := null,  --      (null -     )
    BREAD_ONLY_PROGRESS     in boolean := null   --      (null -     )
  ) return                  TGANTT_TASK;         --  
  
  /*        */
  procedure TGANTT_TASK_ADD_ATTR_VAL
  (
    RGANTT                  in TGANTT,                 --  
    RTASK                   in out nocopy TGANTT_TASK, --  
    SNAME                   in varchar2,               -- 
    SVALUE                  in varchar2,               -- 
    BCLEAR                  in boolean := false        --      (false -  , true -    )
  );
  
  /*        */
  procedure TGANTT_TASK_ADD_DEPENDENCY
  (
    RTASK                   in out nocopy TGANTT_TASK, --  
    NDEPENDENCY             in number,                 -- .   
    BCLEAR                  in boolean := false        --      (false -  , true -    )
  );
  
  /*    */
  function TGANTT_MAKE
  (
    STITLE                  in varchar2 := null,           --  (null -  )
    NZOOM                   in number := NGANTT_ZOOM_WEEK, --   (.  NGANTT_ZOOM_*)
    BZOOM_BAR               in boolean := true,            --   
    BREAD_ONLY              in boolean := false,           --       
    BREAD_ONLY_DATES        in boolean := false,           --     
    BREAD_ONLY_PROGRESS     in boolean := false            --     
  ) return                  TGANTT;                        --  
  
  /*        */
  procedure TGANTT_ADD_TASK_ATTR
  (
    RGANTT                  in out nocopy TGANTT, --   
    SNAME                   in varchar2,          -- 
    SCAPTION                in varchar2,          -- 
    BVISIBLE                boolean := true,      --  
    BCLEAR                  in boolean := false   --     (false -  , true -    )
  );

  /*       */
  procedure TGANTT_ADD_TASK_COLOR
  (
    RGANTT                  in out nocopy TGANTT, --   
    SBG_COLOR               in varchar2 := null,  --    ( - HTML-, #RRGGBBAA)
    STEXT_COLOR             in varchar2 := null,  --     ( - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      in varchar2 := null,  --    ( - HTML-, #RRGGBBAA)
    SDESC                   in varchar2,          -- 
    BCLEAR                  in boolean := false   --     (false -  , true -    )
  );

  /*      */
  procedure TGANTT_ADD_TASK
  (
    RGANTT                  in out nocopy TGANTT, --   
    RTASK                   in TGANTT_TASK,       -- 
    BCLEAR                  in boolean := false   --      (false -  , true -    )
  );
  
  /*    */
  function TGANTT_TO_XML
  (
    RGANTT                  in TGANTT,     --   
    NINCLUDE_DEF            in number := 1 --    (0 - , 1 - )
  ) return                  clob;          -- XML-

  /*       */
  procedure TCHART_DATASET_ITM_ATTR_VL_ADD
  (
    RATTR_VALS              in out nocopy TCHART_DATASET_ITEM_ATTR_VALS, --      
    SNAME                   PKG_STD.TSTRING,                             -- 
    SVALUE                  PKG_STD.TSTRING,                             -- 
    BCLEAR                  in boolean := false                          --        (false -  , true -    )
  );

  /*     */
  function TCHART_DATASET_MAKE
  (
    SCAPTION                in varchar2,         -- 
    SBORDER_COLOR           in varchar2 := null, --       (null -      ,  - HTML-, #RRGGBBAA)
    SBG_COLOR               in varchar2 := null  --       (null -      ,  - HTML-, #RRGGBBAA)
  ) return                  TCHART_DATASET;      --  

  /*       */
  procedure TCHART_DATASET_ADD_ITEM
  (
    RDATASET                in out nocopy TCHART_DATASET,             --    
    NVALUE                  in number,                                --   ,   
    RATTR_VALS              in TCHART_DATASET_ITEM_ATTR_VALS := null, --    (null -    )
    BCLEAR                  in boolean := false                       --       (false -  , true -    )
  );

  /*   */
  function TCHART_MAKE
  (
    STYPE                   in varchar2,         --  (.  SCHART_TYPE_*)
    STITLE                  in varchar2 := null, --  (null -  )
    SLGND_POS               in varchar2 := null  --   (null -  , .  SCHART_LGND_POS_*)
  ) return                  TCHART;              --  

  /*     */
  procedure TCHART_ADD_LABEL
  (
    RCHART                  in out nocopy TCHART, --  
    SLABEL                  in varchar2,          --  
    BCLEAR                  in boolean := false   --     (false -  , true -    )
  );

  /*     */
  procedure TCHART_ADD_DATASET
  (
    RCHART                  in out nocopy TCHART, --  
    RDATASET                in TCHART_DATASET,    --  
    BCLEAR                  in boolean := false   --      (false -  , true -    )
  );

  /*   */
  function TCHART_TO_XML
  (
    RCHART                  in TCHART,     --  
    NINCLUDE_DEF            in number := 1 --    (0 - , 1 - )
  ) return                  clob;          -- XML-

end PKG_P8PANELS_VISUAL;
/
create or replace package body PKG_P8PANELS_VISUAL as
/*
TODO: owner="root" created="18.10.2023"
text=" data_grid  gant   chart"
*/
  /*  -   */
  SRQ_TAG_XROOT               constant PKG_STD.TSTRING := 'XROOT';     --     
  SRQ_TAG_XFILTERS            constant PKG_STD.TSTRING := 'filters';   --    
  SRQ_TAG_XORDERS             constant PKG_STD.TSTRING := 'orders';    --    
  SRQ_TAG_SNAME               constant PKG_STD.TSTRING := 'name';      --   
  SRQ_TAG_SDIRECTION          constant PKG_STD.TSTRING := 'direction'; --   
  SRQ_TAG_SFROM               constant PKG_STD.TSTRING := 'from';      --    ""
  SRQ_TAG_STO                 constant PKG_STD.TSTRING := 'to';        --    ""

  /*  -   */
  SRESP_TAG_XDATA             constant PKG_STD.TSTRING := 'XDATA';        --     
  SRESP_TAG_XROWS             constant PKG_STD.TSTRING := 'XROWS';        --    
  SRESP_TAG_XCOLUMNS_DEF      constant PKG_STD.TSTRING := 'XCOLUMNS_DEF'; --    
  SRESP_TAG_XGROUPS           constant PKG_STD.TSTRING := 'XGROUPS';      --    
  SRESP_TAG_XGANTT_DEF        constant PKG_STD.TSTRING := 'XGANTT_DEF';   --      
  SRESP_TAG_XGANTT_TASKS      constant PKG_STD.TSTRING := 'XGANTT_TASKS'; --       
  SRESP_TAG_XCHART            constant PKG_STD.TSTRING := 'XCHART';       --    
  SRESP_TAG_XDATA_GRID        constant PKG_STD.TSTRING := 'XDATA_GRID';   --     
  
  /*  -   () */
  SRESP_ATTR_NAME             constant PKG_STD.TSTRING := 'name';         --   
  SRESP_ATTR_CAPTION          constant PKG_STD.TSTRING := 'caption';      --   
  SRESP_ATTR_DATA_TYPE        constant PKG_STD.TSTRING := 'dataType';     --    
  SRESP_ATTR_VISIBLE          constant PKG_STD.TSTRING := 'visible';      --    
  SRESP_ATTR_TITLE            constant PKG_STD.TSTRING := 'title';        --   
  SRESP_ATTR_ZOOM             constant PKG_STD.TSTRING := 'zoom';         --   
  SRESP_ATTR_ID               constant PKG_STD.TSTRING := 'id';           --   
  SRESP_ATTR_START            constant PKG_STD.TSTRING := 'start';        --    
  SRESP_ATTR_END              constant PKG_STD.TSTRING := 'end';          --    
  SRESP_ATTR_RN               constant PKG_STD.TSTRING := 'rn';           --   . 
  SRESP_ATTR_NUMB             constant PKG_STD.TSTRING := 'numb';         --   
  SRESP_ATTR_FULL_NAME        constant PKG_STD.TSTRING := 'fullName';     --    
  SRESP_ATTR_DESC             constant PKG_STD.TSTRING := 'desc';         --   
  SRESP_ATTR_TYPE             constant PKG_STD.TSTRING := 'type';         --   
  SRESP_ATTR_HINT             constant PKG_STD.TSTRING := 'hint';         --   
  SRESP_ATTR_GROUP_NAME       constant PKG_STD.TSTRING := 'groupName';    --    
  SRESP_ATTR_PARENT           constant PKG_STD.TSTRING := 'parent';       --     
  SRESP_ATTR_EXPANDABLE       constant PKG_STD.TSTRING := 'expandable';   --     /
  SRESP_ATTR_EXPANDED         constant PKG_STD.TSTRING := 'expanded';     --    /
  SRESP_ATTR_FIXED_HEADER     constant PKG_STD.TSTRING := 'fixedHeader';  --     
  SRESP_ATTR_FIXED_COLUMNS    constant PKG_STD.TSTRING := 'fixedColumns'; --     
  SRESP_ATTR_WIDTH            constant PKG_STD.TSTRING := 'width';        --   

  /*  -   ( ) */
  SRESP_ATTR_DT_ORDER         constant PKG_STD.TSTRING := 'order';  --    
  SRESP_ATTR_DT_FILTER        constant PKG_STD.TSTRING := 'filter'; --    
  SRESP_ATTR_DT_COLUMN_VALUES constant PKG_STD.TSTRING := 'values'; --    

  /*  -   ( ) */  
  SRESP_ATTR_GANTT_ZOOM_BAR    constant PKG_STD.TSTRING := 'zoomBar';          --        
  SRESP_ATTR_TASK_PROGRESS     constant PKG_STD.TSTRING := 'progress';         --    
  SRESP_ATTR_TASK_DEPS         constant PKG_STD.TSTRING := 'dependencies';     --    
  SRESP_ATTR_TASK_RO           constant PKG_STD.TSTRING := 'readOnly';         --     "  "
  SRESP_ATTR_TASK_RO_PRGRS     constant PKG_STD.TSTRING := 'readOnlyProgress'; --     "   "
  SRESP_ATTR_TASK_RO_DATES     constant PKG_STD.TSTRING := 'readOnlyDates';    --     "   "
  SRESP_ATTR_TASK_BG_COLOR     constant PKG_STD.TSTRING := 'bgColor';          --     
  SRESP_ATTR_TASK_TEXT_COLOR   constant PKG_STD.TSTRING := 'textColor';        --     
  SRESP_ATTR_TASK_BG_PRG_COLOR constant PKG_STD.TSTRING := 'bgProgressColor';  --     
  SRESP_ATTR_TASK_ATTRIBUTES   constant PKG_STD.TSTRING := 'taskAttributes';   --     
  SRESP_ATTR_TASK_COLORS       constant PKG_STD.TSTRING := 'taskColors';       --     

  /*  -   () */  
  SRESP_ATTR_CHART_LGND_POS   constant PKG_STD.TSTRING := 'legendPosition';  --      
  SRESP_ATTR_CHART_LABELS     constant PKG_STD.TSTRING := 'labels';          --    
  SRESP_ATTR_CHART_DATASETS   constant PKG_STD.TSTRING := 'datasets';        --     
  SRESP_ATTR_CHART_DS_LABEL   constant PKG_STD.TSTRING := 'label';           --      
  SRESP_ATTR_CHART_DS_BR_CLR  constant PKG_STD.TSTRING := 'borderColor';     --        
  SRESP_ATTR_CHART_DS_BG_CLR  constant PKG_STD.TSTRING := 'backgroundColor'; --        
  SRESP_ATTR_CHART_DS_DATA    constant PKG_STD.TSTRING := 'data';            --       
  SRESP_ATTR_CHART_DS_ITEMS   constant PKG_STD.TSTRING := 'items';           --      
  SRESP_ATTR_CHART_DS_I_VAL   constant PKG_STD.TSTRING := 'value';           --      
  
  /*  -    */
  SCOND_FROM_POSTFIX          constant PKG_STD.TSTRING := 'From'; --      
  SCOND_TO_POSTFIX            constant PKG_STD.TSTRING := 'To';   --      

  /*     */
  procedure UTL_ROWS_LIMITS_CALC
  (
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    NROW_FROM               out number, --   
    NROW_TO                 out number  --   
  )
  is
  begin
    if (COALESCE(NPAGE_SIZE, 0) <= 0)
    then
      NROW_FROM := 1;
      NROW_TO   := 1000000000;
    else
      NROW_FROM := COALESCE(NPAGE_NUMBER, 1) * NPAGE_SIZE - NPAGE_SIZE + 1;
      NROW_TO   := COALESCE(NPAGE_NUMBER, 1) * NPAGE_SIZE;
    end if;
  end UTL_ROWS_LIMITS_CALC;
  
  /*        */
  function UTL_COND_NAME_MAKE_FROM
  (
    SNAME                   in varchar2 --  
  ) return                  varchar2    -- 
  is
  begin
    return SNAME || SCOND_FROM_POSTFIX;
  end UTL_COND_NAME_MAKE_FROM;

  /*        */
  function UTL_COND_NAME_MAKE_TO
  (
    SNAME                   in varchar2 --  
  ) return                  varchar2    -- 
  is
  begin
    return SNAME || SCOND_TO_POSTFIX;
  end UTL_COND_NAME_MAKE_TO;
  
  /*   */
  function TCOL_VAL_MAKE
  (
    SVALUE                  in varchar2, --  ()
    NVALUE                  in number,   --  ()
    DVALUE                  in date      --  ()
  ) return                  TCOL_VAL     --  
  is
    RRES                    TCOL_VAL;    --   
  begin
    /*   */
    RRES.SVALUE := SVALUE;
    RRES.NVALUE := NVALUE;
    RRES.DVALUE := DVALUE;
    /*   */
    return RRES;
  end TCOL_VAL_MAKE;

  /*     */
  procedure TCOL_VALS_ADD
  (
    RCOL_VALS               in out nocopy TCOL_VALS, --  
    SVALUE                  in varchar2 := null,     --  ()
    NVALUE                  in number := null,       --  ()
    DVALUE                  in date := null,         --  ()
    BCLEAR                  in boolean := false      --    (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RCOL_VALS is null) or (BCLEAR)) then
      RCOL_VALS := TCOL_VALS();
    end if;
    /*   */
    RCOL_VALS.EXTEND();
    RCOL_VALS(RCOL_VALS.LAST) := TCOL_VAL_MAKE(SVALUE => SVALUE, NVALUE => NVALUE, DVALUE => DVALUE);
  end TCOL_VALS_ADD;
  
  /*    */
  function TCOL_DEF_MAKE
  (
    SNAME                   in varchar2,                   -- 
    SCAPTION                in varchar2,                   -- 
    SDATA_TYPE              in varchar2 := SDATA_TYPE_STR, --   (.  SDATA_TYPE_*)
    SCOND_FROM              in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_FROM)
    SCOND_TO                in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_TO)
    BVISIBLE                in boolean := true,            --  
    BORDER                  in boolean := false,           --  
    BFILTER                 in boolean := false,           --  
    RCOL_VALS               in TCOL_VALS := null,          --  
    SHINT                   in varchar2 := null,           --   
    SPARENT                 in varchar2 := null,           --   
    BEXPANDABLE             in boolean := false,           --  /  
    BEXPANDED               in boolean := true,            -- /  
    NWIDTH                  in number := null              --   (  )
  ) return                  TCOL_DEF                       --  
  is
    RRES                    TCOL_DEF;                      --   
  begin
    /*   */
    RRES.SNAME       := SNAME;
    RRES.SCAPTION    := SCAPTION;
    RRES.SDATA_TYPE  := COALESCE(SDATA_TYPE, SDATA_TYPE_STR);
    RRES.SCOND_FROM  := COALESCE(SCOND_FROM, UTL_COND_NAME_MAKE_FROM(SNAME => SNAME));
    RRES.SCOND_TO    := COALESCE(SCOND_TO, UTL_COND_NAME_MAKE_TO(SNAME => SNAME));
    RRES.BVISIBLE    := COALESCE(BVISIBLE, true);
    RRES.BORDER      := COALESCE(BORDER, false);
    RRES.BFILTER     := COALESCE(BFILTER, false);
    RRES.RCOL_VALS   := COALESCE(RCOL_VALS, TCOL_VALS());
    RRES.SHINT       := SHINT;
    RRES.SPARENT     := SPARENT;
    RRES.BEXPANDABLE := COALESCE(BEXPANDABLE, false);
    RRES.BEXPANDED   := COALESCE(BEXPANDED, true);
    RRES.NWIDTH      := NWIDTH;
    /*   */
    return RRES;
  end TCOL_DEF_MAKE;
  
  /*      */
  procedure TCOL_DEFS_ADD
  (
    RCOL_DEFS               in out nocopy TCOL_DEFS,       --   
    SNAME                   in varchar2,                   -- 
    SCAPTION                in varchar2,                   -- 
    SDATA_TYPE              in varchar2 := SDATA_TYPE_STR, --   (.  SDATA_TYPE_*)
    SCOND_FROM              in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_FROM)
    SCOND_TO                in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_TO)
    BVISIBLE                in boolean := true,            --  
    BORDER                  in boolean := false,           --  
    BFILTER                 in boolean := false,           --  
    RCOL_VALS               in TCOL_VALS := null,          --  
    SHINT                   in varchar2 := null,           --   
    SPARENT                 in varchar2 := null,           --   
    BEXPANDABLE             in boolean := false,           --  /  
    BEXPANDED               in boolean := true,            -- /  
    NWIDTH                  in number := null,             --   (  )
    BCLEAR                  in boolean := false            --    (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RCOL_DEFS is null) or (BCLEAR)) then
      RCOL_DEFS := TCOL_DEFS();
    end if;
    /*   */
    RCOL_DEFS.EXTEND();
    RCOL_DEFS(RCOL_DEFS.LAST) := TCOL_DEF_MAKE(SNAME       => SNAME,
                                               SCAPTION    => SCAPTION,
                                               SDATA_TYPE  => SDATA_TYPE,
                                               SCOND_FROM  => SCOND_FROM,
                                               SCOND_TO    => SCOND_TO,
                                               BVISIBLE    => BVISIBLE,
                                               BORDER      => BORDER,
                                               BFILTER     => BFILTER,
                                               RCOL_VALS   => RCOL_VALS,
                                               SHINT       => SHINT,
                                               SPARENT     => SPARENT,
                                               BEXPANDABLE => BEXPANDABLE,
                                               BEXPANDED   => BEXPANDED,
                                               NWIDTH      => NWIDTH);
  end TCOL_DEFS_ADD;
  
  /*      */
  function TCOL_DEFS_FIND
  (
    RCOL_DEFS               in TCOL_DEFS, --    
    SNAME                   in varchar2   -- 
  ) return                  TCOL_DEF      --   (null -   )
  is
  begin
    /*      */
    if ((RCOL_DEFS is not null) and (RCOL_DEFS.COUNT > 0)) then
      for I in RCOL_DEFS.FIRST .. RCOL_DEFS.LAST
      loop
        if (RCOL_DEFS(I).SNAME = SNAME) then
          return RCOL_DEFS(I);
        end if;
      end loop;
    end if;
    /*    */
    return null;
  end TCOL_DEFS_FIND;
  
  /*      */
  procedure TCOL_DEFS_TO_XML
  (
    RCOL_DEFS               in TCOL_DEFS --    
  )
  is    
  begin
    /*     */
    if ((RCOL_DEFS is not null) and (RCOL_DEFS.COUNT > 0)) then
      for I in RCOL_DEFS.FIRST .. RCOL_DEFS.LAST
      loop
        /*    */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XCOLUMNS_DEF);
        /*   */
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_NAME, SVALUE => RCOL_DEFS(I).SNAME);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CAPTION, SVALUE => RCOL_DEFS(I).SCAPTION);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_DATA_TYPE, SVALUE => RCOL_DEFS(I).SDATA_TYPE);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_VISIBLE, BVALUE => RCOL_DEFS(I).BVISIBLE);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_DT_ORDER, BVALUE => RCOL_DEFS(I).BORDER);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_DT_FILTER, BVALUE => RCOL_DEFS(I).BFILTER);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_HINT, SVALUE => RCOL_DEFS(I).SHINT);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_PARENT, SVALUE => RCOL_DEFS(I).SPARENT);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_EXPANDABLE, BVALUE => RCOL_DEFS(I).BEXPANDABLE);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_EXPANDED, BVALUE => RCOL_DEFS(I).BEXPANDED);
        if (RCOL_DEFS(I).NWIDTH is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_WIDTH, NVALUE => RCOL_DEFS(I).NWIDTH);
        end if;
        /*   */
        if (RCOL_DEFS(I).RCOL_VALS is not null) and (RCOL_DEFS(I).RCOL_VALS.COUNT > 0) then
          for V in RCOL_DEFS(I).RCOL_VALS.FIRST .. RCOL_DEFS(I).RCOL_VALS.LAST
          loop
            /*     */
            PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_DT_COLUMN_VALUES);
            /*  */
            case RCOL_DEFS(I).SDATA_TYPE
              when SDATA_TYPE_STR then
                PKG_XFAST.VALUE(SVALUE => RCOL_DEFS(I).RCOL_VALS(V).SVALUE);
              when SDATA_TYPE_NUMB then
                PKG_XFAST.VALUE(NVALUE => RCOL_DEFS(I).RCOL_VALS(V).NVALUE);
              when SDATA_TYPE_DATE then
                PKG_XFAST.VALUE(DVALUE => RCOL_DEFS(I).RCOL_VALS(V).DVALUE);
              else
                P_EXCEPTION(0,
                            '  "%s"       ("%s").',
                            COALESCE(RCOL_DEFS(I).SNAME, '< >'),
                            COALESCE(RCOL_DEFS(I).SDATA_TYPE, '< ˨>'));
            end case;
            /*     */
            PKG_XFAST.UP();
          end loop;
        end if;
        /*    */
        PKG_XFAST.UP();
      end loop;
    end if;
  end TCOL_DEFS_TO_XML;
  
  /*   */
  function TCOL_MAKE
  (
    SNAME                   in varchar2,         --  
    SVALUE                  in varchar2 := null, --  ()
    NVALUE                  in number := null,   --  ()
    DVALUE                  in date := null      --  ()
  ) return                  TCOL                 --  
  is
    RRES                    TCOL;                --   
  begin
    /*   */
    RRES.SNAME    := SNAME;
    RRES.RCOL_VAL := TCOL_VAL_MAKE(SVALUE => SVALUE, NVALUE => NVALUE, DVALUE => DVALUE);
    /*   */
    return RRES;
  end TCOL_MAKE;
  
  /*     */
  procedure TCOLS_ADD
  (
    RCOLS                   in out nocopy TCOLS, --  
    SNAME                   in varchar2,         --  
    SVALUE                  in varchar2 := null, --  ()
    NVALUE                  in number := null,   --  ()
    DVALUE                  in date := null,     --  ()
    BCLEAR                  in boolean := false  --    (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RCOLS is null) or (BCLEAR)) then
      RCOLS := TCOLS();
    end if;
    /*   */
    RCOLS.EXTEND();
    RCOLS(RCOLS.LAST) := TCOL_MAKE(SNAME => SNAME, SVALUE => SVALUE, NVALUE => NVALUE, DVALUE => DVALUE);
  end TCOLS_ADD;
  
  /*    */
  function TGROUP_MAKE
  (
    SNAME                   in varchar2,        -- 
    SCAPTION                in varchar2,        -- 
    BEXPANDABLE             in boolean := true, --  / 
    BEXPANDED               in boolean := true  -- / 
  ) return                  TGROUP              --  
  is
    RRES                    TGROUP;             --   
  begin
    /*   */
    RRES.SNAME       := SNAME;
    RRES.SCAPTION    := SCAPTION;
    RRES.BEXPANDABLE := COALESCE(BEXPANDABLE, true);
    RRES.BEXPANDED   := COALESCE(BEXPANDED, true);
    /*   */
    return RRES;
  end TGROUP_MAKE;
  
  /*      */
  procedure TGROUPS_ADD
  (
    RGROUPS                 in out nocopy TGROUPS, --   
    SNAME                   in varchar2,           -- 
    SCAPTION                in varchar2,           -- 
    BEXPANDABLE             in boolean := false,   --  / 
    BEXPANDED               in boolean := true,    -- / 
    BCLEAR                  in boolean := false    --    (false -  , true -    )
  )
  is
    BFND                    boolean := false;      --     
  begin
    /*     */
    if ((RGROUPS is null) or (BCLEAR)) then
      RGROUPS := TGROUPS();
    end if;
    /*   */
    if (RGROUPS.COUNT > 0) then
      for I in RGROUPS.FIRST .. RGROUPS.LAST
      loop
        if (RGROUPS(I).SNAME = SNAME) then
          /*   -  */
          BFND := true;
          RGROUPS(I) := TGROUP_MAKE(SNAME       => SNAME,
                                    SCAPTION    => SCAPTION,
                                    BEXPANDABLE => BEXPANDABLE,
                                    BEXPANDED   => BEXPANDED);
          exit;
        end if;
      end loop;
    end if;
    /*      */
    if (not BFND) then
      RGROUPS.EXTEND();
      RGROUPS(RGROUPS.LAST) := TGROUP_MAKE(SNAME       => SNAME,
                                           SCAPTION    => SCAPTION,
                                           BEXPANDABLE => BEXPANDABLE,
                                           BEXPANDED   => BEXPANDED);
    end if;
  end TGROUPS_ADD;
  
  /*      */
  procedure TGROUPS_TO_XML
  (
    RGROUPS                 in TGROUPS  --    
  )
  is    
  begin
    /*     */
    if ((RGROUPS is not null) and (RGROUPS.COUNT > 0)) then
      for I in RGROUPS.FIRST .. RGROUPS.LAST
      loop
        /*    */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XGROUPS);
        /*   */
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_NAME, SVALUE => RGROUPS(I).SNAME);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CAPTION, SVALUE => RGROUPS(I).SCAPTION);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_EXPANDABLE, BVALUE => RGROUPS(I).BEXPANDABLE);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_EXPANDED, BVALUE => RGROUPS(I).BEXPANDED);
        /*    */
        PKG_XFAST.UP();
      end loop;
    end if;
  end TGROUPS_TO_XML;
  
  /*   */
  function TROW_MAKE
  (
    SGROUP                  in varchar2 := null --  
  )
  return                    TROW                --  
  is
    RRES                    TROW;               --   
  begin
    /*   */
    RRES.SGROUP := SGROUP;
    RRES.RCOLS  := TCOLS();
    /*   */
    return RRES;
  end TROW_MAKE;
  
  /*     */
  procedure TROW_ADD_COL
  (
    RROW                    in out nocopy TROW,  -- 
    SNAME                   in varchar2,         --  
    SVALUE                  in varchar2 := null, --  ()
    NVALUE                  in number := null,   --  ()
    DVALUE                  in date := null,     --  ()
    BCLEAR                  in boolean := false  --    (false -  , true -    )
  )
  is
  begin
    /*          */
    TCOLS_ADD(RCOLS => RROW.RCOLS, SNAME => SNAME, SVALUE => SVALUE, NVALUE => NVALUE, DVALUE => DVALUE, BCLEAR => BCLEAR);
  end TROW_ADD_COL;
  
  /*          */
  procedure TROW_ADD_CUR_COLS
  (
    RROW                    in out nocopy TROW, -- 
    SNAME                   in varchar2,        --  
    ICURSOR                 in integer,         -- 
    NPOSITION               in number,          --    
    BCLEAR                  in boolean := false --    (false -  , true -    )
  )
  is
    SVALUE                  PKG_STD.TLSTRING;   --    
  begin
    /*     */
    PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR, IPOSITION => NPOSITION, SVALUE => SVALUE);
    /*          */
    TCOLS_ADD(RCOLS => RROW.RCOLS, SNAME => SNAME, SVALUE => SVALUE, NVALUE => null, DVALUE => null, BCLEAR => BCLEAR);
  end TROW_ADD_CUR_COLS;

  /*          */
  procedure TROW_ADD_CUR_COLN
  (
    RROW                    in out nocopy TROW, -- 
    SNAME                   in varchar2,        --  
    ICURSOR                 in integer,         -- 
    NPOSITION               in number,          --    
    BCLEAR                  in boolean := false --    (false -  , true -    )
  )
  is
    NVALUE                  PKG_STD.TLNUMBER;   --    
  begin
    /*     */
    PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => NPOSITION, NVALUE => NVALUE);
    /*          */
    TCOLS_ADD(RCOLS => RROW.RCOLS, SNAME => SNAME, SVALUE => null, NVALUE => NVALUE, DVALUE => null, BCLEAR => BCLEAR);
  end TROW_ADD_CUR_COLN;
  
  /*    ""       */
  procedure TROW_ADD_CUR_COLD
  (
    RROW                    in out nocopy TROW, -- 
    SNAME                   in varchar2,        --  
    ICURSOR                 in integer,         -- 
    NPOSITION               in number,          --    
    BCLEAR                  in boolean := false --    (false -  , true -    )
  )
  is
    DVALUE                  PKG_STD.TLDATE;     --    
  begin
    /*     */
    PKG_SQL_DML.COLUMN_VALUE_DATE(ICURSOR => ICURSOR, IPOSITION => NPOSITION, DVALUE => DVALUE);
    /*          */
    TCOLS_ADD(RCOLS => RROW.RCOLS, SNAME => SNAME, SVALUE => null, NVALUE => null, DVALUE => DVALUE, BCLEAR => BCLEAR);
  end TROW_ADD_CUR_COLD;
  
  /*      */
  procedure TROWS_TO_XML
  (
    RCOL_DEFS               in TCOL_DEFS, --    
    RROWS                   in TROWS      --   
  )
  is  
    RCOL_DEF                TCOL_DEF;     --    
  begin
    /*     */
    if ((RROWS is not null) and (RROWS.COUNT > 0)) then
      for I in RROWS.FIRST .. RROWS.LAST
      loop
        /*   */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XROWS);
        /*    -   */
        if (RROWS(I).SGROUP is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_GROUP_NAME, SVALUE => RROWS(I).SGROUP);
        end if;
        /*    */
        if ((RROWS(I).RCOLS is not null) and (RROWS(I).RCOLS.COUNT > 0)) then
          for J in RROWS(I).RCOLS.FIRST .. RROWS(I).RCOLS.LAST
          loop
            /*    */
            RCOL_DEF := TCOL_DEFS_FIND(RCOL_DEFS => RCOL_DEFS, SNAME => RROWS(I).RCOLS(J).SNAME);
            if (RCOL_DEF.SNAME is null) then
              P_EXCEPTION(0,
                          '  "%s"    .',
                          RROWS(I).RCOLS(J).SNAME);
            end if;
            /*       */
            case RCOL_DEF.SDATA_TYPE
              when SDATA_TYPE_STR then
                PKG_XFAST.ATTR(SNAME => RROWS(I).RCOLS(J).SNAME, SVALUE => RROWS(I).RCOLS(J).RCOL_VAL.SVALUE);
              when SDATA_TYPE_NUMB then
                PKG_XFAST.ATTR(SNAME => RROWS(I).RCOLS(J).SNAME, NVALUE => RROWS(I).RCOLS(J).RCOL_VAL.NVALUE);
              when SDATA_TYPE_DATE then
                PKG_XFAST.ATTR(SNAME => RROWS(I).RCOLS(J).SNAME, DVALUE => RROWS(I).RCOLS(J).RCOL_VAL.DVALUE);
              else
                P_EXCEPTION(0,
                            '  "%s"       ("%s").',
                            RCOL_DEFS(I).SNAME,
                            COALESCE(RCOL_DEFS(I).SDATA_TYPE, '< ˨>'));
            end case;
          end loop;
        end if;
        /*   */
        PKG_XFAST.UP();
      end loop;
    end if;
  end TROWS_TO_XML;
  
  /*    */
  function TDATA_GRID_MAKE
  (
    BFIXED_HEADER           in boolean := false, --  
    NFIXED_COLUMNS          in number := 0       --   
  ) return                  TDATA_GRID           --  
  is
    RRES                    TDATA_GRID;          --   
  begin
    /*   */
    RRES.BFIXED_HEADER  := COALESCE(BFIXED_HEADER, false);
    RRES.NFIXED_COLUMNS := COALESCE(NFIXED_COLUMNS, 0);
    RRES.RCOL_DEFS      := TCOL_DEFS();
    RRES.RGROUPS        := TGROUPS();
    RRES.RROWS          := TROWS();
    /*   */
    return RRES;
  end TDATA_GRID_MAKE;
  
  /*         */
  function TDATA_GRID_FIND_COL_DEF
  (
    RDATA_GRID              in TDATA_GRID, --   
    SNAME                   in varchar2    --  
  ) return                  TCOL_DEF       --   (null -   )
  is
  begin
    return TCOL_DEFS_FIND(RCOL_DEFS => RDATA_GRID.RCOL_DEFS, SNAME => SNAME);
  end TDATA_GRID_FIND_COL_DEF;
  
  /*       */
  procedure TDATA_GRID_ADD_COL_DEF
  (
    RDATA_GRID              in out nocopy TDATA_GRID,      --   
    SNAME                   in varchar2,                   --  
    SCAPTION                in varchar2,                   --  
    SDATA_TYPE              in varchar2 := SDATA_TYPE_STR, --    (.  SDATA_TYPE_*)
    SCOND_FROM              in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_FROM)
    SCOND_TO                in varchar2 := null,           --      (null -  UTL_COND_NAME_MAKE_TO)
    BVISIBLE                in boolean := true,            --  
    BORDER                  in boolean := false,           --    
    BFILTER                 in boolean := false,           --    
    RCOL_VALS               in TCOL_VALS := null,          --   
    SHINT                   in varchar2 := null,           --   
    SPARENT                 in varchar2 := null,           --   
    BEXPANDABLE             in boolean := false,           --  /  
    BEXPANDED               in boolean := true,            -- /  
    NWIDTH                  in number := null,             --   (  )    
    BCLEAR                  in boolean := false            --        (false -  , true -    )
  )
  is
  begin
    /*         */
    TCOL_DEFS_ADD(RCOL_DEFS   => RDATA_GRID.RCOL_DEFS,
                  SNAME       => SNAME,
                  SCAPTION    => SCAPTION,
                  SDATA_TYPE  => SDATA_TYPE,
                  SCOND_FROM  => SCOND_FROM,
                  SCOND_TO    => SCOND_TO,
                  BVISIBLE    => BVISIBLE,
                  BORDER      => BORDER,
                  BFILTER     => BFILTER,
                  RCOL_VALS   => RCOL_VALS,
                  SHINT       => SHINT,
                  SPARENT     => SPARENT,
                  BEXPANDABLE => BEXPANDABLE,
                  BEXPANDED   => BEXPANDED,
                  NWIDTH      => NWIDTH,
                  BCLEAR      => BCLEAR);
  end TDATA_GRID_ADD_COL_DEF;
  
  /*       */
  procedure TDATA_GRID_ADD_GROUP
  (
    RDATA_GRID              in out nocopy TDATA_GRID, --   
    SNAME                   in varchar2,              --  
    SCAPTION                in varchar2,              --  
    BEXPANDABLE             in boolean := false,      --  / 
    BEXPANDED               in boolean := true,       -- / 
    BCLEAR                  in boolean := false       --        (false -  , true -    )
  )
  is
  begin
    /*         */
    TGROUPS_ADD(RGROUPS     => RDATA_GRID.RGROUPS,
                SNAME       => SNAME,
                SCAPTION    => SCAPTION,
                BEXPANDABLE => BEXPANDABLE,
                BEXPANDED   => BEXPANDED,
                BCLEAR      => BCLEAR);
  end TDATA_GRID_ADD_GROUP;
  
  /*       */
  procedure TDATA_GRID_ADD_ROW
  (
    RDATA_GRID              in out nocopy TDATA_GRID, --   
    RROW                    in TROW,                  -- 
    BCLEAR                  in boolean := false       --       (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RDATA_GRID.RROWS is null) or (BCLEAR)) then
      RDATA_GRID.RROWS := TROWS();
    end if;
    /*   */
    RDATA_GRID.RROWS.EXTEND();
    RDATA_GRID.RROWS(RDATA_GRID.RROWS.LAST) := RROW;
  end TDATA_GRID_ADD_ROW;
  
  /*     */
  procedure TDATA_GRID_DEF_TO_XML
  (
    RDATA_GRID                  in TDATA_GRID   --   
  )
  is    
  begin
    /* C   */
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_FIXED_HEADER, BVALUE => RDATA_GRID.BFIXED_HEADER);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_FIXED_COLUMNS, NVALUE => RDATA_GRID.NFIXED_COLUMNS);
  end TDATA_GRID_DEF_TO_XML;
  
  /*    */
  function TDATA_GRID_TO_XML
  (
    RDATA_GRID              in TDATA_GRID, --   
    NINCLUDE_DEF            in number := 1 --    (0 - , 1 - )
  ) return                  clob           -- XML-
  is
    CRES                    clob;          --   
  begin
    /*   XML */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    /*   */
    PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XDATA);
    /*    */
    PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XDATA_GRID);
    /*     */
    TDATA_GRID_DEF_TO_XML(RDATA_GRID => RDATA_GRID);
    /*    */
    PKG_XFAST.UP();
    /*      */
    if (NINCLUDE_DEF = 1) then
      TCOL_DEFS_TO_XML(RCOL_DEFS => RDATA_GRID.RCOL_DEFS);
    end if;
    /*    */
    TGROUPS_TO_XML(RGROUPS => RDATA_GRID.RGROUPS);
    /*    */
    TROWS_TO_XML(RCOL_DEFS => RDATA_GRID.RCOL_DEFS, RROWS => RDATA_GRID.RROWS);
    /*   */
    PKG_XFAST.UP();
    /*  */
    CRES := PKG_XFAST.SERIALIZE_TO_CLOB();
    /*   XML */
    PKG_XFAST.EPILOGUE();
    /*   */
    return CRES;
  exception
    when others then
      /*   XML */
      PKG_XFAST.EPILOGUE();
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end TDATA_GRID_TO_XML;
  
  /*      */
  procedure TFILTER_TO_NUMBER
  (
    RFILTER                 in TFILTER, -- 
    NFROM                   out number, --    
    NTO                     out number  --    
  )
  is
  begin
    /*    */
    if (RFILTER.SFROM is not null) then
      begin
        NFROM := PKG_P8PANELS_BASE.UTL_S2N(SVALUE => RFILTER.SFROM);
      exception
        when others then
          P_EXCEPTION(0,
                      '   (%s)      .',
                      RFILTER.SFROM);
      end;
    end if;
    /*    */    
    if (RFILTER.STO is not null) then
      begin
        NTO := PKG_P8PANELS_BASE.UTL_S2N(SVALUE => RFILTER.STO);
      exception
        when others then
          P_EXCEPTION(0,
                      '   (%s)      .',
                      RFILTER.STO);
      end;
    end if;
  end TFILTER_TO_NUMBER;
  
  /*      */
  procedure TFILTER_TO_DATE
  (
    RFILTER                 in TFILTER, -- 
    DFROM                   out date,   --    
    DTO                     out date    --    
  )
  is
  begin
    /*    */
    if (RFILTER.SFROM is not null) then
      begin
        DFROM := PKG_P8PANELS_BASE.UTL_S2D(SVALUE => RFILTER.SFROM);
      exception
        when others then
          P_EXCEPTION(0,
                      '   (%s)      .',
                      RFILTER.SFROM);
      end;
    end if;
    /*    */
    if (RFILTER.STO is not null) then
      begin
        DTO := PKG_P8PANELS_BASE.UTL_S2D(SVALUE => RFILTER.STO);
      exception
        when others then
          P_EXCEPTION(0,
                      '   (%s)      .',
                      RFILTER.STO);
      end;
    end if;
  end TFILTER_TO_DATE;

  /*   */
  function TFILTER_MAKE
  (
    SNAME                   in varchar2, -- 
    SFROM                   in varchar2, --  ""
    STO                     in varchar2  --  ""
  ) return                  TFILTER      --  
  is
    RRES                    TFILTER;    --   
  begin
    /*   */
    RRES.SNAME := SNAME;
    RRES.SFROM := SFROM;
    RRES.STO   := STO;
    /*   */
    return RRES;
  end TFILTER_MAKE;
  
  /*     */
  function TFILTERS_FIND
  (
    RFILTERS                in TFILTERS, --  
    SNAME                   in varchar2  -- 
  ) return                  TFILTER      --   (null -   )
  is
  begin
    /*     */
    if ((RFILTERS is not null) and (RFILTERS.COUNT > 0)) then
      for I in RFILTERS.FIRST .. RFILTERS.LAST
      loop
        if (RFILTERS(I).SNAME = SNAME) then
          return RFILTERS(I);
        end if;
      end loop;
    end if;
    /*    */
    return null;
  end TFILTERS_FIND;
  
  /*   */
  function TFILTERS_FROM_XML
  (
    CFILTERS                in clob              --    (BASE64(<filters><name></name><from></from><to></to></filters>...))
  ) return                  TFILTERS             --  
  is
    RFILTERS                TFILTERS;            --    
    XDOC                    PKG_XPATH.TDOCUMENT; --  XML
    XROOT                   PKG_XPATH.TNODE;     --   XML
    XNODE                   PKG_XPATH.TNODE;     --   
    XNODES                  PKG_XPATH.TNODES;    --    
  begin
    /*    */
    RFILTERS := TFILTERS();
    /*  XML */
    XDOC := PKG_XPATH.PARSE_FROM_CLOB(LCXML => '<' || SRQ_TAG_XROOT || '>' ||
                                               BLOB2CLOB(LBDATA   => BASE64_DECODE(LCSRCE => CFILTERS),
                                                         SCHARSET => PKG_CHARSET.CHARSET_UTF_()) || '</' ||
                                               SRQ_TAG_XROOT || '>');
    /*    */
    XROOT := PKG_XPATH.ROOT_NODE(RDOCUMENT => XDOC);
    /*    */
    XNODES := PKG_XPATH.LIST_NODES(RPARENT_NODE => XROOT, SPATTERN => '/' || SRQ_TAG_XROOT || '/' || SRQ_TAG_XFILTERS);
    /*     */
    for I in 1 .. PKG_XPATH.COUNT_NODES(RNODES => XNODES)
    loop
      /*      */
      XNODE := PKG_XPATH.ITEM_NODE(RNODES => XNODES, INUMBER => I);
      /*     */
      RFILTERS.EXTEND();
      RFILTERS(RFILTERS.LAST) := TFILTER_MAKE(SNAME => PKG_XPATH.VALUE(RNODE => XNODE, SPATTERN => SRQ_TAG_SNAME),
                                              SFROM => PKG_XPATH.VALUE(RNODE => XNODE, SPATTERN => SRQ_TAG_SFROM),
                                              STO   => PKG_XPATH.VALUE(RNODE => XNODE, SPATTERN => SRQ_TAG_STO));
    end loop;
    /*   */
    PKG_XPATH.FREE(RDOCUMENT => XDOC);
    /*   */
    return RFILTERS;
  exception
    when others then
      /*   */
      PKG_XPATH.FREE(RDOCUMENT => XDOC);
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end TFILTERS_FROM_XML;
  
  /*      */
  procedure TFILTERS_SET_QUERY
  (
    NIDENT                  in number,         --  
    NCOMPANY                in number,         -- .  
    NPARENT                 in number := null, -- .  
    SUNIT                   in varchar2,       --  
    SPROCEDURE              in varchar2,       --    
    RDATA_GRID              in TDATA_GRID,     --   
    RFILTERS                in TFILTERS        --  
  )
  is
    RCOL_DEF                TCOL_DEF;          --    
    BENUM                   boolean;           --    
    NFROM                   PKG_STD.TLNUMBER;  --       
    NTO                     PKG_STD.TLNUMBER;  --       
    DFROM                   PKG_STD.TLDATE;    --       
    DTO                     PKG_STD.TLDATE;    --       
  begin
    /*    -  */
    PKG_COND_BROKER.PROLOGUE(IMODE => PKG_COND_BROKER.MODE_SMART_, NIDENT => NIDENT);
    /*    -     */
    PKG_COND_BROKER.SET_PROCEDURE(SPROCEDURE_NAME => SPROCEDURE);
    /*    -   */
    PKG_COND_BROKER.SET_UNIT(SUNITCODE => SUNIT);
    /*    -   */
    PKG_COND_BROKER.SET_COMPANY(NCOMPANY => NCOMPANY);
    /*    -   */
    if (NPARENT is not null) then
      PKG_COND_BROKER.SET_PARENT(NPARENT => NPARENT);
    end if;
    /*  ,   */
    if ((RFILTERS is not null) and (RFILTERS.COUNT > 0)) then
      for I in RFILTERS.FIRST .. RFILTERS.LAST
      loop
        /*      */
        RCOL_DEF := TCOL_DEFS_FIND(RCOL_DEFS => RDATA_GRID.RCOL_DEFS, SNAME => RFILTERS(I).SNAME);
        if (RCOL_DEF.SNAME is not null) then
          /*      */
          if ((RCOL_DEF.RCOL_VALS is not null) and (RCOL_DEF.RCOL_VALS.COUNT > 0)) then
            BENUM := true;
          else
            BENUM := false;
          end if;
          /*         */
          case RCOL_DEF.SDATA_TYPE
            when SDATA_TYPE_STR then
              begin
                if (BENUM) then
                  PKG_COND_BROKER.SET_CONDITION_ESTR(SCONDITION_NAME   => RCOL_DEF.SCOND_FROM,
                                                     SCONDITION_ESTR   => RFILTERS(I).SFROM,
                                                     ICASE_INSENSITIVE => 1);
                else
                  PKG_COND_BROKER.SET_CONDITION_STR(SCONDITION_NAME   => RCOL_DEF.SCOND_FROM,
                                                    SCONDITION_VALUE  => RFILTERS(I).SFROM,
                                                    ICASE_INSENSITIVE => 1);
                end if;
              end;
            when SDATA_TYPE_NUMB then
              begin
                if (BENUM) then
                  PKG_COND_BROKER.SET_CONDITION_ENUM(SCONDITION_NAME => RCOL_DEF.SCOND_FROM,
                                                     SCONDITION_ENUM => RFILTERS(I).SFROM);
                else
                  TFILTER_TO_NUMBER(RFILTER => RFILTERS(I), NFROM => NFROM, NTO => NTO);
                  if (NFROM is not null) then
                    PKG_COND_BROKER.SET_CONDITION_NUM(SCONDITION_NAME  => RCOL_DEF.SCOND_FROM,
                                                      NCONDITION_VALUE => NFROM);
                  end if;
                  if (NTO is not null) then
                    PKG_COND_BROKER.SET_CONDITION_NUM(SCONDITION_NAME => RCOL_DEF.SCOND_TO, NCONDITION_VALUE => NTO);
                  end if;
                end if;
              end;
            when SDATA_TYPE_DATE then
              begin
                if (BENUM) then                  
                  PKG_COND_BROKER.SET_CONDITION_EDATE(SCONDITION_NAME => RCOL_DEF.SCOND_FROM,
                                                      SCONDITION_EDATE => RFILTERS(I).SFROM);
                else
                  TFILTER_TO_DATE(RFILTER => RFILTERS(I), DFROM => DFROM, DTO => DTO);
                  if (DFROM is not null) then
                    PKG_COND_BROKER.SET_CONDITION_DATE(SCONDITION_NAME  => RCOL_DEF.SCOND_FROM,
                                                       DCONDITION_VALUE => DFROM);
                  end if;
                  if (DTO is not null) then
                    PKG_COND_BROKER.SET_CONDITION_DATE(SCONDITION_NAME => RCOL_DEF.SCOND_TO, DCONDITION_VALUE => DTO);
                  end if;
                end if;
              end;
            else
              P_EXCEPTION(0,
                          '  "%s"       ("%s").',
                          RCOL_DEF.SNAME,
                          COALESCE(RCOL_DEF.SDATA_TYPE, '< ˨>'));
          end case;
        end if;
      end loop;
    end if;
    /*    -  */
    PKG_COND_BROKER.EPILOGUE();
  end TFILTERS_SET_QUERY;
  
  /*   */
  function TORDER_MAKE
  (
    SNAME                   in varchar2, -- 
    SDIRECTION              in varchar2  --  (.  SORDER_DIRECTION_*)
  ) return                  TORDER       --  
  is
    RRES                    TORDER;      --   
  begin
    /*   */
    RRES.SNAME      := SNAME;
    RRES.SDIRECTION := SDIRECTION;
    /*   */
    return RRES;
  end TORDER_MAKE;
  
  /*   */
  function TORDERS_FROM_XML
  (
    CORDERS                 in clob              --    (BASE64(<orders><name></name><direction>ASC/DESC</direction></orders>...))
  ) return                  TORDERS              --  
  is
    RORDERS                 TORDERS;             --    
    XDOC                    PKG_XPATH.TDOCUMENT; --  XML
    XROOT                   PKG_XPATH.TNODE;     --   XML
    XNODE                   PKG_XPATH.TNODE;     --   
    XNODES                  PKG_XPATH.TNODES;    --    
  begin
    /*    */
    RORDERS := TORDERS();
    /*  XML */
    XDOC := PKG_XPATH.PARSE_FROM_CLOB(LCXML => '<' || SRQ_TAG_XROOT || '>' ||
                                               BLOB2CLOB(LBDATA   => BASE64_DECODE(LCSRCE => CORDERS),
                                                         SCHARSET => PKG_CHARSET.CHARSET_UTF_()) || '</' ||
                                               SRQ_TAG_XROOT || '>');
    /*    */
    XROOT := PKG_XPATH.ROOT_NODE(RDOCUMENT => XDOC);
    /*    */
    XNODES := PKG_XPATH.LIST_NODES(RPARENT_NODE => XROOT, SPATTERN => '/' || SRQ_TAG_XROOT || '/' || SRQ_TAG_XORDERS);
    /*     */
    for I in 1 .. PKG_XPATH.COUNT_NODES(RNODES => XNODES)
    loop
      /*      */
      XNODE := PKG_XPATH.ITEM_NODE(RNODES => XNODES, INUMBER => I);
      /*     */
      RORDERS.EXTEND();
      RORDERS(RORDERS.LAST) := TORDER_MAKE(SNAME      => PKG_XPATH.VALUE(RNODE => XNODE, SPATTERN => SRQ_TAG_SNAME),
                                           SDIRECTION => PKG_XPATH.VALUE(RNODE => XNODE, SPATTERN => SRQ_TAG_SDIRECTION));
    end loop;
    /*   */
    PKG_XPATH.FREE(RDOCUMENT => XDOC);
    /*   */
    return RORDERS;
  exception
    when others then
      /*   */
      PKG_XPATH.FREE(RDOCUMENT => XDOC);
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end TORDERS_FROM_XML;
  
  /*      */
  procedure TORDERS_SET_QUERY
  (
    RDATA_GRID              in TDATA_GRID,      --  
    RORDERS                 in TORDERS,         --  
    SPATTERN                in varchar2,        --           
    CSQL                    in out nocopy clob  --  
  )
  is
    CSQL_ORDERS             clob;               --      
  begin
    /*    */
    if ((RORDERS is not null) and (RORDERS.COUNT > 0)) then
      CSQL_ORDERS := ' order by ';
      for I in RORDERS.FIRST .. RORDERS.LAST
      loop
        /*     -  ,   SQL- */
        if ((TCOL_DEFS_FIND(RCOL_DEFS => RDATA_GRID.RCOL_DEFS, SNAME => RORDERS(I).SNAME).SNAME is not null) and
           (RORDERS(I).SDIRECTION in (SORDER_DIRECTION_ASC, SORDER_DIRECTION_DESC))) then
          CSQL_ORDERS := CSQL_ORDERS || RORDERS(I).SNAME || ' ' || RORDERS(I).SDIRECTION;
          if (I < RORDERS.LAST) then
            CSQL_ORDERS := CSQL_ORDERS || ', ';
          end if;
        end if;
      end loop;
    end if;
    CSQL := replace(CSQL, SPATTERN, CSQL_ORDERS);
  end TORDERS_SET_QUERY;
  
  /*         */
  procedure TGANTT_TASK_ATTR_NAME_CHECK
  (
    SNAME                   in varchar2 -- 
  )
  is
  begin
    if (SNAME in (SRESP_ATTR_ID,
                  SRESP_ATTR_RN,
                  SRESP_ATTR_NUMB,
                  SRESP_ATTR_CAPTION,
                  SRESP_ATTR_FULL_NAME,
                  SRESP_ATTR_START,
                  SRESP_ATTR_END,
                  SRESP_ATTR_TASK_PROGRESS,
                  SRESP_ATTR_TASK_BG_COLOR,
                  SRESP_ATTR_TASK_TEXT_COLOR,                  
                  SRESP_ATTR_TASK_RO,
                  SRESP_ATTR_TASK_RO_PRGRS,
                  SRESP_ATTR_TASK_RO_DATES,
                  SRESP_ATTR_TASK_DEPS)) then
      P_EXCEPTION(0,
                  '  "%s"  .',
                  SNAME);
    end if;
  end TGANTT_TASK_ATTR_NAME_CHECK;
  
  /*        */
  function TGANTT_TASK_ATTR_FIND
  (
    RTASK_ATTRS             in TGANTT_TASK_ATTRS, --     
    SNAME                   in varchar2           -- 
  ) return                  TGANTT_TASK_ATTR      --   (null -   )
  is
  begin
    /*     */
    if ((RTASK_ATTRS is not null) and (RTASK_ATTRS.COUNT > 0)) then
      for I in RTASK_ATTRS.FIRST .. RTASK_ATTRS.LAST
      loop
        if (RTASK_ATTRS(I).SNAME = SNAME) then
          return RTASK_ATTRS(I);
        end if;
      end loop;
    end if;
    /*    */
    return null;
  end TGANTT_TASK_ATTR_FIND;
  
  /*        */
  function TGANTT_TASK_COLOR_FIND
  (
    RTASK_COLORS            in TGANTT_TASK_COLORS, --     
    SBG_COLOR               in varchar2 := null,   --    ( - HTML-, #RRGGBBAA)
    STEXT_COLOR             in varchar2 := null,   --     ( - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      in varchar2 := null    --    ( - HTML-, #RRGGBBAA)
  ) return                  TGANTT_TASK_COLOR      --    (null -   )
  is
  begin
    /*     */
    if ((RTASK_COLORS is not null) and (RTASK_COLORS.COUNT > 0)) then
      for I in RTASK_COLORS.FIRST .. RTASK_COLORS.LAST
      loop
        if ((CMP_VC2(V1 => RTASK_COLORS(I).SBG_COLOR, V2 => SBG_COLOR) = 1) and
           (CMP_VC2(V1 => RTASK_COLORS(I).STEXT_COLOR, V2 => STEXT_COLOR) = 1) and
           (CMP_VC2(V1 => RTASK_COLORS(I).SBG_PROGRESS_COLOR, V2 => SBG_PROGRESS_COLOR) = 1)) 
            then
          return RTASK_COLORS(I);
        end if;
      end loop;
    end if;
    /*    */
    return null;
  end TGANTT_TASK_COLOR_FIND;
  
  /*      */
  function TGANTT_TASK_MAKE
  (
    NRN                     in number,           -- . 
    SNUMB                   in varchar2,         -- 
    SCAPTION                in varchar2,         -- 
    SNAME                   in varchar2,         -- 
    DSTART                  in date,             --  
    DEND                    in date,             --  
    NPROGRESS               in number := null,   --  (% )  (null -  )
    SBG_COLOR               in varchar2 := null, --    (null -      ,  - HTML-, #RRGGBBAA)
    STEXT_COLOR             in varchar2 := null, --     (null -      ,  - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      in varchar2 := null, --    (null -      ,  - HTML-, #RRGGBBAA)
    BREAD_ONLY              in boolean := null,  --        (null -     )
    BREAD_ONLY_DATES        in boolean := null,  --      (null -     )
    BREAD_ONLY_PROGRESS     in boolean := null   --      (null -     )
  ) return                  TGANTT_TASK          --  
  is
    RRES                    TGANTT_TASK;         --   
  begin
    /*   */
    if ((NRN is null) or (SNUMB is null) or (SCAPTION is null) or (SNAME is null) or (DSTART is null) or (DEND is null)) then
      P_EXCEPTION(0,
                  ' , , , ,            .');
    end if;
    if ((NPROGRESS is not null) and (not (NPROGRESS between 0 and 100))) then
      P_EXCEPTION(0, '      0  100');
    end if;
    /*   */
    RRES.NRN                 := NRN;
    RRES.SNUMB               := SNUMB;
    RRES.SCAPTION            := SCAPTION;
    RRES.SNAME               := SNAME;
    RRES.DSTART              := DSTART;
    RRES.DEND                := DEND;
    RRES.NPROGRESS           := NPROGRESS;
    RRES.SBG_COLOR           := SBG_COLOR;
    RRES.STEXT_COLOR         := STEXT_COLOR;
    RRES.SBG_PROGRESS_COLOR  := SBG_PROGRESS_COLOR;
    RRES.BREAD_ONLY          := BREAD_ONLY;
    RRES.BREAD_ONLY_DATES    := BREAD_ONLY_DATES;
    RRES.BREAD_ONLY_PROGRESS := BREAD_ONLY_PROGRESS;
    RRES.RATTR_VALS          := TGANTT_TASK_ATTR_VALS();
    RRES.RDEPENDENCIES       := TGANTT_TASK_DEPENDENCIES();
    /*   */
    return RRES;
  end TGANTT_TASK_MAKE;
  
  /*        */
  procedure TGANTT_TASK_ADD_ATTR_VAL
  (
    RGANTT                  in TGANTT,                 --  
    RTASK                   in out nocopy TGANTT_TASK, --  
    SNAME                   in varchar2,               -- 
    SVALUE                  in varchar2,               -- 
    BCLEAR                  in boolean := false        --      (false -  , true -    )
  )
  is
  begin
    /*   */
    TGANTT_TASK_ATTR_NAME_CHECK(SNAME => SNAME);
    /* ,     */
    if (TGANTT_TASK_ATTR_FIND(RTASK_ATTRS => RGANTT.RTASK_ATTRS, SNAME => SNAME).SNAME is null) then
      P_EXCEPTION(0,
                  ' "%s"     .',
                  SNAME);
    end if;
    /*     */
    if ((RTASK.RATTR_VALS is null) or (BCLEAR)) then
      RTASK.RATTR_VALS := TGANTT_TASK_ATTR_VALS();
    end if;
    /*   */
    RTASK.RATTR_VALS.EXTEND();
    RTASK.RATTR_VALS(RTASK.RATTR_VALS.LAST).SNAME := SNAME;
    RTASK.RATTR_VALS(RTASK.RATTR_VALS.LAST).SVALUE := SVALUE;
  end TGANTT_TASK_ADD_ATTR_VAL;
  
  /*        */
  procedure TGANTT_TASK_ADD_DEPENDENCY
  (
    RTASK                   in out nocopy TGANTT_TASK, --  
    NDEPENDENCY             in number,                 -- .   
    BCLEAR                  in boolean := false        --      (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RTASK.RDEPENDENCIES is null) or (BCLEAR)) then
      RTASK.RDEPENDENCIES := TGANTT_TASK_DEPENDENCIES();
    end if;
    /*   */
    RTASK.RDEPENDENCIES.EXTEND();
    RTASK.RDEPENDENCIES(RTASK.RDEPENDENCIES.LAST) := NDEPENDENCY;
  end TGANTT_TASK_ADD_DEPENDENCY;
  
  /*      */
  procedure TGANTT_TASKS_TO_XML
  (
    RTASKS                  in TGANTT_TASKS   --    
  )
  is    
  begin
    /*     */
    if ((RTASKS is not null) and (RTASKS.COUNT > 0)) then
      for I in RTASKS.FIRST .. RTASKS.LAST
      loop
        /*   */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XGANTT_TASKS);
        /*   */
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_ID, SVALUE => 'taskId' || RTASKS(I).NRN);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_RN, NVALUE => RTASKS(I).NRN);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_NUMB, SVALUE => RTASKS(I).SNUMB);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_NAME, SVALUE => RTASKS(I).SCAPTION);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_FULL_NAME, SVALUE => RTASKS(I).SNAME);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_START, DVALUE => RTASKS(I).DSTART);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_END, DVALUE => RTASKS(I).DEND);
        if (RTASKS(I).NPROGRESS is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_PROGRESS, NVALUE => RTASKS(I).NPROGRESS);
        end if;
        if (RTASKS(I).SBG_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_BG_COLOR, SVALUE => RTASKS(I).SBG_COLOR);
        end if;
        if (RTASKS(I).STEXT_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_TEXT_COLOR, SVALUE => RTASKS(I).STEXT_COLOR);
        end if;
        if (RTASKS(I).SBG_PROGRESS_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_BG_PRG_COLOR, SVALUE => RTASKS(I).SBG_PROGRESS_COLOR);
        end if;
        if (RTASKS(I).BREAD_ONLY is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_RO, BVALUE => RTASKS(I).BREAD_ONLY);
        end if;
        if (RTASKS(I).BREAD_ONLY_DATES is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_RO_DATES, BVALUE => RTASKS(I).BREAD_ONLY_DATES);
        end if;
        if (RTASKS(I).BREAD_ONLY_PROGRESS is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_RO_PRGRS, BVALUE => RTASKS(I).BREAD_ONLY_PROGRESS);
        end if;
        /*   */
        if ((RTASKS(I).RATTR_VALS is not null) and (RTASKS(I).RATTR_VALS.COUNT > 0)) then
          for J in RTASKS(I).RATTR_VALS.FIRST .. RTASKS(I).RATTR_VALS.LAST
          loop
            PKG_XFAST.ATTR(SNAME => RTASKS(I).RATTR_VALS(J).SNAME, SVALUE => RTASKS(I).RATTR_VALS(J).SVALUE);
          end loop;
        end if;
        /*  */
        if ((RTASKS(I).RDEPENDENCIES is not null) and (RTASKS(I).RDEPENDENCIES.COUNT > 0)) then
          for J in RTASKS(I).RDEPENDENCIES.FIRST .. RTASKS(I).RDEPENDENCIES.LAST
          loop
            PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_TASK_DEPS);
            PKG_XFAST.VALUE(SVALUE => 'taskId' || TO_CHAR(RTASKS(I).RDEPENDENCIES(J)));
            PKG_XFAST.UP();
          end loop;
        end if;
        /*   */
        PKG_XFAST.UP();
      end loop;
    end if;
  end TGANTT_TASKS_TO_XML;

  /*    */
  function TGANTT_MAKE
  (
    STITLE                  in varchar2 := null,           --  (null -  )
    NZOOM                   in number := NGANTT_ZOOM_WEEK, --   (.  NGANTT_ZOOM_*)
    BZOOM_BAR               in boolean := true,            --   
    BREAD_ONLY              in boolean := false,           --       
    BREAD_ONLY_DATES        in boolean := false,           --     
    BREAD_ONLY_PROGRESS     in boolean := false            --     
  ) return                  TGANTT                         --  
  is
    RRES                    TGANTT;                        --   
  begin
    /*   */
    RRES.STITLE              := STITLE;
    RRES.NZOOM               := COALESCE(NZOOM, NGANTT_ZOOM_WEEK);
    RRES.BZOOM_BAR           := COALESCE(BZOOM_BAR, true);
    RRES.BREAD_ONLY          := COALESCE(BREAD_ONLY, false);
    RRES.BREAD_ONLY_DATES    := COALESCE(BREAD_ONLY_DATES, false);
    RRES.BREAD_ONLY_PROGRESS := COALESCE(BREAD_ONLY_PROGRESS, false);
    RRES.RTASK_ATTRS         := TGANTT_TASK_ATTRS();
    RRES.RTASK_COLORS        := TGANTT_TASK_COLORS();
    RRES.RTASKS              := TGANTT_TASKS();
    /*   */
    return RRES;
  end TGANTT_MAKE;
  
  /*        */
  procedure TGANTT_ADD_TASK_ATTR
  (
    RGANTT                  in out nocopy TGANTT, --   
    SNAME                   in varchar2,          -- 
    SCAPTION                in varchar2,          -- 
    BVISIBLE                boolean := true,      --  
    BCLEAR                  in boolean := false   --     (false -  , true -    )
  )
  is
  begin
    /*   */
    TGANTT_TASK_ATTR_NAME_CHECK(SNAME => SNAME);
    /* ,     */
    if (TGANTT_TASK_ATTR_FIND(RTASK_ATTRS => RGANTT.RTASK_ATTRS, SNAME => SNAME).SNAME is not null) then
      P_EXCEPTION(0,
                  ' "%s"     .',
                  SNAME);
    end if;
    /*     */
    if ((RGANTT.RTASK_ATTRS is null) or (BCLEAR)) then
      RGANTT.RTASK_ATTRS := TGANTT_TASK_ATTRS();
    end if;
    /*   */
    RGANTT.RTASK_ATTRS.EXTEND();
    RGANTT.RTASK_ATTRS(RGANTT.RTASK_ATTRS.LAST).SNAME := SNAME;
    RGANTT.RTASK_ATTRS(RGANTT.RTASK_ATTRS.LAST).SCAPTION := SCAPTION;
    RGANTT.RTASK_ATTRS(RGANTT.RTASK_ATTRS.LAST).BVISIBLE := BVISIBLE;
  end TGANTT_ADD_TASK_ATTR;

  /*       */
  procedure TGANTT_ADD_TASK_COLOR
  (
    RGANTT                  in out nocopy TGANTT, --   
    SBG_COLOR               in varchar2 := null,  --    ( - HTML-, #RRGGBBAA)
    STEXT_COLOR             in varchar2 := null,  --     ( - HTML-, #RRGGBBAA)
    SBG_PROGRESS_COLOR      in varchar2 := null,  --    ( - HTML-, #RRGGBBAA)
    SDESC                   in varchar2,          -- 
    BCLEAR                  in boolean := false   --     (false -  , true -    )
  )
  is
  begin
    /*   */
    if ((SBG_COLOR is null) and (STEXT_COLOR is null) and (SBG_PROGRESS_COLOR is null)) then
      P_EXCEPTION(0,
                  '        ,    .');
    end if;
    if (SDESC is null) then
      P_EXCEPTION(0, '    .');
    end if;
    /* ,     */
    if (TGANTT_TASK_COLOR_FIND(RTASK_COLORS => RGANTT.RTASK_COLORS, SBG_COLOR => SBG_COLOR, STEXT_COLOR => STEXT_COLOR, SBG_PROGRESS_COLOR => SBG_PROGRESS_COLOR)
       .SDESC is not null) then
      P_EXCEPTION(0,
                  '        .');
    end if;
    /*     */
    if ((RGANTT.RTASK_COLORS is null) or (BCLEAR)) then
      RGANTT.RTASK_COLORS := TGANTT_TASK_COLORS();
    end if;
    /*   */
    RGANTT.RTASK_COLORS.EXTEND();
    RGANTT.RTASK_COLORS(RGANTT.RTASK_COLORS.LAST).SBG_COLOR := SBG_COLOR;
    RGANTT.RTASK_COLORS(RGANTT.RTASK_COLORS.LAST).STEXT_COLOR := STEXT_COLOR;
    RGANTT.RTASK_COLORS(RGANTT.RTASK_COLORS.LAST).SBG_PROGRESS_COLOR := SBG_PROGRESS_COLOR;
    RGANTT.RTASK_COLORS(RGANTT.RTASK_COLORS.LAST).SDESC := SDESC;
  end TGANTT_ADD_TASK_COLOR;

  /*      */
  procedure TGANTT_ADD_TASK
  (
    RGANTT                  in out nocopy TGANTT, --   
    RTASK                   in TGANTT_TASK,       -- 
    BCLEAR                  in boolean := false   --      (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RGANTT.RTASKS is null) or (BCLEAR)) then
      RGANTT.RTASKS := TGANTT_TASKS();
    end if;
    /*   */
    RGANTT.RTASKS.EXTEND();
    RGANTT.RTASKS(RGANTT.RTASKS.LAST) := RTASK;
  end TGANTT_ADD_TASK;
  
  /*      */
  procedure TGANTT_DEF_TO_XML
  (
    RGANTT                  in TGANTT   --   
  )
  is    
  begin
    /*    */
    PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XGANTT_DEF);
    /* C   */
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TITLE, SVALUE => RGANTT.STITLE);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_ZOOM, NVALUE => RGANTT.NZOOM);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_GANTT_ZOOM_BAR, BVALUE => RGANTT.BZOOM_BAR);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_RO, BVALUE => RGANTT.BREAD_ONLY);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_RO_DATES, BVALUE => RGANTT.BREAD_ONLY_DATES);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_RO_PRGRS, BVALUE => RGANTT.BREAD_ONLY_PROGRESS);
    /*     */
    if ((RGANTT.RTASK_ATTRS is not null) and (RGANTT.RTASK_ATTRS.COUNT > 0)) then
      /*     */
      for I in RGANTT.RTASK_ATTRS.FIRST .. RGANTT.RTASK_ATTRS.LAST
      loop
        /*     */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_TASK_ATTRIBUTES);
        /*    */
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_NAME, SVALUE => RGANTT.RTASK_ATTRS(I).SNAME);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CAPTION, SVALUE => RGANTT.RTASK_ATTRS(I).SCAPTION);
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_VISIBLE, BVALUE => RGANTT.RTASK_ATTRS(I).BVISIBLE);
        /*     */
        PKG_XFAST.UP();
      end loop;
    end if;
    /*     */
    if ((RGANTT.RTASK_COLORS is not null) and (RGANTT.RTASK_COLORS.COUNT > 0)) then
      /*     */
      for I in RGANTT.RTASK_COLORS.FIRST .. RGANTT.RTASK_COLORS.LAST
      loop
        /*     */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_TASK_COLORS);
        /*    */
        if (RGANTT.RTASK_COLORS(I).SBG_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_BG_COLOR, SVALUE => RGANTT.RTASK_COLORS(I).SBG_COLOR);
        end if;
        if (RGANTT.RTASK_COLORS(I).STEXT_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_TEXT_COLOR, SVALUE => RGANTT.RTASK_COLORS(I).STEXT_COLOR);
        end if;
        if (RGANTT.RTASK_COLORS(I).SBG_PROGRESS_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TASK_BG_PRG_COLOR, SVALUE => RGANTT.RTASK_COLORS(I).SBG_PROGRESS_COLOR);
        end if;
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_DESC, SVALUE => RGANTT.RTASK_COLORS(I).SDESC);
        /*     */
        PKG_XFAST.UP();
      end loop;
    end if;
    /*    */
    PKG_XFAST.UP();
  end TGANTT_DEF_TO_XML;
  
  /*    */
  function TGANTT_TO_XML
  (
    RGANTT                  in TGANTT,     --   
    NINCLUDE_DEF            in number := 1 --    (0 - , 1 - )
  ) return                  clob           -- XML-
  is
    CRES                    clob;          --   
  begin
    /*   XML */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    /*   */
    PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XDATA);
    /*      */
    if (NINCLUDE_DEF = 1) then
      TGANTT_DEF_TO_XML(RGANTT => RGANTT);
    end if;
    /*    */
    TGANTT_TASKS_TO_XML(RTASKS => RGANTT.RTASKS);
    /*   */
    PKG_XFAST.UP();
    /*  */
    CRES := PKG_XFAST.SERIALIZE_TO_CLOB();
    /*   XML */
    PKG_XFAST.EPILOGUE();
    /*   */
    return CRES;
  exception
    when others then
      /*   XML */
      PKG_XFAST.EPILOGUE();
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end TGANTT_TO_XML;
  
  /*         */
  procedure TCHART_DATASET_ITEM_ATTR_NM_CH
  (
    SNAME                   in varchar2 -- 
  )
  is
  begin
    if (SNAME in (SRESP_ATTR_CHART_DS_I_VAL)) then
      P_EXCEPTION(0,
                  '  "%s"  .',
                  SNAME);
    end if;
  end TCHART_DATASET_ITEM_ATTR_NM_CH;
  
  /*    */
  procedure TCHART_LABELS_TO_XML
  (
    RLABELS                 in TCHART_LABELS --   
  )
  is    
  begin
    /*    */
    if ((RLABELS is not null) and (RLABELS.COUNT > 0)) then
      /*   */
      for I in RLABELS.FIRST .. RLABELS.LAST
      loop
        /*    */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_CHART_LABELS);
        /*   */
        PKG_XFAST.VALUE(SVALUE => RLABELS(I));
        /*    */
        PKG_XFAST.UP();
      end loop;
    end if;
  end TCHART_LABELS_TO_XML;
  
  /*       */
  procedure TCHART_DATASET_ITM_ATTR_VL_ADD
  (
    RATTR_VALS              in out nocopy TCHART_DATASET_ITEM_ATTR_VALS, --      
    SNAME                   PKG_STD.TSTRING,                             -- 
    SVALUE                  PKG_STD.TSTRING,                             -- 
    BCLEAR                  in boolean := false                          --        (false -  , true -    )
  )
  is
  begin
    /*    */
    TCHART_DATASET_ITEM_ATTR_NM_CH(SNAME => SNAME);
    /*     */
    if ((RATTR_VALS is null) or (BCLEAR)) then
      RATTR_VALS := TCHART_DATASET_ITEM_ATTR_VALS();
    end if;
    /*   */
    RATTR_VALS.EXTEND();
    RATTR_VALS(RATTR_VALS.LAST).SNAME := SNAME;
    RATTR_VALS(RATTR_VALS.LAST).SVALUE := SVALUE;
  end TCHART_DATASET_ITM_ATTR_VL_ADD;
  
  /*     */
  function TCHART_DATASET_MAKE
  (
    SCAPTION                in varchar2,         -- 
    SBORDER_COLOR           in varchar2 := null, --       (null -      ,  - HTML-, #RRGGBBAA)
    SBG_COLOR               in varchar2 := null  --       (null -      ,  - HTML-, #RRGGBBAA)
  ) return                  TCHART_DATASET       --  
  is
    RRES                    TCHART_DATASET;      --   
  begin
    /*   */
    RRES.SCAPTION      := SCAPTION;
    RRES.SBORDER_COLOR := SBORDER_COLOR;
    RRES.SBG_COLOR     := SBG_COLOR;
    RRES.RITEMS        := TCHART_DATASET_ITEMS();
    /*   */
    return RRES;
  end TCHART_DATASET_MAKE;
  
  /*       */
  procedure TCHART_DATASET_ADD_ITEM
  (
    RDATASET                in out nocopy TCHART_DATASET,             --    
    NVALUE                  in number,                                --   ,   
    RATTR_VALS              in TCHART_DATASET_ITEM_ATTR_VALS := null, --    (null -    )
    BCLEAR                  in boolean := false                       --       (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RDATASET.RITEMS is null) or (BCLEAR)) then
      RDATASET.RITEMS := TCHART_DATASET_ITEMS();
    end if;
    /*   */
    RDATASET.RITEMS.EXTEND();
    RDATASET.RITEMS(RDATASET.RITEMS.LAST).NVALUE := NVALUE;
    RDATASET.RITEMS(RDATASET.RITEMS.LAST).RATTR_VALS := RATTR_VALS;
  end TCHART_DATASET_ADD_ITEM;
  
  /*      */
  procedure TCHART_DATASETS_TO_XML
  (
    RDATASETS               in TCHART_DATASETS --   
  )
  is
  begin
    /*     */
    if ((RDATASETS is not null) and (RDATASETS.COUNT > 0)) then
      /*    */
      for I in RDATASETS.FIRST .. RDATASETS.LAST
      loop
        /*    */
        PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_CHART_DATASETS);
        /*    */
        PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CHART_DS_LABEL, SVALUE => RDATASETS(I).SCAPTION);
        if (RDATASETS(I).SBORDER_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CHART_DS_BR_CLR, SVALUE => RDATASETS(I).SBORDER_COLOR);
        end if;
        if (RDATASETS(I).SBG_COLOR is not null) then
          PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CHART_DS_BG_CLR, SVALUE => RDATASETS(I).SBG_COLOR);
        end if;
        /*       */
        if ((RDATASETS(I).RITEMS is not null) and (RDATASETS(I).RITEMS.COUNT > 0)) then
          /*         */
          for J in RDATASETS(I).RITEMS.FIRST .. RDATASETS(I).RITEMS.LAST
          loop
            /*      */
            PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_CHART_DS_DATA);
            /*    */
            PKG_XFAST.VALUE(NVALUE => RDATASETS(I).RITEMS(J).NVALUE);
            /*      */
            PKG_XFAST.UP();
          end loop;
          /*         */
          for J in RDATASETS(I).RITEMS.FIRST .. RDATASETS(I).RITEMS.LAST
          loop
            /*     */
            PKG_XFAST.DOWN_NODE(SNAME => SRESP_ATTR_CHART_DS_ITEMS);
            /*    */
            PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CHART_DS_I_VAL, NVALUE => RDATASETS(I).RITEMS(J).NVALUE);
            /*    */
            if ((RDATASETS(I).RITEMS(J).RATTR_VALS is not null) and (RDATASETS(I).RITEMS(J).RATTR_VALS.COUNT > 0)) then
              for K in RDATASETS(I).RITEMS(J).RATTR_VALS.FIRST .. RDATASETS(I).RITEMS(J).RATTR_VALS.LAST
              loop
                PKG_XFAST.ATTR(SNAME  => RDATASETS(I).RITEMS(J).RATTR_VALS(K).SNAME,
                               SVALUE => RDATASETS(I).RITEMS(J).RATTR_VALS(K).SVALUE);
              end loop;
            end if;
            /*     */
            PKG_XFAST.UP();
          end loop;
        end if;
        /*    */
        PKG_XFAST.UP();
      end loop;
    end if;
  end TCHART_DATASETS_TO_XML;
  
  /*   */
  function TCHART_MAKE
  (
    STYPE                   in varchar2,         --  (.  SCHART_TYPE_*)
    STITLE                  in varchar2 := null, --  (null -  )
    SLGND_POS               in varchar2 := null  --   (null -  , .  SCHART_LGND_POS_*)
  ) return                  TCHART               --  
  is
    RRES                    TCHART;              --   
  begin
    /*   */
    RRES.STYPE     := STYPE;
    RRES.STITLE    := STITLE;
    RRES.SLGND_POS := SLGND_POS;
    RRES.RLABELS   := TCHART_LABELS();
    RRES.RDATASETS := TCHART_DATASETS();
    /*   */
    return RRES;
  end TCHART_MAKE;
  
  /*     */
  procedure TCHART_ADD_LABEL
  (
    RCHART                  in out nocopy TCHART, --  
    SLABEL                  in varchar2,          --  
    BCLEAR                  in boolean := false   --     (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RCHART.RLABELS is null) or (BCLEAR)) then
      RCHART.RLABELS := TCHART_LABELS();
    end if;
    /*   */
    RCHART.RLABELS.EXTEND();
    RCHART.RLABELS(RCHART.RLABELS.LAST) := SLABEL;
  end TCHART_ADD_LABEL;
  
  /*     */
  procedure TCHART_ADD_DATASET
  (
    RCHART                  in out nocopy TCHART, --  
    RDATASET                in TCHART_DATASET,    --  
    BCLEAR                  in boolean := false   --      (false -  , true -    )
  )
  is
  begin
    /*     */
    if ((RCHART.RDATASETS is null) or (BCLEAR)) then
      RCHART.RDATASETS := TCHART_DATASETS();
    end if;
    /*   */
    RCHART.RDATASETS.EXTEND();
    RCHART.RDATASETS(RCHART.RDATASETS.LAST) := RDATASET;
  end TCHART_ADD_DATASET;
  
  /*     */
  procedure TCHART_DEF_TO_XML
  (
    RCHART                  in TCHART   --  
  )
  is    
  begin
    /* C   */
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TYPE, SVALUE => RCHART.STYPE);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_TITLE, SVALUE => RCHART.STITLE);
    PKG_XFAST.ATTR(SNAME => SRESP_ATTR_CHART_LGND_POS, SVALUE => RCHART.SLGND_POS);
  end TCHART_DEF_TO_XML;
  
  /*   */
  function TCHART_TO_XML
  (
    RCHART                  in TCHART,     --  
    NINCLUDE_DEF            in number := 1 --    (0 - , 1 - )
  ) return                  clob           -- XML-
  is
    CRES                    clob;          --   
  begin
    /*   XML */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    /*   */
    PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XDATA);
    /*   */
    PKG_XFAST.DOWN_NODE(SNAME => SRESP_TAG_XCHART);
    /*      */
    if (NINCLUDE_DEF = 1) then
      TCHART_DEF_TO_XML(RCHART => RCHART);
    end if;
    /*    */
    TCHART_LABELS_TO_XML(RLABELS => RCHART.RLABELS);
    /*     */
    TCHART_DATASETS_TO_XML(RDATASETS => RCHART.RDATASETS);
    /*   */
    PKG_XFAST.UP();
    /*   */
    PKG_XFAST.UP();
    /*  */
    CRES := PKG_XFAST.SERIALIZE_TO_CLOB();
    /*   XML */
    PKG_XFAST.EPILOGUE();
    /*   */
    return CRES;
  exception
    when others then
      /*   XML */
      PKG_XFAST.EPILOGUE();
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end TCHART_TO_XML;
  
end PKG_P8PANELS_VISUAL;
/
