create or replace package PKG_P8PANELS_PROJECTS as

  /*   -    */
  type TSTAGE_ART is record
  (
    NRN                     FPDARTCL.RN%type,   -- .  
    SCODE                   FPDARTCL.CODE%type, --  
    SNAME                   FPDARTCL.NAME%type, --  
    NPLAN                   PKG_STD.TNUMBER,    --    
    NCOST_FACT              PKG_STD.TNUMBER,    --   (null -    )
    NCOST_DIFF              PKG_STD.TNUMBER,    --    (null -    )
    NCTRL_COST              PKG_STD.TNUMBER,    --   (null -    , 0 -  , 1 -  )
    NCONTR                  PKG_STD.TNUMBER,    --  (null -    )
    NCONTR_LEFT             PKG_STD.TNUMBER,    --    (null -    )
    NCTRL_CONTR             PKG_STD.TNUMBER     --   (null -    , 0 -  , 1 -  )
  );
  
  /*   -     */
  type TSTAGE_ARTS is table of TSTAGE_ART;

  /*   */
  procedure COND;

  /*  .    ()  */
  function GET_DOC_OSN_LNK_DOCUMENT
  (
    NRN                     in number   -- .  
  ) return                  number;     -- .    ()

  /*     */
  procedure SELECT_FIN
  (
    NRN                     in number, -- .  
    NDIRECTION              in number, --  (0 - , 1 - )
    NIDENT                  out number --    (  , null -  )
  );
  
  /*      */
  function GET_FIN_IN
  (
    NRN                     in number   -- .  
  ) return                  number;     --    

  /*      */
  function GET_FIN_OUT
  (
    NRN                     in number   -- .  
  ) return                  number;     --    

  /*     */
  function GET_CTRL_FIN
  (
    NRN                     in number   -- .  
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*     */
  function GET_CTRL_CONTR
  (
    NRN                     in number   -- .  
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*     */
  function GET_CTRL_COEXEC
  (
    NRN                     in number   -- .  
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*     */
  function GET_CTRL_PERIOD
  (
    NRN                     in number   -- .  
  ) return                  number;     --  (null -  , 0 -  , 1 -  )
  
  /*     */
  function GET_CTRL_COST
  (
    NRN                     in number   -- .  
  ) return                  number;     --  (null -  , 0 -  , 1 -  )
  
  /*     */
  function GET_CTRL_ACT
  (
    NRN                     in number   -- .  
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*  %   ( ) */
  function GET_COST_READY
  (
    NRN                     in number   -- .  
  ) return                  number;     -- % 
  
  /*   */
  procedure LIST
  (
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CFILTERS                in clob,    -- 
    CORDERS                 in clob,    -- 
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );
  
  /*    */
  procedure GRAPH
  (
    COUT                    out clob    --  
  );
  
  /*     - " " */
  procedure CHART_PROBLEMS
  (
    COUT                    out clob    --  
  );

  /*     - " " */
  procedure CHART_CUSTOMERS
  (
    COUT                    out clob    --  
  );
  
  /*     - "  " */
  procedure CHART_FCCOSTNOTES
  (
    COUT                    out clob    --  
  );
  
  /*     - "  " (      ) */
  procedure CHART_FCCOSTNOTES_SELECT_COST
  (
    NYEAR                   in number,  -- 
    NMONTH                  in number,  -- 
    NIDENT                  out number  --    (  , null -  )
  );
 
  /*    */
  procedure STAGES_COND;
  
  
  /*      */
  procedure STAGES_SELECT_FIN
  (
    NPRN                    in number := null, -- .   (null -    )
    NRN                     in number := null, -- .    (null -    )
    NDIRECTION              in number,         --  (0 - , 1 - )
    NIDENT                  out number         --    (  , null -  )
  );
  
  /*       */
  function STAGES_GET_FIN_IN
  (
    NRN                     in number   -- .   
  ) return                  number;     --    

  /*       */
  function STAGES_GET_FIN_OUT
  (
    NRN                     in number   -- .   
  ) return                  number;     --    

  /*      */
  function STAGES_GET_CTRL_FIN
  (
    NRN                     in number   -- .   
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*      */
  function STAGES_GET_CTRL_CONTR
  (
    NRN                     in number   -- .   
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*      */
  function STAGES_GET_CTRL_COEXEC
  (
    NRN                     in number   -- .   
  ) return                  number;     --  (null -  , 0 -  , 1 -  )
  
  /*      */
  function STAGES_GET_CTRL_PERIOD
  (
    NRN                     in number   -- .   
  ) return                  number;     --  (null -  , 0 -  , 1 -  )
  
  /*      */
  function STAGES_GET_CTRL_COST
  (
    NRN                     in number   -- .   
  ) return                  number;     --  (null -  , 0 -  , 1 -  )
  
  /*      */
  function STAGES_GET_CTRL_ACT
  (
    NRN                     in number   -- .   
  ) return                  number;     --  (null -  , 0 -  , 1 -  )
  
  /*       */
  function STAGES_GET_DAYS_LEFT
  (
    NRN                     in number   -- .   
  ) return                  number;     --   (null -  )
  
  /*       */
  procedure STAGES_SELECT_COST_FACT
  (
    NRN                     in number,  -- .   
    NIDENT                  out number  --    (  , null -  )
  );
  
  /*       */
  function STAGES_GET_COST_FACT
  (
    NRN                     in number   -- .   
  ) return                  number;     --   

  /*          */
  procedure STAGES_SELECT_SUMM_REALIZ
  (
    NRN                     in number,  -- .   
    NIDENT                  out number  --    (  , null -  )
  );
  
  /*      */
  function STAGES_GET_SUMM_REALIZ
  (
    NRN                     in number,  -- .   
    NFPDARTCL_REALIZ        in number   -- .     
  ) return                  number;     --  
  
  /*  %    ( ) */
  function STAGES_GET_COST_READY
  (
    NRN                     in number   -- .   
  ) return                  number;     --  
  
  /*   */
  procedure STAGES_LIST
  (
    NPRN                    in number,  -- .  
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CFILTERS                in clob,    -- 
    CORDERS                 in clob,    -- 
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );
  
  /*          */
  procedure STAGE_ARTS_SELECT_COST_FACT
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NFINFLOW_TYPE           in number := null, --     (null -  , 0 - , 1 - , 2 - )
    NIDENT                  out number         --    (  , null -  )
  );
  
  /*  -      */
  function STAGE_ARTS_GET_COST_FACT
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NFINFLOW_TYPE           in number := null  --     (null -  , 0 - , 1 - , 2 - )
  ) return                  number;            -- -  
  
  /*           */
  procedure STAGE_ARTS_SELECT_CONTR
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NIDENT                  out number         --    (  , null -  )
  );
  
  /*      */
  procedure STAGE_ARTS_GET
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NINC_COST               in number := 0,    --     (0 - , 1 - )
    NINC_CONTR              in number := 0,    --     (0 - , 1 - )
    RSTAGE_ARTS             out TSTAGE_ARTS    --    
  );
  
  /*      */
  procedure STAGE_ARTS_LIST
  (
    NSTAGE                  in number,  -- .   
    CFILTERS                in clob,    -- 
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );

  /*     */
  procedure STAGE_CONTRACTS_COND;

  /*         */
  procedure STAGE_CONTRACTS_SELECT_PAY_IN
  (
    NPROJECTSTAGEPF         in number,  -- .    
    NIDENT                  out number  --    (  , null -  )
  );

  /*       */
  procedure STAGE_CONTRACTS_SELECT_ININV
  (
    NPROJECTSTAGEPF         in number,  -- .    
    NIDENT                  out number  --    (  , null -  )
  );
  
  /*       */
  procedure STAGE_CONTRACTS_SELECT_FIN_OUT
  (
    NPROJECTSTAGEPF         in number,  -- .    
    NIDENT                  out number  --    (  , null -  )
  );
  
  /*         */
  function STAGE_CONTRACTS_GET_CTRL_FIN
  (
    NPROJECTSTAGEPF         in number   -- .    
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*         */
  function STAGE_CONTRACTS_GET_CTRL_COEXE
  (
    NPROJECTSTAGEPF         in number   -- .    
  ) return                  number;     --  (null -  , 0 -  , 1 -  )

  /*        */
  procedure STAGE_CONTRACTS_GET
  (
    NPROJECTSTAGEPF         in number,      -- .    
    NINC_FIN                in number := 0, --     (0 - , 1 - )
    NINC_COEXEC             in number := 0, --     (0 - , 1 - )
    NPAY_IN                 out number,     --    -     
    NFIN_OUT                out number,     --    -     
    NPAY_IN_REST            out number,     --    -       
    NFIN_REST               out number,     --    -      
    NCTRL_FIN               out number,     --    -  (null -  , 0 -  , 1 -  )
    NCOEXEC_IN              out number,     --    -  /
    NCOEXEC_REST            out number,     --    -   /
    NCTRL_COEXEC            out number      --    -  (null -  , 0 -  , 1 -  )
  );
  
  /*     */
  procedure STAGE_CONTRACTS_LIST
  (
    NSTAGE                  in number,  -- .   
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CFILTERS                in clob,    -- 
    CORDERS                 in clob,    -- 
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );

    /*    */
  procedure JB_PRJCTS_LIST
  (
    NIDENT                  in number,  --  
    COUT                    out clob    --  
  );
  
  /*       */
  procedure JB_JOBS_MODIFY_PERIOD
  (
    NJB_JOBS                in number,  -- .    /
    DDATE_FROM              in date,    --   
    DDATE_TO                in date,    --   
    NRESOURCE_STATUS        out number  --   (0 -  , 1 -  , -1 -   )
  );
  
  /*        */
  procedure JB_JOBS_LIST
  (
    NIDENT                  in number,  --  
    NPRN                    in number,  -- .  
    NINCLUDE_DEF            in number,  --      
    COUT                    out clob    --  
  );
  
    /*          */
  procedure JB_PERIODS_PLAN_FOT_LIST
  (
    NJB_PERIODS             in number,  -- .      
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CORDERS                 in clob,    --     
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );
  
  /*          "   " */
  procedure JB_PERIODS_FACT_RPT_LIST
  (
    NJB_PERIODS             in number,  -- .      
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CORDERS                 in clob,    --     
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );

  /*            */
  procedure JB_PERIODS_PLAN_JOBS_LIST
  (
    NJB_PERIODS             in number,  -- .      
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CORDERS                 in clob,    --     
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );
  
  /*    */
  procedure JB_PERIODS_RECALC
  (
    NIDENT                  in number,  --  
    NINITIAL                in number,  --    (0 - , 1 -  )
    NRESOURCE_STATUS        out number  --   (0 -  , 1 -  )
  );
  
  /*    */
  procedure JB_PERIODS_LIST
  (
    NIDENT                  in number,  --  
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CORDERS                 in clob,    --     
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );
  
  /*    */
  procedure JB_CLEAN
  (
    NIDENT                  in number   --  
  );
  
  /*       */
  procedure JB_SAVE
  (
    NIDENT                  in number,  --  
    COUT                    out clob    --  
  );
  
  /*      -  */
  procedure JB_INIT
  (
    DBEGIN                  in out date,   --      
    DFACT                   in out date,   --    
    NDURATION_MEAS          out number,    --    (0 - , 1 - , 2 - , 3 - , 4 - , 5 - )
    SDURATION_MEAS          out varchar2,  --    ()
    NLAB_MEAS               out number,    --   
    SLAB_MEAS               out varchar2,  --    ()
    NIDENT                  in out number, --   (null -  , !null -        )
    NRESOURCE_STATUS        out number     --   (0 -  , 1 -  )    
  );

end PKG_P8PANELS_PROJECTS;
/
create or replace package body PKG_P8PANELS_PROJECTS as

  /*  -   */
  SYES                      constant PKG_STD.TSTRING := '';               -- 
  NDAYS_LEFT_LIMIT          constant PKG_STD.TNUMBER := 30;                 --      
  SFPDARTCL_REALIZ          constant PKG_STD.TSTRING := '14   ';  --      
  SFPDARTCL_SELF_COST       constant PKG_STD.TSTRING := '10 '; --      
  NGANTT_TASK_CAPTION_LEN   constant PKG_STD.TNUMBER := 50;                 --   ()      
  NJB_DURATION_MEAS         constant PKG_STD.TNUMBER := 0;                  --          (0 - , 1 - , 2 - , 3 - , 4 - , 5 - )
  SJB_LAB_MEAS              constant PKG_STD.TSTRING := '/';              --         
  SLAB_MEAS_HOURS           constant PKG_STD.TSTRING := '/';              --     /

  /*  -   */
  SDP_SECON_RESP            constant PKG_STD.TSTRING := '.SECON_RESP'; --   
  SDP_STAX_GROUP            constant PKG_STD.TSTRING := '.TAX_GROUP';  --   
  SDP_SCTL_COST             constant PKG_STD.TSTRING := '.CTL_COST';   --    .    
  SDP_SCTL_CONTR            constant PKG_STD.TSTRING := '.CTL_CONTR';  --       

  /*     .  */
  function UTL_INS_DEPARTMENT_GET_NAME
  (
    NRN                     in number        -- .  
  ) return                  varchar2         --   (null -   )
  is
    SRES                    PKG_STD.TSTRING; --   
  begin
    select T.NAME into SRES from INS_DEPARTMENT T where T.RN = NRN;
    return SRES;
  exception
    when NO_DATA_FOUND then
      return null;
  end UTL_INS_DEPARTMENT_GET_NAME;   
     
  /*    */
  function GET
  (
    NRN                     in number        -- .  
  ) return                  PROJECT%rowtype  --  
  is
    RRES                    PROJECT%rowtype; --   
  begin
    select P.* into RRES from PROJECT P where P.RN = NRN;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NRN, SUNIT_TABLE => 'PROJECT');
  end GET;
  
  /*       */
  function CHECK_RESPONSIBLE
  (
    NRN                     in number,            -- .  
    SAUTHID                 in varchar2           --      
  ) return                  number                --     (0 -  , 1 - )
  is
    RP                      PROJECT%rowtype;      --  
    NRES                    PKG_STD.TNUMBER := 0; --   
    NAUTHID_AGENT           PKG_STD.TREF;         -- .     
  begin
    /*   */
    RP := GET(NRN => NRN);
    /*  ,    */
    FIND_AGNLIST_AUTHID(NFLAG_OPTION => 1, NCOMPANY => RP.COMPANY, SPERS_AUTHID => SAUTHID, NAGENT => NAUTHID_AGENT);
    /*   */
    if (RP.RESPONSIBLE = NAUTHID_AGENT) then
      NRES := 1;
    end if;
    /*   */
    return NRES;
  exception
    when others then
      return NRES;
  end CHECK_RESPONSIBLE;

  /*   */
  procedure COND
  as
  begin
    /*    */
    PKG_COND_BROKER.SET_TABLE(STABLE_NAME => 'PROJECT');
    /*   */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME    => 'CODE',
                                       SCONDITION_NAME => 'EDPROJECTTYPE',
                                       SJOINS          => 'PRJTYPE <- RN;PRJTYPE');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'CODE', SCONDITION_NAME => 'EDMNEMO');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'NAME', SCONDITION_NAME => 'EDNAME');
    /*   */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'NAME_USL', SCONDITION_NAME => 'EDNAME_USL');
    /*    */
    PKG_COND_BROKER.ADD_CONDITION_BETWEEN(SCOLUMN_NAME         => 'BEGPLAN',
                                          SCONDITION_NAME_FROM => 'EDPLANBEGFrom',
                                          SCONDITION_NAME_TO   => 'EDPLANBEGTo');
    /*    */
    PKG_COND_BROKER.ADD_CONDITION_BETWEEN(SCOLUMN_NAME         => 'ENDPLAN',
                                          SCONDITION_NAME_FROM => 'EDPLANENDFrom',
                                          SCONDITION_NAME_TO   => 'EDPLANENDTo');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_ENUM(SCOLUMN_NAME => 'STATE', SCONDITION_NAME => 'CGSTATE');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME    => 'AGNABBR',
                                       SCONDITION_NAME => 'EDEXT_CUST',
                                       SJOINS          => 'EXT_CUST <- RN;AGNLIST');
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_FIN') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_FIN') ||
                                            '(RN) = :EDCTRL_FIN');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_FIN',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_FIN'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_CONTR') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_CONTR') ||
                                            '(RN) = :EDCTRL_CONTR');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_CONTR',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_CONTR'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_COEXEC') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_COEXEC') ||
                                            '(RN) = :EDCTRL_COEXEC');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_COEXEC',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_COEXEC'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_PERIOD') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_PERIOD') ||
                                            '(RN) = :EDCTRL_PERIOD');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_PERIOD',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_PERIOD'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_COST') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_COST') ||
                                            '(RN) = :EDCTRL_COST');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_COST',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_COST'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_ACT') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_ACT') ||
                                            '(RN) = :EDCTRL_ACT');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_ACT',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_ACT'));
    end if;
    /*  (%,  ) */
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYFrom') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYTo') = 0)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_COST_READY') ||
                                            '(RN) >= :EDCOST_READYFrom');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYFrom',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYFrom'));
    end if;
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYTo') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYFrom') = 0)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_COST_READY') ||
                                            '(RN) <= :EDCOST_READYTo');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYTo',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYTo'));
    end if;
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYFrom') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYTo') = 1)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_COST_READY') ||
                                            '(RN) between :EDCOST_READYFrom and :EDCOST_READYTo');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYFrom',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYFrom'));
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYTo',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYTo'));
    end if;
  end COND;
  
  /*  .    ()  */
  function GET_DOC_OSN_LNK_DOCUMENT
  (
    NRN                     in number   -- .  
  ) return                  number      -- .    ()
  is
  begin
    /*         */
    for C in (select CN.RN
                from PROJECTSTAGE PS,
                     STAGES       S,
                     CONTRACTS    CN
               where PS.PRN = NRN
                 and PS.FACEACCCUST = S.FACEACC
                 and S.PRN = CN.RN
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PS.CRN)
                 and exists (select null
                        from V_USERPRIV UP
                       where UP.JUR_PERS = PS.JUR_PERS
                         and UP.UNITCODE = 'Projects')
                 and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = CN.CRN
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = CN.CRN
                         and UP.AUTHID = UTILIZER)
                 and exists (select /*+ INDEX(UP I_USERPRIV_JUR_PERS_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.JUR_PERS = CN.JUR_PERS
                         and UP.UNITCODE = 'Contracts'
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_JUR_PERS_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.JUR_PERS = CN.JUR_PERS
                         and UP.UNITCODE = 'Contracts'
                         and UP.AUTHID = UTILIZER)
               group by CN.RN)
    loop
      /*    */
      return C.RN;
    end loop;
    /*    */
    return null;
  end GET_DOC_OSN_LNK_DOCUMENT;

  /*     */
  procedure SELECT_FIN
  (
    NRN                     in number,  -- .  
    NDIRECTION              in number,  --  (0 - , 1 - )
    NIDENT                  out number  --    (  , null -  )
  )
  is
  begin
    /*   */
    STAGES_SELECT_FIN(NPRN => NRN, NDIRECTION => NDIRECTION, NIDENT => NIDENT);
  end SELECT_FIN;

  /*      */
  function GET_FIN_IN
  (
    NRN                     in number             -- .  
  ) return                  number                --    
  is
    NRES                    PKG_STD.TNUMBER := 0; --   
  begin
    /*     */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      NRES := NRES + STAGES_GET_FIN_IN(NRN => C.RN);
    end loop;
    /*   */
    return NRES;
  end GET_FIN_IN;

  /*      */
  function GET_FIN_OUT
  (
    NRN                     in number             -- .  
  ) return                  number                --    
  is
    NRES                    PKG_STD.TNUMBER := 0; --   
  begin
    /*     */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      NRES := NRES + STAGES_GET_FIN_OUT(NRN => C.RN);
    end loop;
    /*   */
    return NRES;
  end GET_FIN_OUT;

  /*     */
  function GET_CTRL_FIN
  (
    NRN                     in number             -- .  
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NSTAGE_CTRL             PKG_STD.TNUMBER;      --  
    NCNT_STAGES             PKG_STD.TNUMBER := 0; --  
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  "" 
  begin
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      /*    */
      NCNT_STAGES := NCNT_STAGES + 1;
      /*    */
      NSTAGE_CTRL := STAGES_GET_CTRL_FIN(NRN => C.RN);
      /*   "" */
      if (NSTAGE_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NSTAGE_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_STAGES) then
      return null;
    end if;
    /*    -   */
    if (NCNT_STAGES > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end GET_CTRL_FIN;

  /*     */
  function GET_CTRL_CONTR
  (
    NRN                     in number             -- .  
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NSTAGE_CTRL             PKG_STD.TNUMBER;      --  
    NCNT_STAGES             PKG_STD.TNUMBER := 0; --  
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  "" 
  begin
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      /*    */
      NCNT_STAGES := NCNT_STAGES + 1;
      /*    */
      NSTAGE_CTRL := STAGES_GET_CTRL_CONTR(NRN => C.RN);
      /*   "" */
      if (NSTAGE_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NSTAGE_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_STAGES) then
      return null;
    end if;
    /*    -   */
    if (NCNT_STAGES > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end GET_CTRL_CONTR;

  /*     */
  function GET_CTRL_COEXEC
  (
    NRN                     in number             -- .  
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NSTAGE_CTRL             PKG_STD.TNUMBER;      --  
    NCNT_STAGES             PKG_STD.TNUMBER := 0; --  
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  "" 
  begin
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      /*    */
      NCNT_STAGES := NCNT_STAGES + 1;
      /*    */
      NSTAGE_CTRL := STAGES_GET_CTRL_COEXEC(NRN => C.RN);
      /*   "" */
      if (NSTAGE_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NSTAGE_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_STAGES) then
      return null;
    end if;
    /*    -   */
    if (NCNT_STAGES > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end GET_CTRL_COEXEC;

  /*     */
  function GET_CTRL_PERIOD
  (
    NRN                     in number             -- .  
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NSTAGE_CTRL             PKG_STD.TNUMBER;      --  
    NCNT_STAGES             PKG_STD.TNUMBER := 0; --  
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  "" 
  begin
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      /*    */
      NCNT_STAGES := NCNT_STAGES + 1;
      /*    */
      NSTAGE_CTRL := STAGES_GET_CTRL_PERIOD(NRN => C.RN);
      /*   "" */
      if (NSTAGE_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NSTAGE_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_STAGES) then
      return null;
    end if;
    /*    -   */
    if (NCNT_STAGES > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end GET_CTRL_PERIOD;
  
  /*     */
  function GET_CTRL_COST
  (
    NRN                     in number             -- .  
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NSTAGE_CTRL             PKG_STD.TNUMBER;      --  
    NCNT_STAGES             PKG_STD.TNUMBER := 0; --  
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  "" 
  begin
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      /*    */
      NCNT_STAGES := NCNT_STAGES + 1;
      /*    */
      NSTAGE_CTRL := STAGES_GET_CTRL_COST(NRN => C.RN);
      /*   "" */
      if (NSTAGE_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NSTAGE_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_STAGES) then
      return null;
    end if;
    /*    -   */
    if (NCNT_STAGES > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end GET_CTRL_COST;
  
  /*     */
  function GET_CTRL_ACT
  (
    NRN                     in number             -- .  
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NSTAGE_CTRL             PKG_STD.TNUMBER;      --  
    NCNT_STAGES             PKG_STD.TNUMBER := 0; --  
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  "" 
  begin
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = NRN)
    loop
      /*    */
      NCNT_STAGES := NCNT_STAGES + 1;
      /*    */
      NSTAGE_CTRL := STAGES_GET_CTRL_ACT(NRN => C.RN);
      /*   "" */
      if (NSTAGE_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NSTAGE_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_STAGES) then
      return null;
    end if;
    /*    -   */
    if (NCNT_STAGES > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end GET_CTRL_ACT;
  
  /*  %   ( ) */
  function GET_COST_READY
  (
    NRN                     in number             -- .  
  ) return                  number                -- % 
  is
    RP                      PROJECT%rowtype;      --  
    NFPDARTCL_SELF_COST     PKG_STD.TREF;         -- .   
    NCOST_FACT              PKG_STD.TNUMBER := 0; --     
    NSELF_COST_PLAN         PKG_STD.TNUMBER := 0; --   
    RSTG_SELF_COST_PLAN     TSTAGE_ARTS;          --   
    NRES                    PKG_STD.TNUMBER := 0; --   
  begin
    /*   */
    RP := GET(NRN => NRN);
    /*  .       */
    FIND_FPDARTCL_CODE(NFLAG_SMART => 1,
                       NCOMPANY    => RP.COMPANY,
                       SCODE       => SFPDARTCL_SELF_COST,
                       NRN         => NFPDARTCL_SELF_COST);
    /*   */
    for C in (select PS.RN from PROJECTSTAGE PS where PS.PRN = RP.RN)
    loop
      /*     */
      NCOST_FACT := NCOST_FACT + STAGES_GET_COST_FACT(NRN => C.RN);
      /*    */
      STAGE_ARTS_GET(NSTAGE => C.RN, NFPDARTCL => NFPDARTCL_SELF_COST, RSTAGE_ARTS => RSTG_SELF_COST_PLAN);
      if ((RSTG_SELF_COST_PLAN.COUNT = 1) and (RSTG_SELF_COST_PLAN(RSTG_SELF_COST_PLAN.LAST).NPLAN <> 0)) then
        NSELF_COST_PLAN := NSELF_COST_PLAN + RSTG_SELF_COST_PLAN(RSTG_SELF_COST_PLAN.LAST).NPLAN;
      end if;
    end loop;
    /*         */
    if ((NCOST_FACT > 0) and (NSELF_COST_PLAN > 0)) then
      /*       -  %  */
      NRES := ROUND(NCOST_FACT / NSELF_COST_PLAN * 100, 0);
      /*    ,  %   > 100,   ,   */
      if (NRES > 100) then
        NRES := 100;
      end if;
    end if;
    /*   */
    return NRES;
  end GET_COST_READY;
  
  /*   */
  procedure LIST
  (
    NPAGE_NUMBER            in number,                             --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,                             --     (0 - )
    CFILTERS                in clob,                               -- 
    CORDERS                 in clob,                               -- 
    NINCLUDE_DEF            in number,                             --       
    COUT                    out clob                               --   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NIDENT                  PKG_STD.TREF := GEN_IDENT();           --  
    RF                      PKG_P8PANELS_VISUAL.TFILTERS;          -- 
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    RCOL_VALS               PKG_P8PANELS_VISUAL.TCOL_VALS;         --   
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NECON_RESP_DP           PKG_STD.TREF;                          -- .   " "
  begin
    /*   */
    RF := PKG_P8PANELS_VISUAL.TFILTERS_FROM_XML(CFILTERS => CFILTERS);
    /*   */
    RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
    /*            */
    PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                             NPAGE_SIZE   => NPAGE_SIZE,
                                             NROW_FROM    => NROW_FROM,
                                             NROW_TO      => NROW_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCODE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDMNEMO',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNAME',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDNAME',
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNAME_USL',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDNAME_USL',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SEXPECTED_RES',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SPRJTYPE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDPROJECTTYPE',
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SEXT_CUST',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDEXT_CUST',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SGOVCNTRID',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SDOC_OSN',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_SDOC_OSN',
                                               SCAPTION   => '- (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_SDOC_OSN',
                                               SCAPTION   => '- ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SSUBDIV_RESP',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SRESPONSIBLE',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SECON_RESP',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 2);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 3);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 4);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 5);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSTATE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'CGSTATE',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DBEGPLAN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDPLANBEGFrom',
                                               SCOND_TO   => 'EDPLANBEGTo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DENDPLAN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDPLANENDFrom',
                                               SCOND_TO   => 'EDPLANENDTo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_SUM',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCURNAMES',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFIN_IN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_NFIN_IN',
                                               SCAPTION   => '  (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_NFIN_IN',
                                               SCAPTION   => '  ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFIN_OUT',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_NFIN_OUT',
                                               SCAPTION   => '  (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_NFIN_OUT',
                                               SCAPTION   => '  ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_FIN',
                                               SCAPTION   => '- (.)',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_FIN',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b> ()</b> -   ,     .<br>' ||
                                                             '<b style="color:red"> </b> -    ,        .<br>' ||
                                                             '<b style="color:green"> </b> -    ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,         .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_CONTR',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_CONTR',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -   ,      .<br>' ||
                                                             '<b style="color:red"> </b> -    ,            .<br>' ||
                                                             '<b style="color:green"> </b> -    ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,       .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_COEXEC',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_COEXEC',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -     ,      .<br>' ||
                                                             '<b style="color:red"> </b> -    ,      ' ||
                                                             TO_CHAR(NDAYS_LEFT_LIMIT) ||
                                                             ' ,       /     .<br>' ||
                                                             '<b style="color:green"> </b> -    ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,             .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_PERIOD',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_PERIOD',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -      .<br>' ||
                                                             '<b style="color:red"> </b> -    ,      ' ||
                                                             TO_CHAR(NDAYS_LEFT_LIMIT) || ' .<br>' ||
                                                             '<b style="color:green"> </b> -    ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,       .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_COST',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_COST',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -  ,       .<br>' ||
                                                             '<b style="color:red"> </b> -    ,          .<br>' ||
                                                             '<b style="color:green"> </b> -    ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,            ,  .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_ACT',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_ACT',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -   ,   ,   .<br>' ||
                                                             '<b style="color:red"> </b> -    ,   "",        "    "   .<br>' ||
                                                             '<b style="color:green"> </b> -    ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,  ,    ,    "".');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_READY',
                                               SCAPTION   => ' (%, )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCOST_READYFrom',
                                               SCOND_TO   => 'EDCOST_READYTo',
                                               BORDER     => true,
                                               BFILTER    => true);
    /*    -   */
    FIND_DOCS_PROPS_CODE(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, SCODE => SDP_SECON_RESP, NRN => NECON_RESP_DP);
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select P.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.CODE SCODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P."NAME" SNAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.NAME_USL SNAME_USL,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.EXPECTED_RES SEXPECTED_RES,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PT.CODE SPRJTYPE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       EC.AGNABBR SEXT_CUST,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       GC.CODE SGOVCNTRID,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.DOC_OSN SDOC_OSN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Contracts') || ' SLNK_UNIT_SDOC_OSN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_DOC_OSN_LNK_DOCUMENT') || '(P.RN) NLNK_DOCUMENT_SDOC_OSN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       SR.CODE SSUBDIV_RESP,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       R.AGNABBR SRESPONSIBLE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       F_DOCS_PROPS_GET_STR_VALUE(:NECON_RESP_DP, ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Projects') || ', P.RN) SECON_RESP,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P."STATE" NSTATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.BEGPLAN DBEGPLAN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.ENDPLAN DENDPLAN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.COST_SUM_BASECURR NCOST_SUM,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CN.INTCODE SCURNAMES,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_FIN_IN') || '(P.RN) NFIN_IN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Paynotes') || ' SLNK_UNIT_NFIN_IN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_NUM(NVALUE => 0) || ' NLNK_DOCUMENT_NFIN_IN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_FIN_OUT') || '(P.RN) NFIN_OUT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Paynotes') || ' SLNK_UNIT_NFIN_OUT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_NUM(NVALUE => 1) || ' NLNK_DOCUMENT_NFIN_OUT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_FIN') || '(P.RN) NCTRL_FIN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_CONTR') || '(P.RN) NCTRL_CONTR,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_COEXEC') || '(P.RN) NCTRL_COEXEC,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_PERIOD') || '(P.RN) NCTRL_PERIOD,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_COST') || '(P.RN) NCTRL_COST,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_CTRL_ACT') || '(P.RN) NCTRL_ACT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.GET_COST_READY') || '(P.RN) NCOST_READY');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from PROJECT P');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join AGNLIST EC on P.EXT_CUST = EC.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join GOVCNTRID GC on P.GOVCNTRID = GC.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join INS_DEPARTMENT SR on P.SUBDIV_RESP = SR.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join AGNLIST R on P.RESPONSIBLE = R.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PRJTYPE PT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CURNAMES CN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 where P.PRJTYPE = PT.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and P.CURNAMES = CN.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP."CATALOG" = P.CRN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP.JUR_PERS = P.JUR_PERS and UP.UNITCODE = ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Projects') || ')');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and P.RN in (select ID from COND_BROKER_IDSMART where IDENT = :NIDENT) %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '     where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      PKG_P8PANELS_VISUAL.TFILTERS_SET_QUERY(NIDENT     => NIDENT,
                                             NCOMPANY   => NCOMPANY,
                                             SUNIT      => 'Projects',
                                             SPROCEDURE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.COND'),
                                             RDATA_GRID => RDG,
                                             RFILTERS   => RF);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NECON_RESP_DP', NVALUE => NECON_RESP_DP);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => NIDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 10);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 11);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 12);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 13);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 14);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 15);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 16);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 17);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 18);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 19);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 20);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 21);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 22);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 23);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 24);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 25);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 26);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 27);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 28);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 29);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 30);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 31);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 32);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 33);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     */
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NRN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 1,
                                              BCLEAR    => true);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SCODE', ICURSOR => ICURSOR, NPOSITION => 2);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SNAME', ICURSOR => ICURSOR, NPOSITION => 3);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SNAME_USL',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 4);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SEXPECTED_RES',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 5);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SPRJTYPE', ICURSOR => ICURSOR, NPOSITION => 6);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SEXT_CUST',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 7);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SGOVCNTRID',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 8);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SDOC_OSN', ICURSOR => ICURSOR, NPOSITION => 9);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_SDOC_OSN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 10);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_SDOC_OSN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 11);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SSUBDIV_RESP',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 12);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SRESPONSIBLE',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 13);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SECON_RESP',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 14);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW => RDG_ROW, SNAME => 'NSTATE', ICURSOR => ICURSOR, NPOSITION => 15);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW      => RDG_ROW,
                                              SNAME     => 'DBEGPLAN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 16);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW      => RDG_ROW,
                                              SNAME     => 'DENDPLAN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 17);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCOST_SUM',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 18);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SCURNAMES',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 19);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW => RDG_ROW, SNAME => 'NFIN_IN', ICURSOR => ICURSOR, NPOSITION => 20);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_NFIN_IN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 21);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_NFIN_IN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 22);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NFIN_OUT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 23);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_NFIN_OUT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 24);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_NFIN_OUT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 25);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_FIN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 26);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_CONTR',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 27);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_COEXEC',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 28);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_PERIOD',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 29);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_COST',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 30);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_ACT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 31);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCOST_READY',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 32);
        /*     */
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end LIST;
  
  /*    */
  procedure GRAPH
  (
    COUT                    out clob                               --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    DFROM                   PKG_STD.TLDATE;                        --    
    DTO                     PKG_STD.TLDATE;                        --    
    DFROM_CUR               PKG_STD.TLDATE;                        --   
    DTO_CUR                 PKG_STD.TLDATE;                        --   
    SYEAR_COL_NAME          PKG_STD.TSTRING;                       --    
    SPRJ_GROUP_NAME         PKG_STD.TSTRING;                       --    
    BEXPANDED               boolean;                               --   
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
  begin
    /*       */
    select TRUNC(min(DBEGPLAN), 'mm'),
           LAST_DAY(max(DENDPLAN))
      into DFROM,
           DTO
      from (select min(P.BEGPLAN) DBEGPLAN,
                   max(P.ENDPLAN) DENDPLAN
              from PROJECT P
             where P.COMPANY = NCOMPANY
               and P.STATE in (0, 1, 4)
               and P.BEGPLAN is not null
               and P.ENDPLAN is not null
            union all
            select min(PS.BEGPLAN) DBEGPLAN,
                   max(PS.ENDPLAN) DENDPLAN
              from PROJECT      P,
                   PROJECTSTAGE PS
             where P.COMPANY = NCOMPANY
               and P.STATE in (0, 1, 4)
               and P.RN = PS.PRN
               and PS.STATE in (0, 1, 3)
               and PS.BEGPLAN is not null
               and PS.ENDPLAN is not null
               and PS.HRN is null);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE(BFIXED_HEADER => true, NFIXED_COLUMNS => 1);
    /*           */
    if ((DFROM is not null) and (DTO is not null)) then
      /*    */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NRN',
                                                 SCAPTION   => '. ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SJOB',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 NWIDTH     => 300);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SRESP',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NSTATE',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'DFROM',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'DTO',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                                 BVISIBLE   => false);    
      for Y in EXTRACT(year from DFROM) .. EXTRACT(year from DTO)
      loop
        SYEAR_COL_NAME := TO_CHAR(Y);
        if (Y = EXTRACT(year from sysdate)) then
          BEXPANDED := true;
        else
          BEXPANDED := false;
        end if;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID  => RDG,
                                                   SNAME       => SYEAR_COL_NAME,
                                                   SCAPTION    => TO_CHAR(Y),
                                                   SDATA_TYPE  => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                   BEXPANDABLE => true,
                                                   BEXPANDED   => BEXPANDED);
        for M in 1 .. 12
        loop
          DFROM_CUR := TO_DATE('01.' || LPAD(TO_CHAR(M), 2, '0') || '.' || TO_CHAR(Y), 'dd.mm.yyyy');
          DTO_CUR   := LAST_DAY(DFROM_CUR);
          if ((DFROM_CUR >= DFROM) and (DTO_CUR <= DTO)) then
            PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                       SNAME      => SYEAR_COL_NAME || '_' || TO_CHAR(M),
                                                       SCAPTION   => LPAD(TO_CHAR(M), 2, '0'),
                                                       SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                       SPARENT    => SYEAR_COL_NAME);
          end if;
        end loop;
      end loop;
      /*    */
      for PR in (select P.*
                   from PROJECT P
                  where P.COMPANY = NCOMPANY
                    and P.STATE in (0, 1, 4)
                    and P.BEGPLAN is not null
                    and P.ENDPLAN is not null
                  order by P.BEGPLAN)
      loop
        /*     */
        SPRJ_GROUP_NAME := PR.RN;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_GROUP(RDATA_GRID  => RDG,
                                                 SNAME       => SPRJ_GROUP_NAME,
                                                 SCAPTION    => PR.CODE || ' - ' || PR.NAME,
                                                 BEXPANDABLE => true,
                                                 BEXPANDED   => true);
        /*    */
        for ST in (select PS.RN NRN,
                          trim(PS.NUMB) || ' - ' || PS.NAME SJOB,
                          COALESCE(AG.AGNABBR, IND.NAME) SRESP,
                          PS.STATE NSTATE,
                          PS.BEGPLAN DFROM,
                          PS.ENDPLAN DTO
                     from PROJECTSTAGE   PS,
                          AGNLIST        AG,
                          INS_DEPARTMENT IND
                    where PS.PRN = PR.RN
                      and PS.STATE in (0, 1, 3)
                      and PS.BEGPLAN is not null
                      and PS.ENDPLAN is not null
                      and PS.HRN is null
                      and PS.RESPONSIBLE = AG.RN(+)
                      and PS.SUBDIV_RESP = IND.RN(+)
                    order by PS.NUMB)
        loop
          /*   */
          RDG_ROW := PKG_P8PANELS_VISUAL.TROW_MAKE(SGROUP => SPRJ_GROUP_NAME);
          /*     */
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => ST.NRN);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SJOB', SVALUE => ST.SJOB);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SRESP', SVALUE => ST.SRESP);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATE', NVALUE => ST.NSTATE);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'DFROM', DVALUE => ST.DFROM);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'DTO', DVALUE => ST.DTO);
          /*     */
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
        end loop;
      end loop;
    end if;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end GRAPH;
  
  /*     - " " */
  procedure CHART_PROBLEMS
  (
    COUT                    out clob                                           --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY();             --  
    RCH                     PKG_P8PANELS_VISUAL.TCHART;                        -- 
    RCH_DS                  PKG_P8PANELS_VISUAL.TCHART_DATASET;                --  
    RATTR_VALS              PKG_P8PANELS_VISUAL.TCHART_DATASET_ITEM_ATTR_VALS; --    
  begin
    /*    */
    RCH := PKG_P8PANELS_VISUAL.TCHART_MAKE(STYPE     => PKG_P8PANELS_VISUAL.SCHART_TYPE_BAR,
                                           STITLE    => ' ',
                                           SLGND_POS => PKG_P8PANELS_VISUAL.SCHART_LGND_POS_TOP);
    /*    */
    RCH_DS := PKG_P8PANELS_VISUAL.TCHART_DATASET_MAKE(SCAPTION => '-   ');
    /*       */
    for C in (select D.SFILTER,
                     D.SNAME,
                     D.NCOUNT
                from (select 'NCTRL_FIN' SFILTER,
                             '' SNAME,
                             count(P.RN) NCOUNT
                        from PROJECT P
                       where P.COMPANY = NCOMPANY 
                         and PKG_P8PANELS_PROJECTS.GET_CTRL_FIN(P.RN) = 1
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = P.JUR_PERS
                                 and UP.UNITCODE = 'Projects')
                      union all
                      select 'NCTRL_CONTR' SFILTER,
                             '' SNAME,
                             count(P.RN) NCOUNT
                        from PROJECT P
                       where P.COMPANY = NCOMPANY 
                         and PKG_P8PANELS_PROJECTS.GET_CTRL_CONTR(P.RN) = 1
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = P.JUR_PERS
                                 and UP.UNITCODE = 'Projects')
                      union all
                      select 'NCTRL_COEXEC' SFILTER,
                             '' SNAME,
                             count(P.RN) NCOUNT
                        from PROJECT P
                       where P.COMPANY = NCOMPANY 
                         and PKG_P8PANELS_PROJECTS.GET_CTRL_COEXEC(P.RN) = 1
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = P.JUR_PERS
                                 and UP.UNITCODE = 'Projects')
                      union all
                      select 'NCTRL_PERIOD' SFILTER,
                             '' SNAME,
                             count(P.RN) NCOUNT
                        from PROJECT P
                       where P.COMPANY = NCOMPANY 
                         and PKG_P8PANELS_PROJECTS.GET_CTRL_PERIOD(P.RN) = 1
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = P.JUR_PERS
                                 and UP.UNITCODE = 'Projects')
                      union all
                      select 'NCTRL_COST' SFILTER,
                             '' SNAME,
                             count(P.RN) NCOUNT
                        from PROJECT P
                       where P.COMPANY = NCOMPANY 
                         and PKG_P8PANELS_PROJECTS.GET_CTRL_COST(P.RN) = 1
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = P.JUR_PERS
                                 and UP.UNITCODE = 'Projects')
                      union all
                      select 'NCTRL_ACT' SFILTER,
                             '' SNAME,
                             count(P.RN) NCOUNT
                        from PROJECT P
                       where P.COMPANY = NCOMPANY 
                         and PKG_P8PANELS_PROJECTS.GET_CTRL_ACT(P.RN) = 1
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = P.JUR_PERS
                                 and UP.UNITCODE = 'Projects')) D
               order by D.NCOUNT desc)
    loop
      /*    */
      if (C.NCOUNT > 0) then
        /*     */
        PKG_P8PANELS_VISUAL.TCHART_ADD_LABEL(RCHART => RCH, SLABEL => C.SNAME);
        /*      */
        PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                           SNAME      => 'SFILTER',
                                                           SVALUE     => C.SFILTER,
                                                           BCLEAR     => true);
        PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                           SNAME      => 'SFILTER_VALUE',
                                                           SVALUE     => '1');
        PKG_P8PANELS_VISUAL.TCHART_DATASET_ADD_ITEM(RDATASET => RCH_DS, NVALUE => C.NCOUNT, RATTR_VALS => RATTR_VALS);
      end if;
    end loop;
    /*      */
    PKG_P8PANELS_VISUAL.TCHART_ADD_DATASET(RCHART => RCH, RDATASET => RCH_DS);
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TCHART_TO_XML(RCHART => RCH, NINCLUDE_DEF => 1);
  end CHART_PROBLEMS;
  
  /*     - " " */
  procedure CHART_CUSTOMERS
  (
    COUT                    out clob                                           --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY();             --  
    RCH                     PKG_P8PANELS_VISUAL.TCHART;                        -- 
    RCH_DS                  PKG_P8PANELS_VISUAL.TCHART_DATASET;                --  
    RATTR_VALS              PKG_P8PANELS_VISUAL.TCHART_DATASET_ITEM_ATTR_VALS; --    
  begin
    /*    */
    RCH := PKG_P8PANELS_VISUAL.TCHART_MAKE(STYPE     => PKG_P8PANELS_VISUAL.SCHART_TYPE_PIE,
                                           STITLE    => ' ',
                                           SLGND_POS => PKG_P8PANELS_VISUAL.SCHART_LGND_POS_RIGHT);
    /*    */
    RCH_DS := PKG_P8PANELS_VISUAL.TCHART_DATASET_MAKE(SCAPTION => ' ');
    /*  ,     */
    for C in (select D.SEXT_CUST,
                     D.NSUM
                from (select EC.AGNABBR SEXT_CUST,
                             sum(P.COST_SUM_BASECURR) NSUM
                        from PROJECT P,
                             AGNLIST EC
                       where P.COMPANY = NCOMPANY
                         and P.EXT_CUST = EC.RN
                       group by EC.AGNABBR
                       order by 2 desc) D
               where ROWNUM <= 5)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TCHART_ADD_LABEL(RCHART => RCH, SLABEL => C.SEXT_CUST);
      /*      */
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                         SNAME      => 'SFILTER',
                                                         SVALUE     => 'SEXT_CUST',
                                                         BCLEAR     => true);
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                         SNAME      => 'SFILTER_VALUE',
                                                         SVALUE     => C.SEXT_CUST);
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ADD_ITEM(RDATASET => RCH_DS, NVALUE => C.NSUM, RATTR_VALS => RATTR_VALS);
    end loop;
    /*      */
    PKG_P8PANELS_VISUAL.TCHART_ADD_DATASET(RCHART => RCH, RDATASET => RCH_DS);
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TCHART_TO_XML(RCHART => RCH, NINCLUDE_DEF => 1);
  end CHART_CUSTOMERS;
  
  /*     - "  " */
  procedure CHART_FCCOSTNOTES
  (
    COUT                    out clob                                           --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY();             --  
    RCH                     PKG_P8PANELS_VISUAL.TCHART;                        -- 
    RCH_DS                  PKG_P8PANELS_VISUAL.TCHART_DATASET;                --  
    RATTR_VALS              PKG_P8PANELS_VISUAL.TCHART_DATASET_ITEM_ATTR_VALS; --    
    NYEAR                   PKG_STD.TNUMBER;                                   --  
    NSUM                    PKG_STD.TNUMBER;                                   --     
  begin
    NYEAR := TO_NUMBER(TO_CHAR(sysdate, 'yyyy'));
    /*    */
    RCH := PKG_P8PANELS_VISUAL.TCHART_MAKE(STYPE     => PKG_P8PANELS_VISUAL.SCHART_TYPE_LINE,
                                           STITLE    => '    ' || TO_CHAR(NYEAR) || ' ',
                                           SLGND_POS => PKG_P8PANELS_VISUAL.SCHART_LGND_POS_TOP);
    /*    */
    RCH_DS := PKG_P8PANELS_VISUAL.TCHART_DATASET_MAKE(SCAPTION => '  (. .)');
    /*    */
    for I in 1 .. 12
    loop
      /*    ,    */
      select COALESCE(sum(CN.COST_BSUM) / 1000, 0)
        into NSUM
        from FCCOSTNOTES CN
       where CN.COMPANY = NCOMPANY
         and TO_NUMBER(TO_CHAR(CN.COST_DATE, 'mm')) = I
         and TO_NUMBER(TO_CHAR(CN.COST_DATE, 'yyyy')) = NYEAR
         and exists (select null from V_USERPRIV UP where UP.CATALOG = CN.CRN)
         and CN.PROD_ORDER in (select PS.FACEACC
                                 from PROJECTSTAGE PS
                                where PS.COMPANY = CN.COMPANY
                                  and exists (select null from V_USERPRIV UP where UP.CATALOG = PS.CRN)
                                  and exists (select null
                                         from V_USERPRIV UP
                                        where UP.JUR_PERS = PS.JUR_PERS
                                          and UP.UNITCODE = 'Projects'));
      /*     */
      PKG_P8PANELS_VISUAL.TCHART_ADD_LABEL(RCHART => RCH, SLABEL => F_GET_MONTH(NVALUE => I));
      /*      */
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS,
                                                         SNAME      => 'SUNITCODE',
                                                         SVALUE     => 'CostNotes',
                                                         BCLEAR     => true);
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS, SNAME => 'NYEAR', SVALUE => TO_CHAR(NYEAR));
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ITM_ATTR_VL_ADD(RATTR_VALS => RATTR_VALS, SNAME => 'NMONTH', SVALUE => TO_CHAR(I));
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ADD_ITEM(RDATASET => RCH_DS, NVALUE => NSUM, RATTR_VALS => RATTR_VALS);
    end loop;
    /*      */
    PKG_P8PANELS_VISUAL.TCHART_ADD_DATASET(RCHART => RCH, RDATASET => RCH_DS);
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TCHART_TO_XML(RCHART => RCH, NINCLUDE_DEF => 1);
  end CHART_FCCOSTNOTES;
  
  /*     - "  " (      ) */
  procedure CHART_FCCOSTNOTES_SELECT_COST
  (
    NYEAR                   in number,                             -- 
    NMONTH                  in number,                             -- 
    NIDENT                  out number                             --    (  , null -  )
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NSELECTLIST             PKG_STD.TREF;                          -- .     
  begin
    /*     */
    for C in (select CN.COMPANY,
                     CN.RN
                from FCCOSTNOTES CN
               where CN.COMPANY = NCOMPANY
                 and TO_NUMBER(TO_CHAR(CN.COST_DATE, 'mm')) = NMONTH
                 and TO_NUMBER(TO_CHAR(CN.COST_DATE, 'yyyy')) = NYEAR
                 and exists
               (select null from V_USERPRIV UP where UP.CATALOG = CN.CRN)
                 and CN.PROD_ORDER in (select PS.FACEACC
                                         from PROJECTSTAGE PS
                                        where PS.COMPANY = CN.COMPANY
                                          and exists (select null from V_USERPRIV UP where UP.CATALOG = PS.CRN)
                                          and exists (select null
                                                 from V_USERPRIV UP
                                                where UP.JUR_PERS = PS.JUR_PERS
                                                  and UP.UNITCODE = 'Projects')))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'CostNotes',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end CHART_FCCOSTNOTES_SELECT_COST;
  
  /*     */
  function STAGES_GET
  (
    NRN                     in number             -- .   
  ) return                  PROJECTSTAGE%rowtype  --   
  is
    RRES                    PROJECTSTAGE%rowtype; --   
  begin
    select PS.* into RRES from PROJECTSTAGE PS where PS.RN = NRN;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NRN, SUNIT_TABLE => 'PROJECTSTAGE');
  end STAGES_GET;
  
  /*    */
  procedure STAGES_COND
  as
  begin
    /*    */
    PKG_COND_BROKER.SET_TABLE(STABLE_NAME => 'PROJECTSTAGE');
    /*  */
    PKG_COND_BROKER.SET_COLUMN_PRN(SCOLUMN_NAME => 'PRN');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'NUMB', SCONDITION_NAME => 'EDNUMB');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'NAME', SCONDITION_NAME => 'EDNAME');
    /*    */
    PKG_COND_BROKER.ADD_CONDITION_BETWEEN(SCOLUMN_NAME         => 'BEGPLAN',
                                          SCONDITION_NAME_FROM => 'EDPLANBEGFrom',
                                          SCONDITION_NAME_TO   => 'EDPLANBEGTo');
    /*    */
    PKG_COND_BROKER.ADD_CONDITION_BETWEEN(SCOLUMN_NAME         => 'ENDPLAN',
                                          SCONDITION_NAME_FROM => 'EDPLANENDFrom',
                                          SCONDITION_NAME_TO   => 'EDPLANENDTo');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_ENUM(SCOLUMN_NAME => 'STATE', SCONDITION_NAME => 'CGSTATE');
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_FIN') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_FIN') || '(RN) = :EDCTRL_FIN');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_FIN',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_FIN'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_CONTR') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_CONTR') || '(RN) = :EDCTRL_CONTR');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_CONTR',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_CONTR'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_COEXEC') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_COEXEC') || '(RN) = :EDCTRL_COEXEC');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_COEXEC',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_COEXEC'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_PERIOD') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_PERIOD') || '(RN) = :EDCTRL_PERIOD');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_PERIOD',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_PERIOD'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_COST') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_COST') || '(RN) = :EDCTRL_COST');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_COST',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_COST'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_ACT') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_ACT') || '(RN) = :EDCTRL_ACT');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_ACT',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_ACT'));
    end if;
    /*  (%,  ) */
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYFrom') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYTo') = 0)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_COST_READY') || '(RN) >= :EDCOST_READYFrom');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYFrom',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYFrom'));
    end if;
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYTo') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYFrom') = 0)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_COST_READY') || '(RN) <= :EDCOST_READYTo');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYTo',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYTo'));
    end if;
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYFrom') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCOST_READYTo') = 1)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_COST_READY') || '(RN) between :EDCOST_READYFrom and :EDCOST_READYTo');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYFrom',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYFrom'));
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCOST_READYTo',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCOST_READYTo'));
    end if;
  end STAGES_COND;
  
  /*      */
  procedure STAGES_SELECT_FIN
  (
    NPRN                    in number := null, -- .   (null -    )
    NRN                     in number := null, -- .    (null -    )
    NDIRECTION              in number,         --  (0 - , 1 - )
    NIDENT                  out number         --    (  , null -  )
  )
  is
    NSELECTLIST             PKG_STD.TREF;      -- .     
  begin
    /*   */
    for C in (select PN.COMPANY,
                     PN.RN
                from PAYNOTES PN,
                     DICTOPER O
               where PN.COMPANY in (select PS.COMPANY
                                      from PROJECTSTAGE PS
                                     where ((NRN is null) or ((NRN is not null) and (PS.RN = NRN)))
                                       and ((NPRN is null) or ((NPRN is not null) and (PS.PRN = NPRN))))
                 and PN.SIGNPLAN = 0
                 and PN.FINOPER = O.RN
                 and O.TYPOPER_DIRECT = NDIRECTION
                 and exists (select PNC.RN
                        from PAYNOTESCLC  PNC,
                             PROJECTSTAGE PS
                       where PNC.PRN = PN.RN
                         and PNC.FACEACCOUNT = PS.FACEACC
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = PS.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = PS.JUR_PERS
                                 and UP.UNITCODE = 'Projects')
                         and ((NRN is null) or ((NRN is not null) and (PS.RN = NRN)))
                         and ((NPRN is null) or ((NPRN is not null) and (PS.PRN = NPRN))))
                 and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = PN.CRN
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = PN.CRN
                         and UP.AUTHID = UTILIZER)
                 and exists (select /*+ INDEX(UP I_USERPRIV_JUR_PERS_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.JUR_PERS = PN.JUR_PERS
                         and UP.UNITCODE = 'PayNotes'
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_JUR_PERS_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.JUR_PERS = PN.JUR_PERS
                         and UP.UNITCODE = 'PayNotes'
                         and UP.AUTHID = UTILIZER))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'PayNotes',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGES_SELECT_FIN;
  
  /*      */
  function STAGES_GET_FIN
  (
    NRN                     in number,       -- .   
    NDIRECTION              in number        --  (0 - , 1 - )
  ) return                  number           --   
  is
    NRES                    PKG_STD.TNUMBER; --   
  begin
    /*           */
    select COALESCE(sum(PN.PAY_SUM * (PN.CURR_RATE_BASE / PN.CURR_RATE)), 0)
      into NRES
      from PAYNOTES PN,
           DICTOPER O
     where PN.COMPANY in (select PS.COMPANY from PROJECTSTAGE PS where PS.RN = NRN)
       and PN.SIGNPLAN = 0
       and PN.FINOPER = O.RN
       and O.TYPOPER_DIRECT = NDIRECTION
       and exists (select PNC.RN
              from PAYNOTESCLC  PNC,
                   PROJECTSTAGE PS
             where PNC.PRN = PN.RN
               and PNC.FACEACCOUNT = PS.FACEACC
               and PS.RN = NRN);
    /*   */
    return NRES;
  end STAGES_GET_FIN;
  
  /*       */
  function STAGES_GET_FIN_IN
  (
    NRN                     in number   -- .   
  ) return                  number      --    
  is
  begin
    return STAGES_GET_FIN(NRN => NRN, NDIRECTION => 0);
  end STAGES_GET_FIN_IN;

  /*       */
  function STAGES_GET_FIN_OUT
  (
    NRN                     in number   -- .   
  ) return                  number      --    
  is
  begin
    return STAGES_GET_FIN(NRN => NRN, NDIRECTION => 1);
  end STAGES_GET_FIN_OUT;

  /*      */
  function STAGES_GET_CTRL_FIN
  (
    NRN                     in number             -- .   
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NCONTR_CTRL             PKG_STD.TNUMBER;      --   
    NCNT_CONTR              PKG_STD.TNUMBER := 0; --   
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  ""  
  begin
    /*    */
    for C in (select PSPF.RN from PROJECTSTAGEPF PSPF where PSPF.PRN = NRN)
    loop
      /*    */
      NCNT_CONTR := NCNT_CONTR + 1;
      /*    */
      NCONTR_CTRL := STAGE_CONTRACTS_GET_CTRL_FIN(NPROJECTSTAGEPF => C.RN);
      /*   "" */
      if (NCONTR_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NCONTR_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_CONTR) then
      return null;
    end if;
    /*    -   */
    if (NCNT_CONTR > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end STAGES_GET_CTRL_FIN;

  /*      */
  function STAGES_GET_CTRL_CONTR
  (
    NRN                     in number             -- .   
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    RSTAGE_ARTS             TSTAGE_ARTS;          --      
    NCNT_NULL               PKG_STD.TNUMBER := 0; --     
  begin
    /*       */
    STAGE_ARTS_GET(NSTAGE => NRN, NINC_CONTR => 1, RSTAGE_ARTS => RSTAGE_ARTS);
    /*    -   */
    if ((RSTAGE_ARTS is not null) and (RSTAGE_ARTS.COUNT > 0)) then
      for I in RSTAGE_ARTS.FIRST .. RSTAGE_ARTS.LAST
      loop
        if (RSTAGE_ARTS(I).NCTRL_CONTR is null) then
          NCNT_NULL := NCNT_NULL + 1;
        end if;
        /*       */
        if (RSTAGE_ARTS(I).NCTRL_CONTR = 1) then
          /*      */
          return 1;
        end if;
      end loop;
      /*        -      */
      if (NCNT_NULL = RSTAGE_ARTS.COUNT) then
        return null;
      end if;
      /*    -   */
      return 0;
    else
      /*     */
      return null;
    end if;
  end STAGES_GET_CTRL_CONTR;

  /*      */
  function STAGES_GET_CTRL_COEXEC
  (
    NRN                     in number             -- .   
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    NCONTR_CTRL             PKG_STD.TNUMBER;      --   
    NCNT_CONTR              PKG_STD.TNUMBER := 0; --   
    NCNT_NULL               PKG_STD.TNUMBER := 0; --  ""  
  begin
    /*    */
    for C in (select PSPF.RN from PROJECTSTAGEPF PSPF where PSPF.PRN = NRN)
    loop
      /*    */
      NCNT_CONTR := NCNT_CONTR + 1;
      /*    */
      NCONTR_CTRL := STAGE_CONTRACTS_GET_CTRL_COEXE(NPROJECTSTAGEPF => C.RN);
      /*   "" */
      if (NCONTR_CTRL is null) then
        NCNT_NULL := NCNT_NULL + 1;
      end if;
      /*      -      */
      if (NCONTR_CTRL = 1) then
        return 1;
      end if;
    end loop;
    /*        -      */
    if (NCNT_NULL = NCNT_CONTR) then
      return null;
    end if;
    /*    -   */
    if (NCNT_CONTR > 0) then
      return 0;
    else
      /*      */
      return null;
    end if;
  end STAGES_GET_CTRL_COEXEC;
  
  /*      */
  function STAGES_GET_CTRL_PERIOD
  (
    NRN                     in number        -- .   
  ) return                  number           --  (null -  , 0 -  , 1 -  )
  is
    NDAYS_LEFT              PKG_STD.TNUMBER; --     
  begin
    /*      */
    NDAYS_LEFT := STAGES_GET_DAYS_LEFT(NRN => NRN);
    /*       -      */
    if (NDAYS_LEFT is null) then
      return null;
    end if;
    /*      */
    if (NDAYS_LEFT < NDAYS_LEFT_LIMIT) then
      /*      */
      return 1;
    else
      /*   */
      return 0;
    end if;
  end STAGES_GET_CTRL_PERIOD;
  
  /*      */
  function STAGES_GET_CTRL_COST
  (
    NRN                     in number             -- .   
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    RSTAGE_ARTS             TSTAGE_ARTS;          --      
    NCNT_NULL               PKG_STD.TNUMBER := 0; --     
  begin
    /*       */
    STAGE_ARTS_GET(NSTAGE => NRN, NINC_COST => 1, RSTAGE_ARTS => RSTAGE_ARTS);
    /*    -   */
    if ((RSTAGE_ARTS is not null) and (RSTAGE_ARTS.COUNT > 0)) then
      for I in RSTAGE_ARTS.FIRST .. RSTAGE_ARTS.LAST
      loop
        if (RSTAGE_ARTS(I).NCTRL_COST is null) then
          NCNT_NULL := NCNT_NULL + 1;
        end if;
        /*       */
        if (RSTAGE_ARTS(I).NCTRL_COST = 1) then
          /*      */
          return 1;
        end if;
      end loop;
      /*        -      */
      if (NCNT_NULL = RSTAGE_ARTS.COUNT) then
        return null;
      end if;
      /*    -   */
      return 0;
    else
      /*     */
      return null;
    end if;
  end STAGES_GET_CTRL_COST;
  
  /*      */
  function STAGES_GET_CTRL_ACT
  (
    NRN                     in number             -- .   
  ) return                  number                --  (null -  , 0 -  , 1 -  )
  is
    RPS                     PROJECTSTAGE%rowtype; --   
    NTRANSINVCUST           PKG_STD.TREF;         -- .  ,  
  begin
    /*    */
    RPS := STAGES_GET(NRN => NRN);
    /*      "",    */
    if (RPS.STATE <> 2) then
      return null;
    end if;
    /*     */
    begin
      select T.RN
        into NTRANSINVCUST
        from TRANSINVCUST T
       where T.FACEACC = RPS.FACEACCCUST
         and T.STATUS = 1
         and exists (select null
                from TRINVCUSTCLC TC
               where TC.PRN in (select TS.RN from TRANSINVCUSTSPECS TS where TS.PRN = T.RN)
                 and TC.FACEACCOUNT = RPS.FACEACC);
    exception
      when NO_DATA_FOUND then
        null;
    end;
    /*   ,   "",       -   */
    if (NTRANSINVCUST is null) then
      return 1;
    end if;
    /*    -   */
    return 0;
  end STAGES_GET_CTRL_ACT;
  
  /*       */
  function STAGES_GET_DAYS_LEFT
  (
    NRN                     in number             -- .   
  ) return                  number                --   (null -  )
  is
    RSTG                    PROJECTSTAGE%rowtype; --  
  begin
    /*   */
    RSTG := STAGES_GET(NRN => NRN);
    /*    */
    if (RSTG.ENDPLAN is not null) then
      return ROUND(RSTG.ENDPLAN - sysdate);
    else
      return null;
    end if;
  end STAGES_GET_DAYS_LEFT;
  
  /*       */
  procedure STAGES_SELECT_COST_FACT
  (
    NRN                     in number,  -- .   
    NIDENT                  out number  --    (  , null -  )
  )
  is
  begin
    STAGE_ARTS_SELECT_COST_FACT(NSTAGE => NRN, NFINFLOW_TYPE => 2, NIDENT => NIDENT);
  end STAGES_SELECT_COST_FACT;
  
  /*       */
  function STAGES_GET_COST_FACT
  (
    NRN                     in number   -- .   
  ) return                  number      --   
  is
  begin
    return STAGE_ARTS_GET_COST_FACT(NSTAGE => NRN, NFINFLOW_TYPE => 2);
  end STAGES_GET_COST_FACT;
    
  /*          */
  procedure STAGES_SELECT_SUMM_REALIZ
  (
    NRN                     in number,            -- .   
    NIDENT                  out number            --    (  , null -  )
  )
  is
    RSTG                    PROJECTSTAGE%rowtype; --  
    NSELECTLIST             PKG_STD.TREF;         -- .     
  begin
    /*   */
    RSTG := STAGES_GET(NRN => NRN);
    /*       */
    for C in (select T.COMPANY,
                     T.RN
                from TRANSINVCUST T
               where T.STATUS = 1
                 and T.COMPANY = RSTG.COMPANY
                 and T.FACEACC = RSTG.FACEACCCUST
                 and exists (select TC.RN
                        from TRANSINVCUSTSPECS TS,
                             TRINVCUSTCLC      TC
                       where TS.PRN = T.RN
                         and TC.PRN = TS.RN
                         and TC.FACEACCOUNT = RSTG.FACEACC
                         and exists (select null from V_USERPRIV UP where UP.CATALOG = RSTG.CRN)
                         and exists (select null
                                from V_USERPRIV UP
                               where UP.JUR_PERS = RSTG.JUR_PERS
                                 and UP.UNITCODE = 'Projects'))
                 and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = T.CRN
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = T.CRN
                         and UP.AUTHID = UTILIZER))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'GoodsTransInvoicesToConsumers',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGES_SELECT_SUMM_REALIZ;
  
  /*      */
  function STAGES_GET_SUMM_REALIZ
  (
    NRN                     in number,  -- .   
    NFPDARTCL_REALIZ        in number   -- .     
  ) return                  number      --  
  is
  begin
    if (NFPDARTCL_REALIZ is not null) then
      return STAGE_ARTS_GET_COST_FACT(NSTAGE => NRN, NFPDARTCL => NFPDARTCL_REALIZ);
    else
      return 0;
    end if;
  end STAGES_GET_SUMM_REALIZ;
    
  /*  %    ( ) */
  function STAGES_GET_COST_READY
  (
    NRN                     in number             -- .   
  ) return                  number                -- % 
  is
    RSTG                    PROJECTSTAGE%rowtype; --  
    NFPDARTCL_SELF_COST     PKG_STD.TREF;         -- .   
    NCOST_FACT              PKG_STD.TNUMBER;      --   
    RSELF_COST_PLAN         TSTAGE_ARTS;          --  
    NRES                    PKG_STD.TNUMBER := 0; --   
  begin
    /*   */
    RSTG := STAGES_GET(NRN => NRN);
    /*  .       */
    FIND_FPDARTCL_CODE(NFLAG_SMART => 1,
                       NCOMPANY    => RSTG.COMPANY,
                       SCODE       => SFPDARTCL_SELF_COST,
                       NRN         => NFPDARTCL_SELF_COST);
    /*     */
    NCOST_FACT := STAGES_GET_COST_FACT(NRN => RSTG.RN);
    /*    */
    STAGE_ARTS_GET(NSTAGE => RSTG.RN, NFPDARTCL => NFPDARTCL_SELF_COST, RSTAGE_ARTS => RSELF_COST_PLAN);
    /*          */
    if ((NCOST_FACT > 0) and (RSELF_COST_PLAN.COUNT = 1) and (RSELF_COST_PLAN(RSELF_COST_PLAN.LAST).NPLAN <> 0)) then
      /*       -  %  */
      NRES := ROUND(NCOST_FACT / RSELF_COST_PLAN(RSELF_COST_PLAN.LAST).NPLAN * 100, 0);
      /*    ,  %   > 100,   ,   */
      if (NRES > 100) then
        NRES := 100;
      end if;
    end if;
    /*   */
    return NRES;
  end STAGES_GET_COST_READY;
  
  /*   */
  procedure STAGES_LIST
  (
    NPRN                    in number,                             -- .  
    NPAGE_NUMBER            in number,                             --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,                             --     (0 - )
    CFILTERS                in clob,                               -- 
    CORDERS                 in clob,                               -- 
    NINCLUDE_DEF            in number,                             --       
    COUT                    out clob                               --   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NIDENT                  PKG_STD.TREF := GEN_IDENT();           --  
    RF                      PKG_P8PANELS_VISUAL.TFILTERS;          -- 
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    RCOL_VALS               PKG_P8PANELS_VISUAL.TCOL_VALS;         --   
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    NFPDARTCL_REALIZ        PKG_STD.TREF;                          -- .     
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NCOST_FACT              PKG_STD.TNUMBER;                       --      
    NSUMM_REALIZ            PKG_STD.TNUMBER;                       --     
    NSUMM_INCOME            PKG_STD.TNUMBER;                       --     
    NINCOME_PRC             PKG_STD.TNUMBER;                       --     
  begin
    /*  .       */
    FIND_FPDARTCL_CODE(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, SCODE => SFPDARTCL_REALIZ, NRN => NFPDARTCL_REALIZ);
    /*   */
    RF := PKG_P8PANELS_VISUAL.TFILTERS_FROM_XML(CFILTERS => CFILTERS);
    /*   */
    RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
    /*            */
    PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                             NPAGE_SIZE   => NPAGE_SIZE,
                                             NROW_FROM    => NROW_FROM,
                                             NROW_TO      => NROW_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNUMB',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDNUMB',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNAME',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDNAME',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SEXPECTED_RES',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SFACEACC',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 2);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 3);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 4);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 5);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSTATE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'CGSTATE',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DBEGPLAN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDPLANBEGFrom',
                                               SCOND_TO   => 'EDPLANBEGTo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DENDPLAN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDPLANENDFrom',
                                               SCOND_TO   => 'EDPLANENDTo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_SUM',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCURNAMES',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFIN_IN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_NFIN_IN',
                                               SCAPTION   => '  (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_NFIN_IN',
                                               SCAPTION   => '  ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFIN_OUT',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_NFIN_OUT',
                                               SCAPTION   => '  (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_NFIN_OUT',
                                               SCAPTION   => '  ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_FIN',
                                               SCAPTION   => '- (.)',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_FIN',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b> ()</b> -   ,    .<br>' ||
                                                             '<b style="color:red"> </b> -     ,        .<br>' ||
                                                             '<b style="color:green"> </b> -     ,  .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,         .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_CONTR',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_CONTR',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -   ,      .<br>' ||
                                                             '<b style="color:red"> </b> -    ,   ,         .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,            .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_COEXEC',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_COEXEC',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -     ,      .<br>' ||
                                                             '<b style="color:red"> </b> -      ' ||
                                                             TO_CHAR(NDAYS_LEFT_LIMIT) ||
                                                             ' ,       /      .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,             .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NDAYS_LEFT',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_PERIOD',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_PERIOD',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -      .<br>' ||
                                                             '<b style="color:red"> </b> -      ' ||
                                                             TO_CHAR(NDAYS_LEFT_LIMIT) || ' .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,       .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_FACT',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_NCOST_FACT',
                                               SCAPTION   => '   (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_NCOST_FACT',
                                               SCAPTION   => '   ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSUMM_REALIZ',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_NSUMM_REALIZ',
                                               SCAPTION   => '  (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_NSUMM_REALIZ',
                                               SCAPTION   => '  ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSUMM_INCOME',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NINCOME_PRC',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_COST',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_COST',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -  ,       .<br>' ||
                                                             '<b style="color:red"> </b> -          .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,            ,  .');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_ACT',
                                               SCAPTION   => '-',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_ACT',
                                               BORDER     => true,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -   ,   ,   .<br>' ||
                                                             '<b style="color:red"> </b> -    "",        "    "   .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,  ,     ,    "".');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_READY',
                                               SCAPTION   => ' (%, )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCOST_READYFrom',
                                               SCOND_TO   => 'EDCOST_READYTo',
                                               BORDER     => true,
                                               BFILTER    => true);
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select PS.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS.NUMB SNUMB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS."NAME" SNAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS.EXPECTED_RES SEXPECTED_RES,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       FAC.NUMB SFACEACC,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS."STATE" NSTATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS.BEGPLAN DBEGPLAN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS.ENDPLAN DENDPLAN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PS.COST_SUM_BASECURR NCOST_SUM,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CN.INTCODE SCURNAMES,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_FIN_IN') || '(PS.RN) NFIN_IN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Paynotes') || ' SLNK_UNIT_NFIN_IN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_NUM(NVALUE => 0) || ' NLNK_DOCUMENT_NFIN_IN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_FIN_OUT') || '(PS.RN) NFIN_OUT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Paynotes') || ' SLNK_UNIT_NFIN_OUT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_NUM(NVALUE => 1) || ' NLNK_DOCUMENT_NFIN_OUT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_FIN') || '(PS.RN) NCTRL_FIN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_CONTR') || '(PS.RN) NCTRL_CONTR,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_COEXEC') || '(PS.RN) NCTRL_COEXEC,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_DAYS_LEFT') || '(PS.RN) NDAYS_LEFT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_PERIOD') || '(PS.RN) NCTRL_PERIOD,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_COST_FACT') || '(PS.RN) NCOST_FACT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'CostNotes') || ' SLNK_UNIT_NCOST_FACT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_NUM(NVALUE => 1) || ' NLNK_DOCUMENT_NCOST_FACT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_SUMM_REALIZ') || '(PS.RN, :NFPDARTCL_REALIZ) NSUMM_REALIZ,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'GoodsTransInvoicesToConsumers') || ' SLNK_UNIT_NSUMM_REALIZ,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_NUM(NVALUE => 1) || ' NLNK_DOCUMENT_NSUMM_REALIZ,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_COST') || '(PS.RN) NCTRL_COST,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_CTRL_ACT') || '(PS.RN) NCTRL_ACT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_GET_COST_READY') || '(PS.RN) NCOST_READY');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from PROJECTSTAGE PS');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join FACEACC FAC on PS.FACEACC = FAC.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PROJECT P,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CURNAMES CN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 where PS.PRN = P.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and P.CURNAMES = CN.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP."CATALOG" = PS.CRN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP.JUR_PERS = PS.JUR_PERS and UP.UNITCODE = ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Projects') || ')');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and PS.RN in (select ID from COND_BROKER_IDSMART where IDENT = :NIDENT) %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      PKG_P8PANELS_VISUAL.TFILTERS_SET_QUERY(NIDENT     => NIDENT,
                                             NCOMPANY   => NCOMPANY,
                                             NPARENT    => NPRN,
                                             SUNIT      => 'ProjectsStages',
                                             SPROCEDURE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGES_COND'),
                                             RDATA_GRID => RDG,
                                             RFILTERS   => RF);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => NIDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NFPDARTCL_REALIZ', NVALUE => NFPDARTCL_REALIZ);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 10);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 11);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 12);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 13);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 14);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 15);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 16);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 17);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 18);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 19);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 20);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 21);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 22);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 23);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 24);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 25);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 26);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 27);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 28);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 29);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 30);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 31);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     */
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NRN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 1,
                                              BCLEAR    => true);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SNUMB', ICURSOR => ICURSOR, NPOSITION => 2);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SNAME', ICURSOR => ICURSOR, NPOSITION => 3);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SEXPECTED_RES',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 4);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SFACEACC', ICURSOR => ICURSOR, NPOSITION => 5);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW => RDG_ROW, SNAME => 'NSTATE', ICURSOR => ICURSOR, NPOSITION => 6);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW => RDG_ROW, SNAME => 'DBEGPLAN', ICURSOR => ICURSOR, NPOSITION => 7);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW => RDG_ROW, SNAME => 'DENDPLAN', ICURSOR => ICURSOR, NPOSITION => 8);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCOST_SUM',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 9);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SCURNAMES',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 10);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW => RDG_ROW, SNAME => 'NFIN_IN', ICURSOR => ICURSOR, NPOSITION => 11);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_NFIN_IN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 12);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_NFIN_IN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 13);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NFIN_OUT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 14);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_NFIN_OUT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 15);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_NFIN_OUT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 16);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_FIN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 17);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_CONTR',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 18);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_COEXEC',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 19);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NDAYS_LEFT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 20);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_PERIOD',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 21);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 22, NVALUE => NCOST_FACT);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCOST_FACT', NVALUE => NCOST_FACT);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_NCOST_FACT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 23);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_NCOST_FACT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 24);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 25, NVALUE => NSUMM_REALIZ);
        if (NSUMM_REALIZ = 0) then
          NSUMM_INCOME := 0;
          NINCOME_PRC  := 0;
        else
          NSUMM_INCOME := NSUMM_REALIZ - NCOST_FACT;
          NINCOME_PRC  := NSUMM_INCOME / NCOST_FACT * 100;
        end if;
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSUMM_REALIZ', NVALUE => NSUMM_REALIZ);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_NSUMM_REALIZ',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 26);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_NSUMM_REALIZ',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 27);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSUMM_INCOME', NVALUE => NSUMM_INCOME);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NINCOME_PRC', NVALUE => NINCOME_PRC);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_COST',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 28);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCTRL_ACT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 29);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NCOST_READY',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 30);
        /*     */
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end STAGES_LIST;
  
  /*          */
  procedure STAGE_ARTS_SELECT_COST_FACT
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NFINFLOW_TYPE           in number := null, --     (null -  , 0 - , 1 - , 2 - )
    NIDENT                  out number         --    (  , null -  )
  )
  is
    NSELECTLIST             PKG_STD.TREF;      -- .     
  begin
    /*     */
    for C in (select CN.COMPANY,
                     CN.RN
                from PROJECTSTAGE PS,
                     FCCOSTNOTES  CN,
                     FINSTATE     FS,
                     FPDARTCL     FA,
                     FINFLOWTYPE  FT
               where PS.RN = NSTAGE
                 and PS.FACEACC = CN.PROD_ORDER
                 and ((NFPDARTCL is null) or ((NFPDARTCL is not null) and (CN.COST_ARTICLE = NFPDARTCL)))
                 and CN.COST_TYPE = FS.RN
                 and FS.TYPE = 1
                 and CN.COST_ARTICLE = FA.RN
                 and FA.DEF_FLOW = FT.RN(+)
                 and ((NFINFLOW_TYPE is null) or ((NFINFLOW_TYPE is not null) and (FT.TYPE = NFINFLOW_TYPE)))
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PS.CRN)
                 and exists (select null from V_USERPRIV UP where UP.JUR_PERS = PS.JUR_PERS and UP.UNITCODE = 'Projects')
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = CN.CRN))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'CostNotes',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGE_ARTS_SELECT_COST_FACT;
  
  /*  -      */
  function STAGE_ARTS_GET_COST_FACT
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NFINFLOW_TYPE           in number := null  --     (null -  , 0 - , 1 - , 2 - )
  ) return                  number             -- -  
  is
    NRES                    PKG_STD.TNUMBER;   --   
  begin
    /*           */
    select COALESCE(sum(CN.COST_BSUM), 0)
      into NRES
      from PROJECTSTAGE PS,
           FCCOSTNOTES  CN,
           FINSTATE     FS,
           FPDARTCL     FA,
           FINFLOWTYPE  FT
     where PS.RN = NSTAGE
       and PS.FACEACC = CN.PROD_ORDER
       and ((NFPDARTCL is null) or ((NFPDARTCL is not null) and (CN.COST_ARTICLE = NFPDARTCL)))
       and CN.COST_TYPE = FS.RN
       and FS.TYPE = 1
       and CN.COST_ARTICLE = FA.RN
       and FA.DEF_FLOW = FT.RN(+)
       and ((NFINFLOW_TYPE is null) or ((NFINFLOW_TYPE is not null) and (FT.TYPE = NFINFLOW_TYPE)));
    /*   */
    return NRES;
  end STAGE_ARTS_GET_COST_FACT;

  /*           */
  procedure STAGE_ARTS_SELECT_CONTR
  (
    NSTAGE                  in number,         -- .   
    NFPDARTCL               in number := null, -- .    (null -  )
    NIDENT                  out number         --    (  , null -  )
  )
  is
    NSELECTLIST             PKG_STD.TREF;      -- .     
  begin
    /*    */
    for C in (select distinct S.COMPANY NCOMPANY,
                              S.PRN     NRN
                from PROJECTSTAGEPF EPF,
                     STAGES         S
               where EPF.PRN = NSTAGE
                 and EPF.FACEACC = S.FACEACC
                 and ((NFPDARTCL is null) or ((NFPDARTCL is not null) and (EPF.COST_ARTICLE = NFPDARTCL)))
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = EPF.CRN)
                 and exists (select null from V_USERPRIV UP where UP.JUR_PERS = EPF.JUR_PERS and UP.UNITCODE = 'Projects')
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = S.CRN)
                 and exists (select null from V_USERPRIV UP where UP.JUR_PERS = S.JUR_PERS and UP.UNITCODE = 'Contracts'))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.NCOMPANY,
                               NDOCUMENT    => C.NRN,
                               SUNITCODE    => 'Contracts',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGE_ARTS_SELECT_CONTR;

  /*         */
  function STAGE_ARTS_GET_CONTR
  (
    NSTAGE                  in number,            -- .   
    NFPDARTCL               in number :=null      -- .    (null -  )
  ) return                  number                --    
  is
    RSTG                    PROJECTSTAGE%rowtype; --  
    NTAX_GROUP_DP           PKG_STD.TREF;         -- .  .     
    SPRJ_TAX_GROUP          PKG_STD.TSTRING;      --   
    NSUM                    PKG_STD.TNUMBER;      --   ( )
    NSUM_TAX                PKG_STD.TNUMBER;      --   ( )
  begin
    /*    */
    begin
      RSTG := STAGES_GET(NRN => NSTAGE);
    exception
      when others then
        null;
    end;
    /*    -    */
    if (RSTG.RN is not null) then
      /*  .  .      */
      FIND_DOCS_PROPS_CODE(NFLAG_SMART => 1,
                           NCOMPANY    => RSTG.COMPANY,
                           SCODE       => SDP_STAX_GROUP,
                           NRN         => NTAX_GROUP_DP);
      /*     */
      SPRJ_TAX_GROUP := F_DOCS_PROPS_GET_STR_VALUE(NPROPERTY => NTAX_GROUP_DP,
                                                   SUNITCODE => 'Projects',
                                                   NDOCUMENT => RSTG.PRN);
      /*       */
      select COALESCE(sum(S.STAGE_SUM), 0),
             COALESCE(sum(S.STAGE_SUMTAX), 0)
        into NSUM,
             NSUM_TAX
        from PROJECTSTAGEPF EPF,
             STAGES         S
       where EPF.PRN = RSTG.RN
         and EPF.FACEACC = S.FACEACC
         and ((NFPDARTCL is null) or ((NFPDARTCL is not null) and (EPF.COST_ARTICLE = NFPDARTCL)));
      /*         */
      if (SPRJ_TAX_GROUP is not null) then
        return NSUM;
      else
        return NSUM_TAX;
      end if;
    else
      return 0;
    end if;
  end STAGE_ARTS_GET_CONTR;
  
  /*      */
  procedure STAGE_ARTS_GET
  (
    NSTAGE                  in number,            -- .     
    NFPDARTCL               in number := null,    -- .    (null -  )
    NINC_COST               in number := 0,       --     (0 - , 1 - )
    NINC_CONTR              in number := 0,       --     (0 - , 1 - )
    RSTAGE_ARTS             out TSTAGE_ARTS       --    
  )
  is
    RSTG                    PROJECTSTAGE%rowtype; --   
    NCTL_COST_DP            PKG_STD.TREF;         -- .  . ,      
    NCTL_CONTR_DP           PKG_STD.TREF;         -- .  . ,      
    I                       PKG_STD.TNUMBER;      --     
  begin
    /*   */
    RSTG := STAGES_GET(NRN => NSTAGE);
    /*    -   */
    if (NINC_COST = 1) then
      FIND_DOCS_PROPS_CODE(NFLAG_SMART => 1, NCOMPANY => RSTG.COMPANY, SCODE => SDP_SCTL_COST, NRN => NCTL_COST_DP);
    end if;
    /*    -   */
    if (NINC_CONTR = 1) then
      FIND_DOCS_PROPS_CODE(NFLAG_SMART => 1, NCOMPANY => RSTG.COMPANY, SCODE => SDP_SCTL_CONTR, NRN => NCTL_CONTR_DP);
    end if;
    /*   */
    RSTAGE_ARTS := TSTAGE_ARTS();
    /*           */
    for C in (select CSPA.NUMB     SNUMB,
                     A.RN          NARTICLE,
                     A.NAME        SARTICLE,
                     CSPA.COST_SUM NCOST_SUM
                from PROJECTSTAGE  PS,
                     STAGES        CS,
                     CONTRPRSTRUCT CSP,
                     CONTRPRCLC    CSPA,
                     FPDARTCL      A
               where PS.RN = RSTG.RN
                 and PS.FACEACCCUST = CS.FACEACC
                 and CSP.PRN = CS.RN
                 and CSP.SIGN_ACT = 1
                 and CSPA.PRN = CSP.RN
                 and CSPA.COST_ARTICLE = A.RN
                 and ((NFPDARTCL is null) or ((NFPDARTCL is not null) and (A.RN = NFPDARTCL)))
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PS.CRN)
                 and exists (select null from V_USERPRIV UP where UP.JUR_PERS = PS.JUR_PERS and UP.UNITCODE = 'Projects')
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = CS.CRN)
                 and exists (select null from V_USERPRIV UP where UP.JUR_PERS = CS.JUR_PERS and UP.UNITCODE = 'Contracts')
               order by CSPA.NUMB)
    loop
      /*     */
      RSTAGE_ARTS.EXTEND();
      I := RSTAGE_ARTS.LAST;
      /*      */
      RSTAGE_ARTS(I).NRN := C.NARTICLE;
      RSTAGE_ARTS(I).SCODE := C.SNUMB;
      RSTAGE_ARTS(I).SNAME := C.SARTICLE;
      RSTAGE_ARTS(I).NPLAN := C.NCOST_SUM;
      /*            */
      if ((NINC_COST = 1) and
         (UPPER(F_DOCS_PROPS_GET_STR_VALUE(NPROPERTY => NCTL_COST_DP,
                                            SUNITCODE => 'FinPlanArticles',
                                            NDOCUMENT => RSTAGE_ARTS(I).NRN)) = UPPER(SYES)) and
         (RSTAGE_ARTS(I).NPLAN is not null)) then
        /*     */
        RSTAGE_ARTS(I).NCOST_FACT := STAGE_ARTS_GET_COST_FACT(NSTAGE => NSTAGE, NFPDARTCL => RSTAGE_ARTS(I).NRN);
        /*   (-) */
        RSTAGE_ARTS(I).NCOST_DIFF := RSTAGE_ARTS(I).NPLAN - RSTAGE_ARTS(I).NCOST_FACT;
        /*   */
        if (RSTAGE_ARTS(I).NCOST_DIFF >= 0) then
          RSTAGE_ARTS(I).NCTRL_COST := 0;
        else
          RSTAGE_ARTS(I).NCTRL_COST := 1;
        end if;
      end if;
      /*           */
      if ((NINC_CONTR = 1) and
         (UPPER(F_DOCS_PROPS_GET_STR_VALUE(NPROPERTY => NCTL_CONTR_DP,
                                            SUNITCODE => 'FinPlanArticles',
                                            NDOCUMENT => RSTAGE_ARTS(I).NRN)) = UPPER(SYES)) and
         (RSTAGE_ARTS(I).NPLAN is not null)) then
        /*  */
        RSTAGE_ARTS(I).NCONTR := STAGE_ARTS_GET_CONTR(NSTAGE => NSTAGE, NFPDARTCL => RSTAGE_ARTS(I).NRN);
        /*   */
        RSTAGE_ARTS(I).NCONTR_LEFT := RSTAGE_ARTS(I).NPLAN - RSTAGE_ARTS(I).NCONTR;
        /*   */
        if (RSTAGE_ARTS(I).NCONTR_LEFT >= 0) then
          RSTAGE_ARTS(I).NCTRL_CONTR := 0;
        else
          RSTAGE_ARTS(I).NCTRL_CONTR := 1;
        end if;
      end if;
    end loop;
  end STAGE_ARTS_GET;
  
  /*      */
  procedure STAGE_ARTS_LIST
  (
    NSTAGE                  in number,                      -- .   
    CFILTERS                in clob,                        -- 
    NINCLUDE_DEF            in number,                      --       
    COUT                    out clob                        --   
  )
  is
    RF                      PKG_P8PANELS_VISUAL.TFILTERS;   -- 
    RF_CTRL_COST            PKG_P8PANELS_VISUAL.TFILTER;    --    " ()"
    NCTRL_COST_FROM         PKG_STD.TNUMBER;                --       " ()"
    NCTRL_COST_TO           PKG_STD.TNUMBER;                --       " ()"
    RF_CTRL_CONTR           PKG_P8PANELS_VISUAL.TFILTER;    --    " ()"
    NCTRL_CONTR_FROM        PKG_STD.TNUMBER;                --       " ()"
    NCTRL_CONTR_TO          PKG_STD.TNUMBER;                --       " ()"
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
    RCOL_VALS               PKG_P8PANELS_VISUAL.TCOL_VALS;  --   
    RSTAGE_ARTS             TSTAGE_ARTS;                    --    
  begin
    /*   */
    RF := PKG_P8PANELS_VISUAL.TFILTERS_FROM_XML(CFILTERS => CFILTERS);
    /*      */
    RF_CTRL_COST := PKG_P8PANELS_VISUAL.TFILTERS_FIND(RFILTERS => RF, SNAME => 'NCTRL_COST');
    PKG_P8PANELS_VISUAL.TFILTER_TO_NUMBER(RFILTER => RF_CTRL_COST, NFROM => NCTRL_COST_FROM, NTO => NCTRL_COST_TO);
    /*      */
    RF_CTRL_CONTR := PKG_P8PANELS_VISUAL.TFILTERS_FIND(RFILTERS => RF, SNAME => 'NCTRL_CONTR');
    PKG_P8PANELS_VISUAL.TFILTER_TO_NUMBER(RFILTER => RF_CTRL_CONTR, NFROM => NCTRL_CONTR_FROM, NTO => NCTRL_CONTR_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNUMB',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNAME',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPLAN',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_FACT',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOST_DIFF',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_COST',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCONTR',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCONTR_LEFT',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_CONTR',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS);
    /*        */
    STAGE_ARTS_GET(NSTAGE => NSTAGE, NINC_COST => 1, NINC_CONTR => 1, RSTAGE_ARTS => RSTAGE_ARTS);
    /*    */
    if ((RSTAGE_ARTS is not null) and (RSTAGE_ARTS.COUNT > 0)) then
      for I in RSTAGE_ARTS.FIRST .. RSTAGE_ARTS.LAST
      loop
        /*    */
        if (((NCTRL_COST_FROM is null) or
           ((NCTRL_COST_FROM is not null) and (NCTRL_COST_FROM = RSTAGE_ARTS(I).NCTRL_COST))) and
           ((NCTRL_CONTR_FROM is null) or
           ((NCTRL_CONTR_FROM is not null) and (NCTRL_CONTR_FROM = RSTAGE_ARTS(I).NCTRL_CONTR)))) then
          /*     */
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW,
                                           SNAME  => 'NRN',
                                           NVALUE => RSTAGE_ARTS(I).NRN,
                                           BCLEAR => true);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SNUMB', SVALUE => RSTAGE_ARTS(I).SCODE);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SNAME', SVALUE => RSTAGE_ARTS(I).SNAME);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPLAN', NVALUE => RSTAGE_ARTS(I).NPLAN);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCOST_FACT', NVALUE => RSTAGE_ARTS(I).NCOST_FACT);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCOST_DIFF', NVALUE => RSTAGE_ARTS(I).NCOST_DIFF);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCTRL_COST', NVALUE => RSTAGE_ARTS(I).NCTRL_COST);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCONTR', NVALUE => RSTAGE_ARTS(I).NCONTR);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW,
                                           SNAME  => 'NCONTR_LEFT',
                                           NVALUE => RSTAGE_ARTS(I).NCONTR_LEFT);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW,
                                           SNAME  => 'NCTRL_CONTR',
                                           NVALUE => RSTAGE_ARTS(I).NCTRL_CONTR);
          /*     */
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
        end if;
      end loop;
    end if;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end STAGE_ARTS_LIST;

  /*      */
  function STAGE_CONTRACTS_GET_PSPF
  (
    NPROJECTSTAGEPF         in number               -- .    
  ) return                  PROJECTSTAGEPF%rowtype  --    
  is
    RRES                    PROJECTSTAGEPF%rowtype; --   
  begin
    select PS.* into RRES from PROJECTSTAGEPF PS where PS.RN = NPROJECTSTAGEPF;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NPROJECTSTAGEPF, SUNIT_TABLE => 'PROJECTSTAGEPF');
  end STAGE_CONTRACTS_GET_PSPF;
  
  /*     */
  procedure STAGE_CONTRACTS_COND
  is
  begin
    /*    */
    PKG_COND_BROKER.SET_TABLE(STABLE_NAME => 'PROJECTSTAGEPF');
    /*   */
    PKG_COND_BROKER.SET_COLUMN_PRN(SCOLUMN_NAME => 'PRN');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME    => 'AGNNAME',
                                       SCONDITION_NAME => 'EDAGENT',
                                       SJOINS          => 'PERFORMER <- RN;AGNLIST');
    /*   */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME    => 'CODE',
                                       SCONDITION_NAME => 'EDSCOST_ART',
                                       SJOINS          => 'COST_ARTICLE <- RN;FPDARTCL');
    /*  -   */
    PKG_COND_BROKER.SET_GROUP(SGROUP_NAME         => 'STAGES',
                              STABLE_NAME         => 'STAGES',
                              SCOLUMN_NAME        => 'FACEACC',
                              SPARENT_COLUMN_NAME => 'FACEACC');
    /*   -   */
    PKG_COND_BROKER.ADD_GROUP_CONDITION_CODE(SGROUP_NAME     => 'STAGES',
                                             SCOLUMN_NAME    => 'NUMB',
                                             SCONDITION_NAME => 'EDSTAGE',
                                             IALIGN          => 20);
    /*   -    */
    PKG_COND_BROKER.ADD_GROUP_CONDITION_BETWEEN(SGROUP_NAME          => 'STAGES',
                                                SCOLUMN_NAME         => 'BEGIN_DATE',
                                                SCONDITION_NAME_FROM => 'EDCSTAGE_BEGIN_DATEFrom',
                                                SCONDITION_NAME_TO   => 'EDCSTAGE_BEGIN_DATETo');
    /*   -    */
    PKG_COND_BROKER.ADD_GROUP_CONDITION_BETWEEN(SGROUP_NAME          => 'STAGES',
                                                SCOLUMN_NAME         => 'END_DATE',
                                                SCONDITION_NAME_FROM => 'EDCSTAGE_END_DATEFrom',
                                                SCONDITION_NAME_TO   => 'EDCSTAGE_END_DATETo');
    /*   -   */
    PKG_COND_BROKER.ADD_GROUP_CONDITION_CODE(SGROUP_NAME     => 'STAGES',
                                             SCOLUMN_NAME    => 'DOC_PREF',
                                             SCONDITION_NAME => 'EDDOC_PREF',
                                             SJOINS          => 'PRN <- RN;CONTRACTS',
                                             IALIGN          => 80);
    /*   -   */
    PKG_COND_BROKER.ADD_GROUP_CONDITION_CODE(SGROUP_NAME     => 'STAGES',
                                             SCOLUMN_NAME    => 'DOC_NUMB',
                                             SCONDITION_NAME => 'EDDOC_NUMB',
                                             SJOINS          => 'PRN <- RN;CONTRACTS',
                                             IALIGN          => 80);
    /*   -   */
    PKG_COND_BROKER.ADD_GROUP_CONDITION_BETWEEN(SGROUP_NAME          => 'STAGES',
                                                SCOLUMN_NAME         => 'DOC_DATE',
                                                SCONDITION_NAME_FROM => 'EDDOC_DATEFrom',
                                                SCONDITION_NAME_TO   => 'EDDOC_DATETo',
                                                SJOINS               => 'PRN <- RN;CONTRACTS');
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_FIN') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGE_CONTRACTS_GET_CTRL_FIN') || '(RN) = :EDCTRL_FIN');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_FIN',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_FIN'));
    end if;
    /*   */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'EDCTRL_COEXEC') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGE_CONTRACTS_GET_CTRL_COEXE') || '(RN) = :EDCTRL_COEXEC');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'EDCTRL_COEXEC',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'EDCTRL_COEXEC'));
    end if;
  end STAGE_CONTRACTS_COND;

  /*         */
  procedure STAGE_CONTRACTS_SELECT_PAY_IN
  (
    NPROJECTSTAGEPF         in number,    -- .    
    NIDENT                  out number    --    (  , null -  )
  )
  is
    NSELECTLIST             PKG_STD.TREF; -- .     
  begin
    /*   */
    for C in (select PAI.COMPANY,
                     PAI.RN
                from PROJECTSTAGEPF PSPF,
                     PROJECTSTAGE   PS,
                     PAYACCIN       PAI
               where PSPF.RN = NPROJECTSTAGEPF
                 and PSPF.PRN = PS.RN
                 and PSPF.FACEACC = PAI.FACEACC
                 and PAI.DOC_STATE = 1
                 and exists (select null
                        from PAYACCINSPCLC PCLC
                       where PCLC.PRN in (select PAIS.RN from PAYACCINSPEC PAIS where PAIS.PRN = PAI.RN)
                         and PCLC.FACEACCOUNT = PS.FACEACC)
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PSPF.CRN)
                 and exists (select null
                        from V_USERPRIV UP
                       where UP.JUR_PERS = PSPF.JUR_PERS
                         and UP.UNITCODE = 'Projects')
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PAI.CRN))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'PaymentAccountsIn',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGE_CONTRACTS_SELECT_PAY_IN;
  
  /*       */
  procedure STAGE_CONTRACTS_SELECT_ININV
  (
    NPROJECTSTAGEPF         in number,    -- .    
    NIDENT                  out number    --    (  , null -  )
  )
  is
    NSELECTLIST             PKG_STD.TREF; -- .     
  begin
    /*   */
    for C in (select I.COMPANY,
                     I.RN
                from PROJECTSTAGEPF PSPF,
                     PROJECTSTAGE   PS,
                     ININVOICES     I
               where PSPF.RN = NPROJECTSTAGEPF
                 and PSPF.PRN = PS.RN
                 and PSPF.FACEACC = I.FACEACC
                 and I.STATUS = 2
                 and exists (select null
                        from ININVOICESSPC ICLC
                       where ICLC.PRN in (select ISP.RN from ININVOICESSPECS ISP where ISP.PRN = I.RN)
                         and ICLC.FACEACCOUNT = PS.FACEACC)
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PSPF.CRN)
                 and exists (select null
                        from V_USERPRIV UP
                       where UP.JUR_PERS = PSPF.JUR_PERS
                         and UP.UNITCODE = 'Projects')
                 and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = I.CRN
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = I.CRN
                         and UP.AUTHID = UTILIZER))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'IncomingInvoices',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGE_CONTRACTS_SELECT_ININV;

  /*       */
  procedure STAGE_CONTRACTS_SELECT_FIN_OUT
  (
    NPROJECTSTAGEPF         in number,    -- .    
    NIDENT                  out number    --    (  , null -  )
  )
  is
    NSELECTLIST             PKG_STD.TREF; -- .     
  begin
    /*   */
    for C in (select PN.COMPANY,
                     PN.RN
                from PROJECTSTAGEPF PSPF,
                     PROJECTSTAGE   PS,
                     PAYNOTES       PN
               where PSPF.RN = NPROJECTSTAGEPF
                 and PSPF.PRN = PS.RN
                 and PSPF.FACEACC = PN.FACEACC
                 and PN.SIGNPLAN = 0
                 and exists (select null
                        from PAYNOTESCLC PNCLC
                       where PNCLC.PRN = PN.RN
                         and PNCLC.FACEACCOUNT = PS.FACEACC)
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = PSPF.CRN)
                 and exists (select null
                        from V_USERPRIV UP
                       where UP.JUR_PERS = PSPF.JUR_PERS
                         and UP.UNITCODE = 'Projects')
                 and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = PN.CRN
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.CATALOG = PN.CRN
                         and UP.AUTHID = UTILIZER)
                 and exists (select /*+ INDEX(UP I_USERPRIV_JUR_PERS_ROLEID) */
                       null
                        from USERPRIV UP
                       where UP.JUR_PERS = PN.JUR_PERS
                         and UP.UNITCODE = 'PayNotes'
                         and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                            UR.ROLEID
                                             from USERROLES UR
                                            where UR.AUTHID = UTILIZER)
                      union all
                      select /*+ INDEX(UP I_USERPRIV_JUR_PERS_AUTHID) */
                       null
                        from USERPRIV UP
                       where UP.JUR_PERS = PN.JUR_PERS
                         and UP.UNITCODE = 'PayNotes'
                         and UP.AUTHID = UTILIZER))
    loop
      /*    */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*       */
      P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                               NCOMPANY     => C.COMPANY,
                               NDOCUMENT    => C.RN,
                               SUNITCODE    => 'PayNotes',
                               SACTIONCODE  => null,
                               NCRN         => null,
                               NDOCUMENT1   => null,
                               SUNITCODE1   => null,
                               SACTIONCODE1 => null,
                               NRN          => NSELECTLIST);
    end loop;
  end STAGE_CONTRACTS_SELECT_FIN_OUT;

  /*         */
  function STAGE_CONTRACTS_GET_CTRL_FIN
  (
    NPROJECTSTAGEPF         in number        -- .    
  ) return                  number           --  (null -  , 0 -  , 1 -  )
  is
    NTMP                    PKG_STD.TNUMBER; --     
    NCTRL_FIN               PKG_STD.TNUMBER; --   
  begin
    /*       */
    STAGE_CONTRACTS_GET(NPROJECTSTAGEPF => NPROJECTSTAGEPF,
                        NINC_FIN        => 1,
                        NINC_COEXEC     => 0,
                        NPAY_IN         => NTMP,
                        NFIN_OUT        => NTMP,
                        NPAY_IN_REST    => NTMP,
                        NFIN_REST       => NTMP,
                        NCTRL_FIN       => NCTRL_FIN,
                        NCOEXEC_IN      => NTMP,
                        NCOEXEC_REST    => NTMP,
                        NCTRL_COEXEC    => NTMP);
    /*   */
    return NCTRL_FIN;
  end STAGE_CONTRACTS_GET_CTRL_FIN;
  
  /*         */
  function STAGE_CONTRACTS_GET_CTRL_COEXE
  (
    NPROJECTSTAGEPF         in number        -- .    
  ) return                  number           --  (null -  , 0 -  , 1 -  )
  is
    NTMP                    PKG_STD.TNUMBER; --     
    NCTRL_COEXEC            PKG_STD.TNUMBER; --   
  begin
    /*       */
    STAGE_CONTRACTS_GET(NPROJECTSTAGEPF => NPROJECTSTAGEPF,
                        NINC_FIN        => 0,
                        NINC_COEXEC     => 1,
                        NPAY_IN         => NTMP,
                        NFIN_OUT        => NTMP,
                        NPAY_IN_REST    => NTMP,
                        NFIN_REST       => NTMP,
                        NCTRL_FIN       => NTMP,
                        NCOEXEC_IN      => NTMP,
                        NCOEXEC_REST    => NTMP,
                        NCTRL_COEXEC    => NCTRL_COEXEC);
    /*   */
    return NCTRL_COEXEC;
  end STAGE_CONTRACTS_GET_CTRL_COEXE;

  /*        */
  procedure STAGE_CONTRACTS_GET
  (
    NPROJECTSTAGEPF         in number,              -- .    
    NINC_FIN                in number := 0,         --     (0 - , 1 - )
    NINC_COEXEC             in number := 0,         --     (0 - , 1 - )    
    NPAY_IN                 out number,             --    -     
    NFIN_OUT                out number,             --    -     
    NPAY_IN_REST            out number,             --    -       
    NFIN_REST               out number,             --    -      
    NCTRL_FIN               out number,             --    -  (null -  , 0 -  , 1 -  )
    NCOEXEC_IN              out number,             --    -  /
    NCOEXEC_REST            out number,             --    -   /
    NCTRL_COEXEC            out number              --    -  (null -  , 0 -  , 1 -  )
  )
  is
    RPSPF                   PROJECTSTAGEPF%rowtype; --    
    RPS                     PROJECTSTAGE%rowtype;   --    
    NDAYS_LEFT              PKG_STD.TNUMBER;        --       
  begin
    /*      */
    RPSPF := STAGE_CONTRACTS_GET_PSPF(NPROJECTSTAGEPF => NPROJECTSTAGEPF);
    /*      */
    RPS := STAGES_GET(NRN => RPSPF.PRN);
    /*    */
    NPAY_IN      := 0;
    NFIN_OUT     := 0;
    NPAY_IN_REST := 0;
    NFIN_REST    := RPSPF.COST_PLAN;
    NCTRL_FIN    := null;
    NCOEXEC_IN   := 0;
    NCOEXEC_REST := RPSPF.COST_PLAN;
    NCTRL_COEXEC := null;
    /*      */
    if (RPS.FACEACC is not null) then
      /*      */
      if (NINC_FIN = 1) then
        /*      -       ,         */
        select sum(PAI.SUMMWITHNDS * PAI.FA_BASECOURS)
          into NPAY_IN
          from PAYACCIN PAI
         where PAI.FACEACC = RPSPF.FACEACC
           and PAI.DOC_STATE = 1
           and exists (select null
                  from PAYACCINSPCLC PCLC
                 where PCLC.PRN in (select PAIS.RN from PAYACCINSPEC PAIS where PAIS.PRN = PAI.RN)
                   and PCLC.FACEACCOUNT = RPS.FACEACC);
        /*      -   .      ,         */
        select sum(PN.PAY_SUM * (PN.CURR_RATE_BASE / PN.CURR_RATE))
          into NFIN_OUT
          from PAYNOTES PN
         where PN.FACEACC = RPSPF.FACEACC
           and PN.SIGNPLAN = 0
           and exists (select null
                  from PAYNOTESCLC PNCLC
                 where PNCLC.PRN = PN.RN
                   and PNCLC.FACEACCOUNT = RPS.FACEACC);
        /*        */
        NPAY_IN_REST := COALESCE(NPAY_IN, 0) - COALESCE(NFIN_OUT, 0);
        /*       */
        NFIN_REST := RPSPF.COST_PLAN - COALESCE(NFIN_OUT, 0);
        /*     () */
        if (NPAY_IN is null) then
          NCTRL_FIN := null;
        else
          if (NPAY_IN_REST > 0) then
            NCTRL_FIN := 1;
          else
            NCTRL_FIN := 0;
          end if;
        end if;
        /*   */
        NPAY_IN  := COALESCE(NPAY_IN, 0);
        NFIN_OUT := COALESCE(NFIN_OUT, 0);
      end if;
      /*      */
      if (NINC_COEXEC = 1) then
        /*  / -          ,         */
        select sum(I.SUMMTAX * (I.CURBASECOURS / I.CURCOURS))
          into NCOEXEC_IN
          from ININVOICES I
         where I.FACEACC = RPSPF.FACEACC
           and I.STATUS = 2
           and exists (select null
                  from ININVOICESSPC ICLC
                 where ICLC.PRN in (select ISP.RN from ININVOICESSPECS ISP where ISP.PRN = I.RN)
                   and ICLC.FACEACCOUNT = RPS.FACEACC);
        /*    / */
        NCOEXEC_REST := RPSPF.COST_PLAN - COALESCE(NCOEXEC_IN, 0);
        /*     () */
        NDAYS_LEFT := STAGES_GET_DAYS_LEFT(NRN => RPS.RN);
        if (NDAYS_LEFT is null) then
          NCTRL_COEXEC := null;
        else
          if ((NCOEXEC_REST > 0) and (NDAYS_LEFT < NDAYS_LEFT_LIMIT)) then
            NCTRL_COEXEC := 1;
          else
            NCTRL_COEXEC := 0;
          end if;
        end if;
        /*   */
        NCOEXEC_IN := COALESCE(NCOEXEC_IN, 0);
      end if;
    end if;
  end STAGE_CONTRACTS_GET;
  
  /*     */
  procedure STAGE_CONTRACTS_LIST
  (
    NSTAGE                  in number,                             -- .   
    NPAGE_NUMBER            in number,                             --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,                             --     (0 - )
    CFILTERS                in clob,                               -- 
    CORDERS                 in clob,                               -- 
    NINCLUDE_DEF            in number,                             --       
    COUT                    out clob                               --   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NIDENT                  PKG_STD.TREF := GEN_IDENT();           --  
    RF                      PKG_P8PANELS_VISUAL.TFILTERS;          -- 
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    RCOL_VALS               PKG_P8PANELS_VISUAL.TCOL_VALS;         --   
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NPROJECTSTAGEPF         PKG_STD.TREF;                          -- .        
    NPAY_IN                 PKG_STD.TNUMBER;                       --    -     
    NFIN_OUT                PKG_STD.TNUMBER;                       --    -     
    NPAY_IN_REST            PKG_STD.TNUMBER;                       --    -       
    NFIN_REST               PKG_STD.TNUMBER;                       --    -      
    NCTRL_FIN               PKG_STD.TNUMBER;                       --    -  (null -  , 0 -  , 1 -  )
    NCOEXEC_IN              PKG_STD.TNUMBER;                       --    -  /
    NCOEXEC_REST            PKG_STD.TNUMBER;                       --    -   /
    NCTRL_COEXEC            PKG_STD.TNUMBER;                       --    -  (null -  , 0 -  , 1 -  )
  begin
    /*   */
    RF := PKG_P8PANELS_VISUAL.TFILTERS_FROM_XML(CFILTERS => CFILTERS);
    /*   */
    RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
    /*            */
    PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                             NPAGE_SIZE   => NPAGE_SIZE,
                                             NROW_FROM    => NROW_FROM,
                                             NROW_TO      => NROW_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SDOC_PREF',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDDOC_PREF',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_SDOC_PREF',
                                               SCAPTION   => ' (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_SDOC_PREF',
                                               SCAPTION   => ' ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SDOC_NUMB',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDDOC_NUMB',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SLNK_UNIT_SDOC_NUMB',
                                               SCAPTION   => ' (  )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLNK_DOCUMENT_SDOC_NUMB',
                                               SCAPTION   => ' ( )',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DDOC_DATE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDDOC_DATEFrom',
                                               SCOND_TO   => 'EDDOC_DATETo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SEXT_NUMBER',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SAGENT',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDAGENT',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SAGENT_INN',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SAGENT_KPP',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SGOVCNTRID',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCSTAGE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDSTAGE',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCSTAGE_DESCRIPTION',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DCSTAGE_BEGIN_DATE',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDCSTAGE_BEGIN_DATEFrom',
                                               SCOND_TO   => 'EDCSTAGE_BEGIN_DATETo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DCSTAGE_END_DATE',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               SCOND_FROM => 'EDCSTAGE_END_DATEFrom',
                                               SCOND_TO   => 'EDCSTAGE_END_DATETo',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSUMM',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCURR',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SCOST_ART',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SCOND_FROM => 'EDSCOST_ART',
                                               BORDER     => true,
                                               BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPAY_IN',
                                               SCAPTION   => '   ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFIN_OUT',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPAY_IN_REST',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TCOL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_FIN',
                                               SCAPTION   => '- (.)',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_FIN',
                                               BORDER     => false,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b> ()</b> -   ,     .<br>' ||
                                                             '<b style="color:red"> </b> -       .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,             (   ).');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFIN_REST',
                                               SCAPTION   => '     ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOEXEC_IN',
                                               SCAPTION   => ' /',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCOEXEC_REST',
                                               SCAPTION   => '  /',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NCTRL_COEXEC',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SCOND_FROM => 'EDCTRL_COEXEC',
                                               BORDER     => false,
                                               BFILTER    => true,
                                               RCOL_VALS  => RCOL_VALS,
                                               SHINT      => '<b></b> -       .<br>' ||
                                                             '<b style="color:red"> </b> -    ,     ,   ' ||
                                                             TO_CHAR(NDAYS_LEFT_LIMIT) ||
                                                             ' ,       /  .<br>' ||
                                                             '<b style="color:green"> </b> -    .<br>' ||
                                                             '<b style="color:gray"></b> -       . ,         , ' ||
                                                             '            ( ).');
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select PSPF.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       trim(CN.DOC_PREF) SDOC_PREF,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Contracts') || ' SLNK_UNIT_SDOC_PREF,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CN.RN NLNK_DOCUMENT_SDOC_PREF,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       trim(CN.DOC_NUMB) SDOC_NUMB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Contracts') || ' SLNK_UNIT_SDOC_NUMB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CN.RN NLNK_DOCUMENT_SDOC_NUMB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CN.DOC_DATE DDOC_DATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CN.EXT_NUMBER SEXT_NUMBER,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.AGNNAME SAGENT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.AGNIDNUMB SAGENT_INN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AG.REASON_CODE SAGENT_KPP,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       GC.CODE SGOVCNTRID,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       trim(ST.NUMB) SCSTAGE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ST.DESCRIPTION SCSTAGE_DESCRIPTION,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ST.BEGIN_DATE DCSTAGE_BEGIN_DATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ST.END_DATE DCSTAGE_END_DATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PSPF.COST_PLAN NSUMM,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CUR.INTCODE SCURR,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ART.CODE SCOST_ART');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from PROJECTSTAGEPF PSPF');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join FPDARTCL ART on PSPF.COST_ARTICLE = ART.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       STAGES ST,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CONTRACTS CN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join GOVCNTRID GC on CN.GOVCNTRID = GC.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       AGNLIST AG,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CURNAMES CUR');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 where PSPF.FACEACC = ST.FACEACC');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and ST.PRN = CN.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and PSPF.PERFORMER = AG.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and CN.CURRENCY = CUR.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP."CATALOG" = PSPF.CRN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP.JUR_PERS = PSPF.JUR_PERS and UP.UNITCODE = ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Projects') || ')');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP."CATALOG" = ST.CRN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and exists (select null from V_USERPRIV UP where UP.JUR_PERS = ST.JUR_PERS and UP.UNITCODE = ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Contracts') || ')');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and PSPF.RN in (select ID from COND_BROKER_IDSMART where IDENT = :NIDENT) %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      PKG_P8PANELS_VISUAL.TFILTERS_SET_QUERY(NIDENT     => NIDENT,
                                             NCOMPANY   => NCOMPANY,
                                             NPARENT    => NSTAGE,
                                             SUNIT      => 'ProjectsStagesPerformers',
                                             SPROCEDURE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_PROJECTS.STAGE_CONTRACTS_COND'),
                                             RDATA_GRID => RDG,
                                             RFILTERS   => RF);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => NIDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 10);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 11);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 12);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 13);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 14);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 15);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 16);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 17);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 18);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 19);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 20);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 21);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     */
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 1, NVALUE => NPROJECTSTAGEPF);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => NPROJECTSTAGEPF, BCLEAR => true);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SDOC_PREF',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 2);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_SDOC_PREF',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 3);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_SDOC_PREF',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 4);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SDOC_NUMB',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 5);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SLNK_UNIT_SDOC_NUMB',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 6);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLNK_DOCUMENT_SDOC_NUMB',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 7);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW      => RDG_ROW,
                                              SNAME     => 'DDOC_DATE',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 8);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SEXT_NUMBER',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 9);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SAGENT', ICURSOR => ICURSOR, NPOSITION => 10);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SAGENT_INN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 11);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SAGENT_KPP',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 12);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SGOVCNTRID',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 13);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SCSTAGE', ICURSOR => ICURSOR, NPOSITION => 14);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SCSTAGE_DESCRIPTION',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 15);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW      => RDG_ROW,
                                              SNAME     => 'DCSTAGE_BEGIN_DATE',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 16);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLD(RROW      => RDG_ROW,
                                              SNAME     => 'DCSTAGE_END_DATE',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 17);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW => RDG_ROW, SNAME => 'NSUMM', ICURSOR => ICURSOR, NPOSITION => 18);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SCURR', ICURSOR => ICURSOR, NPOSITION => 19);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SCOST_ART',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 20);
        STAGE_CONTRACTS_GET(NPROJECTSTAGEPF => NPROJECTSTAGEPF,
                            NINC_FIN        => 1,
                            NINC_COEXEC     => 1,
                            NPAY_IN         => NPAY_IN,
                            NFIN_OUT        => NFIN_OUT,
                            NPAY_IN_REST    => NPAY_IN_REST,
                            NFIN_REST       => NFIN_REST,
                            NCTRL_FIN       => NCTRL_FIN,
                            NCOEXEC_IN      => NCOEXEC_IN,
                            NCOEXEC_REST    => NCOEXEC_REST,
                            NCTRL_COEXEC    => NCTRL_COEXEC);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPAY_IN', NVALUE => NPAY_IN);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NFIN_OUT', NVALUE => NFIN_OUT);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPAY_IN_REST', NVALUE => NPAY_IN_REST);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCTRL_FIN', NVALUE => NCTRL_FIN);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NFIN_REST', NVALUE => NFIN_REST);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCOEXEC_IN', NVALUE => NCOEXEC_IN);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCOEXEC_REST', NVALUE => NCOEXEC_REST);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NCTRL_COEXEC', NVALUE => NCTRL_COEXEC);
        /*     */
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end STAGE_CONTRACTS_LIST;
  
  /*     */
  function JOBS_GET
  (
    NRN                     in number           -- .   
  ) return                  PROJECTJOB%rowtype  --   
  is
    RRES                    PROJECTJOB%rowtype; --   
  begin
    select PS.* into RRES from PROJECTJOB PS where PS.RN = NRN;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NRN, SUNIT_TABLE => 'PROJECTJOB');
  end JOBS_GET;
  
  /*      */
  function JB_GET_BEG
  (
    NIDENT                  in number       --  
  ) return                  date            --    
  is
    DRES                    PKG_STD.TLDATE; --   
  begin
    select min(D.DMIN_BEG_PLAN)
      into DRES
      from (select min(P.BEGPLAN) DMIN_BEG_PLAN
              from PROJECT P
             where P.RN in (select T.PROJECT from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT)
            union all
            select min(PS.BEGPLAN) DMIN_BEG_PLAN
              from PROJECTSTAGE PS
             where PS.PRN in (select T.PROJECT from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT)
            union all
            select min(PJ.BEGPLAN) DMIN_BEG_PLAN
              from PROJECTJOB PJ
             where PJ.PRN in (select T.PROJECT from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT)) D;
    /* ,   -  */
    if (DRES is null) then
      P_EXCEPTION(0,
                  '      . ,   ,       .');
    end if;
    /*   -     */
    return TRUNC(DRES, 'mm');
  end JB_GET_BEG;
  
  /*      */
  function JB_GET_END
  (
    NIDENT                  in number       --  
  ) return                  date            --    
  is
    DRES                    PKG_STD.TLDATE; --   
  begin
    select max(D.DMAX_END_PLAN)
      into DRES
      from (select max(P.ENDPLAN) DMAX_END_PLAN
              from PROJECT P
             where P.RN in (select T.PROJECT from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT)
            union all
            select max(PS.ENDPLAN) DMAX_END_PLAN
              from PROJECTSTAGE PS
             where PS.PRN in (select T.PROJECT from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT)
            union all
            select max(PJ.ENDPLAN) DMAX_END_PLAN
              from PROJECTJOB PJ
             where PJ.PRN in (select T.PROJECT from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT)) D;
    /* ,   -  */
    if (DRES is null) then
      P_EXCEPTION(0,
                  '      . ,   ,       .');
    end if;
    /*   -     */
    return LAST_DAY(DRES);
  end JB_GET_END;  
  
  /*      */
  function JB_GET_DURATION_MEAS_CODE
  (
    NDURATION_MEAS          in number   --    (0 - , 1 - , 2 - , 3 - , 4 - , 5 - )
  ) return                  varchar2    --    
  is
  begin
    /*       */
    case NDURATION_MEAS
      /*   */
      when 0 then
        return '';
      when 1 then
        return '';
      when 2 then
        return '';
      when 3 then
        return '';
      when 4 then
        return '';
      when 5 then
        return '';
      /*   */
      else
        P_EXCEPTION(0,
                    '   "%s"  .',
                    COALESCE(TO_CHAR(NDURATION_MEAS), '< >'));
    end case;
  end JB_GET_DURATION_MEAS_CODE;
  
  /*     */
  procedure JB_PRMS_BASE_INSERT
  (
    NIDENT                  in number,   --  
    DDATE_BEGIN             in date,     --    
    DDATE_FACT              in date,     --    
    NDURATION_MEAS          in number,   --    (0 - , 1 - , 2 - , 3 - , 4 - , 5 - )
    SDURATION_MEAS_CODE     in varchar2, --    ()
    NLAB_MEAS               in number,   --   
    SLAB_MEAS_CODE          in varchar2, --    ()
    NRN                     out number   -- .   
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into P8PNL_JB_PRMS
      (RN, IDENT, DATE_BEGIN, DATE_FACT, DURATION_MEAS, DURATION_MEAS_CODE, LAB_MEAS, LAB_MEAS_CODE)
    values
      (NRN, NIDENT, DDATE_BEGIN, DDATE_FACT, NDURATION_MEAS, SDURATION_MEAS_CODE, NLAB_MEAS, SLAB_MEAS_CODE);
  end JB_PRMS_BASE_INSERT;
  
  /*    */
  procedure JB_PRMS_CLEAN
  (
    NIDENT                  in number   --  
  )
  is
  begin
    /*    */
    delete from P8PNL_JB_PRMS T where T.IDENT = NIDENT;
  end JB_PRMS_CLEAN;
  
  /*      */
  function JB_PRMS_GET
  (
    NIDENT                  in number              --  
  ) return                  P8PNL_JB_PRMS%rowtype  --  
  is
    RRES                    P8PNL_JB_PRMS%rowtype; --   
  begin
    select P.* into RRES from P8PNL_JB_PRMS P where P.IDENT = NIDENT;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NIDENT, SUNIT_TABLE => 'P8PNL_JB_PRMS');
  end JB_PRMS_GET;
  
  /*        */
  function JB_PRJCTS_GET
  (
    NJB_PRJCTS              in number                -- .     
  ) return                  P8PNL_JB_PRJCTS%rowtype  --  
  is
    RRES                    P8PNL_JB_PRJCTS%rowtype; --   
  begin
    select P.* into RRES from P8PNL_JB_PRJCTS P where P.RN = NJB_PRJCTS;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NJB_PRJCTS, SUNIT_TABLE => 'P8PNL_JB_PRJCTS');
  end JB_PRJCTS_GET;

  /*     ,   */
  procedure JB_PRJCTS_SET_CHANGED
  (
    NJB_PRJCTS              in number,  -- .     
    NCHANGED                in number   --   ,   (0 - , 1 - )  
  )
  is
  begin
    /*   */
    update P8PNL_JB_PRJCTS T set T.CHANGED = NCHANGED where T.RN = NJB_PRJCTS;
  end JB_PRJCTS_SET_CHANGED;

  /*       */
  procedure JB_PRJCTS_BASE_INSERT
  (
    NIDENT                  in number,  --  
    NPROJECT                in number,  -- .  
    NJOBS                   in number,  --   - (0 - , 1 - )
    NEDITABLE               in number,  --    (0 - , 1 - )
    NCHANGED                in number,  --   ,   (0 - , 1 - )  
    NJB_PRJCTS              out number  -- .     
  )
  is
  begin
    /*  .   */
    NJB_PRJCTS := GEN_ID();
    /*   */
    insert into P8PNL_JB_PRJCTS
      (RN, IDENT, PROJECT, JOBS, EDITABLE, CHANGED)
    values
      (NJB_PRJCTS, NIDENT, NPROJECT, NJOBS, NEDITABLE, NCHANGED);
  end JB_PRJCTS_BASE_INSERT;
  
  /*    */
  procedure JB_PRJCTS_LIST
  (
    NIDENT                  in number,  --  
    COUT                    out clob    --  
  )
  is
  begin
    /*   XML */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    /*   */
    PKG_XFAST.DOWN_NODE(SNAME => 'XDATA');
    /*    */
    for C in (select T.RN       NRN,
                     T.PROJECT  NPROJECT,
                     P.NAME_USL SNAME,
                     T.JOBS     NJOBS,
                     T.EDITABLE NEDITABLE,
                     T.CHANGED  NCHANGED
                from P8PNL_JB_PRJCTS T,
                     PROJECT         P
               where T.IDENT = NIDENT
                 and T.PROJECT = P.RN
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                 and exists (select null
                        from V_USERPRIV UP
                       where UP.JUR_PERS = P.JUR_PERS
                         and UP.UNITCODE = 'Projects')
               order by T.RN)
    loop
      /*   */
      PKG_XFAST.DOWN_NODE(SNAME => 'XPROJECTS');
      /*   */
      PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => C.NRN);
      PKG_XFAST.ATTR(SNAME => 'NPROJECT', NVALUE => C.NPROJECT);
      PKG_XFAST.ATTR(SNAME => 'SNAME', SVALUE => C.SNAME);
      PKG_XFAST.ATTR(SNAME => 'NJOBS', NVALUE => C.NJOBS);
      PKG_XFAST.ATTR(SNAME => 'NEDITABLE', NVALUE => C.NEDITABLE);
      PKG_XFAST.ATTR(SNAME => 'NCHANGED', NVALUE => C.NCHANGED);
      /*   */
      PKG_XFAST.UP();
    end loop;
    /*   */
    PKG_XFAST.UP();
    /*  */
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    /*   XML */
    PKG_XFAST.EPILOGUE();
  exception
    when others then
      /*   XML */
      PKG_XFAST.EPILOGUE();
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end JB_PRJCTS_LIST;
  
  /*   /     */
  function JB_JOBS_GET
  (
    NJB_JOBS                in number              -- .   /    
  ) return                  P8PNL_JB_JOBS%rowtype  --  
  is
    RRES                    P8PNL_JB_JOBS%rowtype; --   
  begin
    select P.* into RRES from P8PNL_JB_JOBS P where P.RN = NJB_JOBS;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NJB_JOBS, SUNIT_TABLE => 'P8PNL_JB_JOBS');
  end JB_JOBS_GET;
  
  /*   /     /  */
  function JB_JOBS_GET_BY_SOURCE
  (
    NIDENT                  in number,             --  
    NPRN                    in number,             -- .  
    NSOURCE                 in number              -- .   (/ )
  ) return                  P8PNL_JB_JOBS%rowtype  --  
  is
    RRES                    P8PNL_JB_JOBS%rowtype; --   
  begin
    select T.*
      into RRES
      from P8PNL_JB_JOBS T
     where T.IDENT = NIDENT
       and T.PRN = NPRN
       and T.SOURCE = NSOURCE;
    return RRES;
  exception
    when NO_DATA_FOUND then
      P_EXCEPTION(0,
                  ' / (RN-: %s)     .',
                  COALESCE(TO_CHAR(NSOURCE), '< >'));
  end JB_JOBS_GET_BY_SOURCE;
  
  /*      /,   */
  procedure JB_JOBS_SET_CHANGED
  (
    NJB_JOBS                in number,  -- .    /
    NCHANGED                in number   --   ,   (0 - , 1 - )  
  )
  is
  begin
    /*   */
    update P8PNL_JB_JOBS T set T.CHANGED = NCHANGED where T.RN = NJB_JOBS;
  end JB_JOBS_SET_CHANGED;
  
  /*   /    */
  procedure JB_JOBS_BASE_INSERT
  (
    NIDENT                  in number,   --  
    NPRN                    in number,   -- .  
    NHRN                    in number,   -- .      /
    NSOURCE                 in number,   -- .   (/ )
    SNUMB                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    DDATE_FROM              in date,     -- 
    DDATE_TO                in date,     -- 
    NDURATION               in number,   -- 
    SEXECUTOR               in varchar2, -- 
    NSTAGE                  in number,   --   (0 - , 1 - )
    NEDITABLE               in number,   --    (0 - , 1 - )
    NJB_JOBS                out number   -- .    /
  )
  is
  begin
    /*  .   */
    NJB_JOBS := GEN_ID();
    /*   */
    insert into P8PNL_JB_JOBS
      (RN, IDENT, PRN, HRN, source, NUMB, name, DATE_FROM, DATE_TO, DURATION, EXECUTOR, STAGE, EDITABLE)
    values
      (NJB_JOBS, NIDENT, NPRN, NHRN, NSOURCE, SNUMB, SNAME, DDATE_FROM, DDATE_TO, NDURATION, SEXECUTOR, NSTAGE, NEDITABLE);
  end JB_JOBS_BASE_INSERT;
  
  /*        */
  procedure JB_JOBS_BASE_MODIFY_PERIOD
  (
    NJB_JOBS                in number,             -- .    /
    NDELTA                  in number,             --   
    NCHANGE_FLAG            in number              --    (1 -   , 2 -   )
  )
  is
    RJ                      PROJECTJOB%rowtype;    --    
    RS                      PROJECTSTAGE%rowtype;  --    
    RJB_J                   P8PNL_JB_JOBS%rowtype; --     
    RJB_PRMS                P8PNL_JB_PRMS%rowtype; --  
    DDATE_FROM_NEW          PKG_STD.TLDATE;        --    
    DDATE_TO_NEW            PKG_STD.TLDATE;        --    
  begin
    /*     */
    RJB_J := JB_JOBS_GET(NJB_JOBS => NJB_JOBS);
    /*    */
    RJB_PRMS := JB_PRMS_GET(NIDENT => RJB_J.IDENT);
    /*    */
    RJ := JOBS_GET(NRN => RJB_J.SOURCE);
    /*  -       */
    if (RJ.PROJECTSTAGE is null) then
      P_EXCEPTION(0,
                  ' "%s"      .',
                  trim(RJ.NUMB));
    end if;
    /*    */
    RS := STAGES_GET(NRN => RJ.PROJECTSTAGE);
    /*  -      */
    if (RJ.DURATION_CHG <> 2) then
      P_EXCEPTION(0,
                  ' "%s"    .',
                  trim(RJ.NUMB));
    end if;
    /*  -        "" */
    if (RJ.STATE <> 0) then
      P_EXCEPTION(0,
                  ' "%s"     " ".',
                  trim(RJ.NUMB));
    end if;
    /*         */
    if (NCHANGE_FLAG = 1) then
      DDATE_FROM_NEW := RJB_J.DATE_FROM + NDELTA;
      P_PROJECTJOB_GET_OFFSET_DATE(NCOMPANY     => RJ.COMPANY,
                                   DSRC_DATE    => DDATE_FROM_NEW,
                                   NOFFSET      => RJ.DURATION_P,
                                   NOFFSET_MEAS => RJB_PRMS.DURATION_MEAS,
                                   DDEST_DATE   => DDATE_TO_NEW);
    else
      DDATE_TO_NEW := RJB_J.DATE_TO + NDELTA;
      P_PROJECTJOB_GET_OFFSET_DATE(NCOMPANY     => RJ.COMPANY,
                                   DSRC_DATE    => DDATE_TO_NEW,
                                   NOFFSET      => -RJ.DURATION_P,
                                   NOFFSET_MEAS => RJB_PRMS.DURATION_MEAS,
                                   DDEST_DATE   => DDATE_FROM_NEW);
    end if;
    /*  -          */
    if ((NCHANGE_FLAG = 1) and (DDATE_FROM_NEW <= RJB_PRMS.DATE_FACT)) then
      P_EXCEPTION(0,
                  '      "   " (%s).',
                  TO_CHAR(RJB_PRMS.DATE_FACT, 'DD.MM.YYYY'));
    end if;
    /*  -          */
    if ((NCHANGE_FLAG = 2) and (DDATE_TO_NEW <= RJB_PRMS.DATE_FACT)) then
      P_EXCEPTION(0,
                  '      "   " (%s).',
                  TO_CHAR(RJB_PRMS.DATE_FACT, 'DD.MM.YYYY'));
    end if;
    /*  -           */
    if ((NCHANGE_FLAG = 2) and (DDATE_TO_NEW >= RS.ENDPLAN)) then
      P_EXCEPTION(0,
                  '        (%s).',
                  TO_CHAR(RS.ENDPLAN, 'DD.MM.YYYY'));
    end if;
    /*   */
    update P8PNL_JB_JOBS T
       set T.DATE_FROM = DDATE_FROM_NEW,
           T.DATE_TO   = DDATE_TO_NEW
     where T.RN = RJB_J.RN;
    /*     */
    JB_JOBS_SET_CHANGED(NJB_JOBS => RJB_J.RN, NCHANGED => 1);
    /*          */
    for C in (select J.RN
                from P8PNL_JB_JOBS J
               where J.RN in (select PRV.PRN
                                from P8PNL_JB_JOBSPREV PRV
                               where PRV.IDENT = RJB_J.IDENT
                                 and PRV.JB_JOBS = RJB_J.RN))
    loop
      JB_JOBS_BASE_MODIFY_PERIOD(NJB_JOBS => C.RN, NDELTA => NDELTA, NCHANGE_FLAG => NCHANGE_FLAG);
    end loop;
  end JB_JOBS_BASE_MODIFY_PERIOD;
  
  /*       */
  procedure JB_JOBS_MODIFY_PERIOD
  (
    NJB_JOBS                in number,                     -- .    /
    DDATE_FROM              in date,                       --   
    DDATE_TO                in date,                       --   
    NRESOURCE_STATUS        out number                     --   (0 -  , 1 -  , -1 -   )
  )
  is
    RJB_J                   P8PNL_JB_JOBS%rowtype;         --     
    RJB_P                   P8PNL_JB_PRJCTS%rowtype;       --      
    RJ                      PROJECTJOB%rowtype;            --    
    NCHANGE_FLAG            PKG_STD.TNUMBER := 0;          --    (0 -  , 1 -   , 2 -   )
    NDELTA                  PKG_STD.TNUMBER;               --  
    SUTILIZER               PKG_STD.TSTRING := UTILIZER(); --  
  begin
    /*     */
    RJB_J := JB_JOBS_GET(NJB_JOBS => NJB_JOBS);
    /*     */
    RJB_P := JB_PRJCTS_GET(NJB_PRJCTS => RJB_J.PRN);
    /*    */
    RJ := JOBS_GET(NRN => RJB_J.SOURCE);
    /*  -     */
    if (RJB_J.STAGE = 1) then
      P_EXCEPTION(0, '     .');
    end if;
    /*  -       */
    if (CHECK_RESPONSIBLE(NRN => RJB_P.PROJECT, SAUTHID => SUTILIZER) <> 1) then
      P_EXCEPTION(0, '      .');
    end if;
    /*  -      */
    if (RJ.DURATION_CHG <> 2) then
      P_EXCEPTION(0, '    .');
    end if;
    /*   ,       */
    if ((DDATE_FROM is not null) and (TRUNC(RJB_J.DATE_FROM) <> TRUNC(DDATE_FROM))) then
      NCHANGE_FLAG := 1;
      NDELTA       := TRUNC(DDATE_FROM) - TRUNC(RJB_J.DATE_FROM);
    end if;
    if ((DDATE_TO is not null) and (TRUNC(RJB_J.DATE_TO) <> TRUNC(DDATE_TO)) and (NCHANGE_FLAG = 0)) then
      NCHANGE_FLAG := 2;
      NDELTA       := TRUNC(DDATE_TO) - TRUNC(RJB_J.DATE_TO);
    end if;
    /*     */
    if (NCHANGE_FLAG <> 0) then
      /*   */
      JB_JOBS_BASE_MODIFY_PERIOD(NJB_JOBS       => RJB_J.RN,
                                 NDELTA         => NDELTA,
                                 NCHANGE_FLAG   => NCHANGE_FLAG);
      /*      */
      JB_PRJCTS_SET_CHANGED(NJB_PRJCTS => RJB_P.RN, NCHANGED => 1);
      /*    */
      JB_PERIODS_RECALC(NIDENT => RJB_P.IDENT, NINITIAL => 0, NRESOURCE_STATUS => NRESOURCE_STATUS);
    else
      /*    */
      NRESOURCE_STATUS := -1;
    end if;
  end JB_JOBS_MODIFY_PERIOD;
  
  /*        */
  procedure JB_JOBS_LIST
  (
    NIDENT                  in number,                                --  
    NPRN                    in number,                                -- .  
    NINCLUDE_DEF            in number,                                --      
    COUT                    out clob                                  --  
  )
  is
    /*  */
    SBG_COLOR_DANGER        constant PKG_STD.TSTRING := '#ff4d4d';    --    
    SBG_COLOR_WARN          constant PKG_STD.TSTRING := 'orange';     --     
    SBG_COLOR_OK            constant PKG_STD.TSTRING := 'lightgreen'; --    
    SBG_COLOR_DISABLED      constant PKG_STD.TSTRING := 'darkgrey';   --    
    SBG_COLOR_STAGE         constant PKG_STD.TSTRING := 'cadetblue';  --   
    STEXT_COLOR_DANGER      constant PKG_STD.TSTRING := 'blue';       --     

    /*  */
    RJB_PRJ                 P8PNL_JB_PRJCTS%rowtype;                  --    
    RPRJ                    PROJECT%rowtype;                          --  
    RSTG                    PROJECTSTAGE%rowtype;                     --  
    RJOB                    PROJECTJOB%rowtype;                       --  
    RG                      PKG_P8PANELS_VISUAL.TGANTT;               --   
    RGT                     PKG_P8PANELS_VISUAL.TGANTT_TASK;          --        
    STITLE                  PKG_STD.TSTRING;                          --  
    BREAD_ONLY_DATES        boolean := false;                         --       
    BTASK_READ_ONLY         boolean;                                  --      
    STASK_BG_COLOR          PKG_STD.TSTRING;                          --   
    STASK_TEXT_COLOR        PKG_STD.TSTRING;                          --   
    STASK_CAPTION           PKG_STD.TSTRING;                          --      
    NTASK_STATE             PKG_STD.TNUMBER;                          --  
    NTASK_PROGRESS          PKG_STD.TNUMBER;                          --       
    STASK_RESP              PKG_STD.TSTRING;                          --    
  begin
    /*      */
    RJB_PRJ := JB_PRJCTS_GET(NJB_PRJCTS => NPRN);
    /*    */
    RPRJ := GET(NRN => RJB_PRJ.PROJECT);
    /*       */
    if (RJB_PRJ.EDITABLE = 0) then
      BREAD_ONLY_DATES := true;
    end if;
    /*    */
    STITLE := RPRJ.NAME_USL || ' - ' || RPRJ.NAME;
    if ((RPRJ.EXT_CUST is not null) or ((RPRJ.BEGPLAN is not null) and (RPRJ.ENDPLAN is not null))) then
      STITLE := STITLE || ' (';
      if (RPRJ.EXT_CUST is not null) then
        STITLE := STITLE || ': "' ||
                  COALESCE(GET_AGNLIST_AGNABBR_ID(NFLAG_SMART => 1, NRN => RPRJ.EXT_CUST), '< ˨>') || '", ';
      end if;
      if ((RPRJ.BEGPLAN is not null) and (RPRJ.ENDPLAN is not null)) then
        STITLE := STITLE || ' ' || TO_CHAR(RPRJ.BEGPLAN, 'dd.mm.yyyy') || '  ' ||
                  TO_CHAR(RPRJ.ENDPLAN, 'dd.mm.yyyy');
      end if;
      STITLE := STITLE || ')';
    end if;
    /*    */
    RG := PKG_P8PANELS_VISUAL.TGANTT_MAKE(STITLE              => STITLE,
                                          NZOOM               => PKG_P8PANELS_VISUAL.NGANTT_ZOOM_MONTH,
                                          BREAD_ONLY_DATES    => BREAD_ONLY_DATES,
                                          BREAD_ONLY_PROGRESS => true);
    /*      */
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT => RG, SNAME => 'type', SCAPTION => '');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT => RG, SNAME => 'state', SCAPTION => '');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT => RG, SNAME => 'resp', SCAPTION => '');
    /*     */
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT      => RG,
                                              SBG_COLOR   => SBG_COLOR_DANGER,
                                              STEXT_COLOR => STEXT_COLOR_DANGER,
                                              SDESC       => '    " " -   ,      . ' ||
                                                             '    "", "" -   ,      /.');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_WARN,
                                              SDESC     => '    " " -   ,     . ' ||
                                                           '    "", "" -   ,     .');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_OK,
                                              SDESC     => '     .');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_DISABLED,
                                              SDESC     => '   (   ""  "").');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_STAGE,
                                              SDESC     => '   .');
    /*   */
    for C in (select JB.*
                from P8PNL_JB_JOBS   JB,
                     P8PNL_JB_PRJCTS PB,
                     PROJECT         P
               where JB.IDENT = NIDENT
                 and JB.PRN = NPRN
                 and JB.PRN = PB.RN
                 and PB.PROJECT = P.RN
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                 and exists (select null
                        from V_USERPRIV UP
                       where UP.JUR_PERS = P.JUR_PERS
                         and UP.UNITCODE = 'Projects')
               order by JB.RN)
    loop
      /*   -    ,     */
      STASK_RESP := null;
      if (C.STAGE = 1) then
        RSTG := STAGES_GET(NRN => C.SOURCE);
        if (RSTG.RESPONSIBLE is not null) then
          STASK_RESP := GET_AGNLIST_AGNABBR_ID(NFLAG_SMART => 1, NRN => RSTG.RESPONSIBLE);
        elsif (RSTG.SUBDIV_RESP is not null) then
          STASK_RESP := UTL_INS_DEPARTMENT_GET_NAME(NRN => RSTG.SUBDIV_RESP);
        end if;
      else
        RJOB := JOBS_GET(NRN => C.SOURCE);
        if (RJOB.PERFORM is not null) then
          STASK_RESP := GET_AGNLIST_AGNABBR_ID(NFLAG_SMART => 1, NRN => RJOB.PERFORM);
        elsif (RJOB.SUBDIV is not null) then
          STASK_RESP := UTL_INS_DEPARTMENT_GET_NAME(NRN => RJOB.SUBDIV);
        end if;
      end if;
      /*    */
      if (C.STAGE = 1) then
        NTASK_STATE := RSTG.STATE;
      else
        NTASK_STATE := RJOB.STATE;
      end if;
      /*    */
      if (C.STAGE = 1) then
        /*     */
        STASK_BG_COLOR := SBG_COLOR_STAGE;
      else
        /*      (  ) */
        STASK_BG_COLOR   := null;
        STASK_TEXT_COLOR := null;
        /*  -   (" ") */
        if (RJOB.STATE = 0) then
          if (C.DATE_FROM <= sysdate) then
            STASK_BG_COLOR   := SBG_COLOR_DANGER;
            STASK_TEXT_COLOR := STEXT_COLOR_DANGER;
          elsif (C.DATE_FROM <= sysdate + NDAYS_LEFT_LIMIT) then
            STASK_BG_COLOR := SBG_COLOR_WARN;
          else
            STASK_BG_COLOR := SBG_COLOR_OK;
          end if;
        end if;
        /*  -   ("", "") */
        if (RJOB.STATE in (1, 3)) then
          if (C.DATE_TO <= sysdate) then
            STASK_BG_COLOR   := SBG_COLOR_DANGER;
            STASK_TEXT_COLOR := STEXT_COLOR_DANGER;
          elsif (C.DATE_TO <= sysdate + NDAYS_LEFT_LIMIT) then
            STASK_BG_COLOR := SBG_COLOR_WARN;
          else
            STASK_BG_COLOR := SBG_COLOR_OK;
          end if;
        end if;
        /*  -   ("", "") */
        if (RJOB.STATE in (2, 4)) then
          /*   */
          STASK_BG_COLOR := SBG_COLOR_DISABLED;
        end if;
      end if;
      /*     */
      BTASK_READ_ONLY := false;
      if (C.EDITABLE = 0) then
        BTASK_READ_ONLY := true;
      end if;
      /*       */
      STASK_CAPTION := trim(C.NUMB) || ' - ' || C.NAME;
      if (LENGTH(STASK_CAPTION) > NGANTT_TASK_CAPTION_LEN) then
        STASK_CAPTION := SUBSTR(STASK_CAPTION, 1, NGANTT_TASK_CAPTION_LEN) || '...';
      end if;
      /*   (     ""  "") */
      if ((C.STAGE = 0) and (RJOB.STATE in (1, 3)) and (RJOB.LAB_PLAN > 0)) then
        NTASK_PROGRESS := RJOB.LAB_FACT / RJOB.LAB_PLAN * 100;
      else
        NTASK_PROGRESS := null;
      end if;
      /*   */
      RGT := PKG_P8PANELS_VISUAL.TGANTT_TASK_MAKE(NRN                 => C.RN,
                                                  SNUMB               => C.NUMB,
                                                  SCAPTION            => STASK_CAPTION,
                                                  SNAME               => C.NAME,
                                                  DSTART              => C.DATE_FROM,
                                                  DEND                => C.DATE_TO,
                                                  NPROGRESS           => NTASK_PROGRESS,
                                                  SBG_COLOR           => STASK_BG_COLOR,
                                                  STEXT_COLOR         => STASK_TEXT_COLOR,
                                                  BREAD_ONLY          => BTASK_READ_ONLY,
                                                  BREAD_ONLY_PROGRESS => true);
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG,
                                                   RTASK  => RGT,
                                                   SNAME  => 'type',
                                                   SVALUE => C.STAGE,
                                                   BCLEAR => true);
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG, RTASK => RGT, SNAME => 'state', SVALUE => NTASK_STATE);
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG, RTASK => RGT, SNAME => 'resp', SVALUE => STASK_RESP);
      /*     */
      for CP in (select JP.JB_JOBS
                   from P8PNL_JB_JOBSPREV JP
                  where JP.IDENT = NIDENT
                    and JP.PRN = C.RN)
      loop
        PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_DEPENDENCY(RTASK => RGT, NDEPENDENCY => CP.JB_JOBS);
      end loop;
      /*     */
      PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK(RGANTT => RG, RTASK => RGT);
    end loop;
    /* ,    -   */
    if (RG.RTASKS.COUNT = 0) then
      P_EXCEPTION(0,
                  '    /,      (,          /).');
    end if;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TGANTT_TO_XML(RGANTT => RG, NINCLUDE_DEF => NINCLUDE_DEF);
  end JB_JOBS_LIST;
  
  /*    /    */
  procedure JB_JOBSPREV_BASE_INSERT
  (    
    NIDENT                  in number, --  
    NPRN                    in number, -- .  
    NJB_JOBS                in number, -- .   /
    NJB_JOBSPREV            out number -- .     /
  )
  is
  begin
    /*  .   */
    NJB_JOBSPREV := GEN_ID();
    /*   */
    insert into P8PNL_JB_JOBSPREV (RN, IDENT, PRN, JB_JOBS) values (NJB_JOBSPREV, NIDENT, NPRN, NJB_JOBS);
  end JB_JOBSPREV_BASE_INSERT;
  
  /*        */
  function JB_PERIODS_GET
  (
    NJB_PERIODS             in number                 -- .      
  ) return                  P8PNL_JB_PERIODS%rowtype  --  
  is
    RRES                    P8PNL_JB_PERIODS%rowtype; --   
  begin
    select P.* into RRES from P8PNL_JB_PERIODS P where P.RN = NJB_PERIODS;
    return RRES;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NJB_PERIODS, SUNIT_TABLE => 'P8PNL_JB_PERIODS');
  end JB_PERIODS_GET;
  
  /*            */
  procedure JB_PERIODS_PLAN_FOT_BUILD
  (
    NJB_PERIODS             in number,                             -- .      
    NMODE                   in number := 0,                        --  (0 -   , 1 -  )
    NPAGE_NUMBER            in number := 0,                        --   (  NPAGE_SIZE=0  NMODE = 1)
    NPAGE_SIZE              in number := 0,                        --     (0 - ,   NMODE = 1)
    CORDERS                 in clob := null,                       --  (  NMODE = 1)
    NINCLUDE_DEF            in number := 1,                        --        (  NMODE = 1)
    NLAB_PLAN_FOT           out number,                            --    
    COUT                    out clob                               --    (   NMODE = 0)
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    RPRD                    P8PNL_JB_PERIODS%rowtype;              --   
    RJB_PRMS                P8PNL_JB_PRMS%rowtype;                 --  
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --       
    NPERS_LAB               PKG_STD.TLNUMBER;                      --   
    NLAB_MEAS_HOURS         PKG_STD.TREF;                          -- .     /
  begin
    /*  .     / */
    FIND_DICMUNTS_BY_MNEMO(NFLAG_SMART => 0,
                           NCOMPANY    => NCOMPANY,
                           SMEAS_MNEMO => SLAB_MEAS_HOURS,
                           NRN         => NLAB_MEAS_HOURS);
    /*       */
    NLAB_PLAN_FOT := 0;
    /*     */
    RPRD := JB_PERIODS_GET(NJB_PERIODS => NJB_PERIODS);
    /*    */
    RJB_PRMS := JB_PRMS_GET(NIDENT => RPRD.IDENT);
    /*       */
    if (NMODE = 1) then
      /*            -     */
      PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => 0,
                                               NPAGE_SIZE   => 0,
                                               NROW_FROM    => NROW_FROM,
                                               NROW_TO      => NROW_TO);
    else
      /*      -   */
      RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
      /*            */
      PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                               NPAGE_SIZE   => NPAGE_SIZE,
                                               NROW_FROM    => NROW_FROM,
                                               NROW_TO      => NROW_TO);
      /*    */
      RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
      /*      */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NRN',
                                                 SCAPTION   => '.   ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SPERSON',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NLAB_PLAN_FOT',
                                                 SCAPTION   => ' (' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BORDER     => true);
    end if;
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select FM.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PERS.CODE SPERSON,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       SH.AVG_HOURS NLAB_PLAN_FOT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from CLNPSPFM   FM,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CLNPERSONS PERS,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CLNPSDEP   PSD,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       PRPROF     PROF,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       CLNPSPFMHS FMH,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       SLSCHEDULE SH');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 where FM.COMPANY = :NCOMPANY');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and FM.PERSRN = PERS.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and FM.DEPTRN = :NINS_DEPARTMENT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and FM.PSDEPRN = PSD.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and PSD.PRPROF = PROF.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and PROF.RN in (select MP.PRPROF from FCMANPOWER MP where MP.RN = :NFCMANPOWER)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and ((FM.BEGENG between :DDATE_FROM and :DDATE_TO) or (FM.ENDENG between :DDATE_FROM and :DDATE_TO) or');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ((FM.BEGENG < :DDATE_FROM) and (COALESCE(FM.ENDENG, :DDATE_TO + 1) > :DDATE_TO)))');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and FM.RN = FMH.PRN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and ((FMH.DO_ACT_FROM between :DDATE_FROM and :DDATE_TO) or (FMH.DO_ACT_TO between :DDATE_FROM and :DDATE_TO) or');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ((FMH.DO_ACT_FROM < :DDATE_FROM) and (COALESCE(FMH.DO_ACT_TO, :DDATE_TO + 1) > :DDATE_TO)))');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and FMH.SCHEDULE = SH.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and ' || PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_BASE.UTL_DOC_ACCESS_CHECK') ||'(FM.COMPANY, ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'ClientPostPerform') || ', FM.RN) = 1');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NCOMPANY', NVALUE => NCOMPANY);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NINS_DEPARTMENT', NVALUE => RPRD.INS_DEPARTMENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NFCMANPOWER', NVALUE => RPRD.FCMANPOWER);
      PKG_SQL_DML.BIND_VARIABLE_DATE(ICURSOR => ICURSOR, SNAME => 'DDATE_FROM', DVALUE => RPRD.DATE_FROM);
      PKG_SQL_DML.BIND_VARIABLE_DATE(ICURSOR => ICURSOR, SNAME => 'DDATE_TO', DVALUE => RPRD.DATE_TO);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 4);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     (       /, ..       ) */
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 3, NVALUE => NPERS_LAB);
        NPERS_LAB := F_DICMUNTS_BASE_RECALC_QUANT(NFLAG_SMART => 0,
                                                  NCOMPANY    => NCOMPANY,
                                                  NUMEAS_FROM => NLAB_MEAS_HOURS,
                                                  NQUANT_FROM => NPERS_LAB,
                                                  NUMEAS_TO   => RJB_PRMS.LAB_MEAS);
        /*      */
        NLAB_PLAN_FOT := NLAB_PLAN_FOT + NPERS_LAB;
        /*      */
        if (NMODE = 0) then
          /*     */
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NRN',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 1,
                                                BCLEAR    => true);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SPERSON',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 2);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NLAB_PLAN_FOT', NVALUE => NPERS_LAB);
          /*     */
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
        end if;
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*      */
    if (NMODE = 0) then
      /*   */
      COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
    end if;
  end JB_PERIODS_PLAN_FOT_BUILD;
  
  /*          */
  procedure JB_PERIODS_PLAN_FOT_LIST
  (
    NJB_PERIODS             in number,        -- .      
    NPAGE_NUMBER            in number,        --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,        --     (0 - )
    CORDERS                 in clob,          --     
    NINCLUDE_DEF            in number,        --       
    COUT                    out clob          --   
  )
  is
    NTMP                    PKG_STD.TLNUMBER; --   
  begin
    /*      */
    JB_PERIODS_PLAN_FOT_BUILD(NJB_PERIODS   => NJB_PERIODS,
                              NMODE         => 0,
                              NPAGE_NUMBER  => NPAGE_NUMBER,
                              NPAGE_SIZE    => NPAGE_SIZE,
                              CORDERS       => CORDERS,
                              NINCLUDE_DEF  => NINCLUDE_DEF,
                              NLAB_PLAN_FOT => NTMP,
                              COUT          => COUT);
  end JB_PERIODS_PLAN_FOT_LIST;
  
  /*         ( ) */
  function JB_PERIODS_PLAN_FOT_CALC
  (
    NJB_PERIODS             in number         -- .      
  ) return                  number            --     ( )
  is
    NRES                    PKG_STD.TLNUMBER; --    
    CTMP                    clob;             --   
  begin
    /*      */
    JB_PERIODS_PLAN_FOT_BUILD(NJB_PERIODS => NJB_PERIODS, NMODE => 1, NLAB_PLAN_FOT => NRES, COUT => CTMP);
    /*    */
    return NRES;
  end JB_PERIODS_PLAN_FOT_CALC;

  /*            "   " */
  procedure JB_PERIODS_FACT_RPT_BUILD
  (
    NJB_PERIODS             in number,                             -- .      
    NMODE                   in number := 0,                        --  (0 -   , 1 -  )
    NPAGE_NUMBER            in number := 0,                        --   (  NPAGE_SIZE=0  NMODE = 1)
    NPAGE_SIZE              in number := 0,                        --     (0 - ,   NMODE = 1)
    CORDERS                 in clob := null,                       --  (  NMODE = 1)
    NINCLUDE_DEF            in number := 1,                        --        (  NMODE = 1)
    NLAB_FACT_RPT           out number,                            --    "   "
    COUT                    out clob                               --    (   NMODE = 0)
  )  
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    RPRD                    P8PNL_JB_PERIODS%rowtype;              --   
    RJB_PRMS                P8PNL_JB_PRMS%rowtype;                 --  
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    DJOB_BEG                PKG_STD.TLDATE;                        --      
    DJOB_END                PKG_STD.TLDATE;                        --      
    NJOB_DUR                PKG_STD.TLNUMBER;                      --     
    NJOB_LAB                PKG_STD.TLNUMBER;                      --     
    NJOB_LAB_MEAS           PKG_STD.TREF;                          --      
  begin
    /*      "   " */
    NLAB_FACT_RPT := 0;
    /*     */
    RPRD := JB_PERIODS_GET(NJB_PERIODS => NJB_PERIODS);
    /*    */
    RJB_PRMS := JB_PRMS_GET(NIDENT => RPRD.IDENT);
    /*       */
    if (NMODE = 1) then
      /*            -     */
      PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => 0,
                                               NPAGE_SIZE   => 0,
                                               NROW_FROM    => NROW_FROM,
                                               NROW_TO      => NROW_TO);
    else
      /*      -   */
      RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
      /*            */
      PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                               NPAGE_SIZE   => NPAGE_SIZE,
                                               NROW_FROM    => NROW_FROM,
                                               NROW_TO      => NROW_TO);
      /*    */
      RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
      /*      */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NRN',
                                                 SCAPTION   => '.    ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SPRJDEPLAN',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SPRJ',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SSTG_JOB',
                                                 SCAPTION   => '-',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SJOB_NAME',
                                                 SCAPTION   => '. ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NJOB_STATE',
                                                 SCAPTION   => '. ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'DJOB_BEG',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'DJOB_END',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NJOB_DUR',
                                                 SCAPTION   => '.  (' || RJB_PRMS.DURATION_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SPERSON',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NLAB',
                                                 SCAPTION   => '. (' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BORDER     => true);
    end if;
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*      ,    */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '         from (select MP.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      DT.DOCCODE || '', '' || trim(T.DOCPREF) || ''/'' || trim(T.DOCNUMB) || '', '' || TO_CHAR(T.DOCDATE, ''dd.mm.yyyy'') SPRJDEPLAN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      P.CODE || ''-'' || P.NAME_USL SPRJ,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      trim(COALESCE(PS.NUMB, ''/'')) || ''-'' || trim(PJ.NUMB) SSTG_JOB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJ.NAME SJOB_NAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJ.STATE NJOB_STATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJ.BEGPLAN DJOB_BEG,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJ.ENDPLAN DJOB_END,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      F_CLNPERSONS_FORMAT_CODE(FMP.COMPANY, FMP.CODE) SPERSON,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      MP.LABOUR_F NLAB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJMP.UMEAS NLAB_MEAS');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 from PRJDEPLAN        T,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      DOCTYPES         DT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      ENPERIOD         PR,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PRJDEPLANMANPOW  MP');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      left outer join CLNPSPFM FM on MP.CLNPSPFM = FM.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      left outer join CLNPERSONS FMP on FM.PERSRN = FMP.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PROJECT          P,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PROJECTJOB       PJ');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      left outer join PROJECTSTAGE PS on PJ.PROJECTSTAGE = PS.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PROJECTJOBMANPOW PJMP');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                where T.COMPANY = :NCOMPANY');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and T.STATE = 2');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and T.PERIOD = PR.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and T.DOCTYPE = DT.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and T.SUBDIV = :NINS_DEPARTMENT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and ((PR.STARTDATE between :DDATE_FROM and :DDATE_TO) or (PR.ENDDATE between :DDATE_FROM and :DDATE_TO) or');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      ((PR.STARTDATE < :DDATE_FROM) and (PR.ENDDATE > :DDATE_TO)))');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and MP.PRN in (select PJ.RN from PRJDEPPLANJOB PJ where PJ.PRN = T.RN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and MP.PROJECTJOBMANPOW = PJMP.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJMP.FCMANPOWER = :NFCMANPOWER');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJMP.PRN = PJ.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJ.PRN = P.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and exists (select null from V_USERPRIV UP where UP."CATALOG" = T.CRN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'ProjectDepartmentPlans') || ')');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NCOMPANY', NVALUE => NCOMPANY);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NINS_DEPARTMENT', NVALUE => RPRD.INS_DEPARTMENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NFCMANPOWER', NVALUE => RPRD.FCMANPOWER);
      PKG_SQL_DML.BIND_VARIABLE_DATE(ICURSOR => ICURSOR, SNAME => 'DDATE_FROM', DVALUE => RPRD.DATE_FROM);
      PKG_SQL_DML.BIND_VARIABLE_DATE(ICURSOR => ICURSOR, SNAME => 'DDATE_TO', DVALUE => RPRD.DATE_TO);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 10);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 11);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 12);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*       */
        PKG_SQL_DML.COLUMN_VALUE_DATE(ICURSOR => ICURSOR, IPOSITION => 7, DVALUE => DJOB_BEG);
        PKG_SQL_DML.COLUMN_VALUE_DATE(ICURSOR => ICURSOR, IPOSITION => 8, DVALUE => DJOB_END);
        P_PROJECTJOB_GET_DURATION(NCOMPANY       => NCOMPANY,
                                  DBEG_DATE      => DJOB_BEG,
                                  DEND_DATE      => DJOB_END,
                                  NDURATION_MEAS => RJB_PRMS.DURATION_MEAS,
                                  NDURATION      => NJOB_DUR);
        /*       */
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 10, NVALUE => NJOB_LAB);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 11, NVALUE => NJOB_LAB_MEAS);
        NJOB_LAB := F_DICMUNTS_BASE_RECALC_QUANT(NFLAG_SMART => 0,
                                                 NCOMPANY    => NCOMPANY,
                                                 NUMEAS_FROM => NJOB_LAB_MEAS,
                                                 NQUANT_FROM => NJOB_LAB,
                                                 NUMEAS_TO   => RJB_PRMS.LAB_MEAS);
        /*      */
        NLAB_FACT_RPT := NLAB_FACT_RPT + NJOB_LAB;
        /*      */
        if (NMODE = 0) then
          /*     */
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NRN',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 1,
                                                BCLEAR    => true);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SPRJDEPLAN',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 2);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SPRJ', ICURSOR => ICURSOR, NPOSITION => 3);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SSTG_JOB',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 4);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SJOB_NAME',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 5);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NJOB_STATE',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 6);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'DJOB_BEG', DVALUE => DJOB_BEG);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'DJOB_END', DVALUE => DJOB_END);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NJOB_DUR', NVALUE => NJOB_DUR);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SPERSON',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 9);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NLAB', NVALUE => NJOB_LAB);
          /*     */
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
        end if;
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*      */
    if (NMODE = 0) then
      /*   */
      COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
    end if;
  end JB_PERIODS_FACT_RPT_BUILD;
  
  /*          "   " */
  procedure JB_PERIODS_FACT_RPT_LIST
  (
    NJB_PERIODS             in number,        -- .      
    NPAGE_NUMBER            in number,        --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,        --     (0 - )
    CORDERS                 in clob,          --     
    NINCLUDE_DEF            in number,        --       
    COUT                    out clob          --   
  )  
  is
    NTMP                    PKG_STD.TLNUMBER; --   
  begin
    /*     "   " */
    JB_PERIODS_FACT_RPT_BUILD(NJB_PERIODS   => NJB_PERIODS,
                              NMODE         => 0,
                              NPAGE_NUMBER  => NPAGE_NUMBER,
                              NPAGE_SIZE    => NPAGE_SIZE,
                              CORDERS       => CORDERS,
                              NINCLUDE_DEF  => NINCLUDE_DEF,
                              NLAB_FACT_RPT => NTMP,
                              COUT          => COUT);
  end JB_PERIODS_FACT_RPT_LIST;
  
  /*       "   "    */
  function JB_PERIODS_FACT_RPT_CALC
  (
    NJB_PERIODS             in number         -- .      
  ) return                  number            --      "   "
  is
    NRES                    PKG_STD.TLNUMBER; --   
    CTMP                    clob;             --   
  begin
    /*     "   " */
    JB_PERIODS_FACT_RPT_BUILD(NJB_PERIODS => NJB_PERIODS, NMODE => 1, NLAB_FACT_RPT => NRES, COUT => CTMP);
    /*    */
    return NRES;
  end JB_PERIODS_FACT_RPT_CALC;
  
  /*              */
  procedure JB_PERIODS_PLAN_JOBS_BUILD
  (
    NJB_PERIODS             in number,                             -- .      
    NMODE                   in number := 0,                        --  (0 -   , 1 -  )
    NPAGE_NUMBER            in number := 0,                        --   (  NPAGE_SIZE=0  NMODE = 1)
    NPAGE_SIZE              in number := 0,                        --     (0 - ,   NMODE = 1)
    CORDERS                 in clob := null,                       --  (  NMODE = 1)
    NINCLUDE_DEF            in number := 1,                        --        (  NMODE = 1)
    NLAB_PLAN_JOB           out number,                            --    
    COUT                    out clob                               --    (   NMODE = 0)
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    RPRD                    P8PNL_JB_PERIODS%rowtype;              --   
    RJB_PRMS                P8PNL_JB_PRMS%rowtype;                 --  
    RO                      PKG_P8PANELS_VISUAL.TORDERS;           -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    DBEG                    PKG_STD.TLDATE;                        --       
    DEND                    PKG_STD.TLDATE;                        --       
    DJOB_BEG                PKG_STD.TLDATE;                        --      -
    DJOB_END                PKG_STD.TLDATE;                        --      -
    NJOB_DUR                PKG_STD.TLNUMBER;                      --     -
    NMP_LAB_MEAS            PKG_STD.TREF;                          --      
    NMP_LAB                 PKG_STD.TLNUMBER;                      --        
    NMP_LAB_ONE             PKG_STD.TLNUMBER;                      --  (  )       
    NMP_LAB_PLAN            PKG_STD.TLNUMBER;                      --        -
  begin
    /*       */
    NLAB_PLAN_JOB := 0;
    /*     */
    RPRD := JB_PERIODS_GET(NJB_PERIODS => NJB_PERIODS);
    /*    */
    RJB_PRMS := JB_PRMS_GET(NIDENT => RPRD.IDENT);
    /*       */
    if (NMODE = 1) then
      /*            -     */
      PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => 0,
                                               NPAGE_SIZE   => 0,
                                               NROW_FROM    => NROW_FROM,
                                               NROW_TO      => NROW_TO);
    else
      /*      -   */
      RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
      /*            */
      PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                               NPAGE_SIZE   => NPAGE_SIZE,
                                               NROW_FROM    => NROW_FROM,
                                               NROW_TO      => NROW_TO);
      /*    */
      RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
      /*      */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NRN',
                                                 SCAPTION   => '.     ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NPROJECT',
                                                 SCAPTION   => '.  ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NJB_PRJCTS',
                                                 SCAPTION   => '.    ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BVISIBLE   => false);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SPRJ',
                                                 SCAPTION   => '',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SSTG_JOB',
                                                 SCAPTION   => '-',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SJOB_NAME',
                                                 SCAPTION   => '. ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NJOB_STATE',
                                                 SCAPTION   => '. ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'DJOB_BEG',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'DJOB_END',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                                 BORDER     => true);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NJOB_DUR',
                                                 SCAPTION   => '.  (' || RJB_PRMS.DURATION_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NMP_LAB',
                                                 SCAPTION   => '. (' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NMP_LAB_ONE',
                                                 SCAPTION   => '. ( . ., ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'NMP_LAB_PLAN',
                                                 SCAPTION   => '. (, , ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    end if;
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '         from (select JB.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      P.RN NPROJECT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      JBP.RN NJB_PRJCTS,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      P.CODE || ''-'' || P.NAME_USL SPRJ,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      trim(PS.NUMB) || ''-'' || trim(PJ.NUMB) SSTG_JOB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJ.NAME SJOB_NAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJ.STATE NJOB_STATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      JB.DATE_FROM DJOB_BEG,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      JB.DATE_TO DJOB_END,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJMP.LABOUR_P NLABOUR_P,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PJMP.UMEAS NLABOUR_P_UMEAS');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 from P8PNL_JB_JOBS JB,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      P8PNL_JB_PRJCTS JBP,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PROJECTJOB PJ');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      left outer join PROJECTSTAGE PS on PJ.PROJECTSTAGE = PS.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PROJECTJOBMANPOW PJMP,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      PROJECT P');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                where JB.IDENT = :NIDENT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and JB.STAGE = ' || PKG_SQL_BUILD.WRAP_NUM(NVALUE => 0));
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and JB.PRN = JBP.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and JB.SOURCE = PJ.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJ.COMPANY = :NCOMPANY');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJ.PRN = P.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJ.RN = PJMP.PRN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJMP.FCMANPOWER = :NFCMANPOWER');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and PJMP.SUBDIV = :NINS_DEPARTMENT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and ((JB.DATE_FROM between :DDATE_FROM and :DDATE_TO) or (JB.DATE_TO between :DDATE_FROM and :DDATE_TO) or');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                      ((JB.DATE_FROM < :DDATE_FROM) and (JB.DATE_TO > :DDATE_TO)))');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and exists (select null from V_USERPRIV UP where UP."CATALOG" = P.CRN)');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = P.JUR_PERS and UP.UNITCODE = ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'Projects') || ')');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NCOMPANY', NVALUE => NCOMPANY);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => RPRD.IDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NINS_DEPARTMENT', NVALUE => RPRD.INS_DEPARTMENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NFCMANPOWER', NVALUE => RPRD.FCMANPOWER);
      PKG_SQL_DML.BIND_VARIABLE_DATE(ICURSOR => ICURSOR, SNAME => 'DDATE_FROM', DVALUE => RPRD.DATE_FROM);
      PKG_SQL_DML.BIND_VARIABLE_DATE(ICURSOR => ICURSOR, SNAME => 'DDATE_TO', DVALUE => RPRD.DATE_TO);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 10);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 11);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 12);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*           (  ) */
        PKG_SQL_DML.COLUMN_VALUE_DATE(ICURSOR => ICURSOR, IPOSITION => 8, DVALUE => DJOB_BEG);
        PKG_SQL_DML.COLUMN_VALUE_DATE(ICURSOR => ICURSOR, IPOSITION => 9, DVALUE => DJOB_END);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 10, NVALUE => NMP_LAB);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 11, NVALUE => NMP_LAB_MEAS);
        P_PROJECTJOB_GET_DURATION(NCOMPANY       => NCOMPANY,
                                  DBEG_DATE      => DJOB_BEG,
                                  DEND_DATE      => DJOB_END,
                                  NDURATION_MEAS => RJB_PRMS.DURATION_MEAS,
                                  NDURATION      => NJOB_DUR);
        NMP_LAB := F_DICMUNTS_BASE_RECALC_QUANT(NFLAG_SMART => 0,
                                                NCOMPANY    => NCOMPANY,
                                                NUMEAS_FROM => NMP_LAB_MEAS,
                                                NQUANT_FROM => NMP_LAB,
                                                NUMEAS_TO   => RJB_PRMS.LAB_MEAS);
        DBEG    := RPRD.DATE_FROM;
        if (DJOB_BEG > RPRD.DATE_FROM) then
          DBEG := DJOB_BEG;
        end if;
        DEND := RPRD.DATE_TO;
        if (DJOB_END < RPRD.DATE_TO) then
          DEND := DJOB_END;
        end if;
        if (DJOB_END - DJOB_BEG <> 0) then
          NMP_LAB_ONE := ROUND(NMP_LAB / (DJOB_END - DJOB_BEG), 3);
        else
          NMP_LAB_ONE := ROUND(NMP_LAB, 3);
        end if;
        NMP_LAB_PLAN := ROUND((DEND - DBEG) * NMP_LAB_ONE, 3);
        /*      */
        NLAB_PLAN_JOB := NLAB_PLAN_JOB + NMP_LAB_PLAN;
        /*      */
        if (NMODE = 0) then
          /*     */
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NRN',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 1,
                                                BCLEAR    => true);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NPROJECT',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 2);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NJB_PRJCTS',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 3);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SPRJ', ICURSOR => ICURSOR, NPOSITION => 4);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SSTG_JOB',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 5);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                SNAME     => 'SJOB_NAME',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 6);
          PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                SNAME     => 'NJOB_STATE',
                                                ICURSOR   => ICURSOR,
                                                NPOSITION => 7);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'DJOB_BEG', DVALUE => DJOB_BEG);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'DJOB_END', DVALUE => DJOB_END);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NJOB_DUR', NVALUE => NJOB_DUR);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NMP_LAB', NVALUE => NMP_LAB);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NMP_LAB_ONE', NVALUE => NMP_LAB_ONE);
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NMP_LAB_PLAN', NVALUE => NMP_LAB_PLAN);
          /*     */
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
        end if;
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*      */
    if (NMODE = 0) then
      /*   */
      COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
    end if;
  end JB_PERIODS_PLAN_JOBS_BUILD;
  
  /*            */
  procedure JB_PERIODS_PLAN_JOBS_LIST
  (
    NJB_PERIODS             in number,        -- .      
    NPAGE_NUMBER            in number,        --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,        --     (0 - )
    CORDERS                 in clob,          --     
    NINCLUDE_DEF            in number,        --       
    COUT                    out clob          --   
  )
  is
    NTMP                    PKG_STD.TLNUMBER; --   
  begin
    /*       - */
    JB_PERIODS_PLAN_JOBS_BUILD(NJB_PERIODS   => NJB_PERIODS,
                               NMODE         => 0,
                               NPAGE_NUMBER  => NPAGE_NUMBER,
                               NPAGE_SIZE    => NPAGE_SIZE,
                               CORDERS       => CORDERS,
                               NINCLUDE_DEF  => NINCLUDE_DEF,
                               NLAB_PLAN_JOB => NTMP,
                               COUT          => COUT);
  end JB_PERIODS_PLAN_JOBS_LIST;
  
  /*              */
  function JB_PERIODS_PLAN_JOBS_CALC
  (
    NJB_PERIODS             in number         -- .      
  ) return                  number            --         
  is
    NRES                    PKG_STD.TLNUMBER; --   
    CTMP                    clob;             --   
  begin
    /*        */
    JB_PERIODS_PLAN_JOBS_BUILD(NJB_PERIODS => NJB_PERIODS, NMODE => 1, NLAB_PLAN_JOB => NRES, COUT => CTMP);
    /*   */
    return NRES;
  end JB_PERIODS_PLAN_JOBS_CALC;
  
  /*        */
  procedure JB_PERIODS_SET_LAB
  (
    NJB_PERIODS             in number,  -- .    
    NLAB_PLAN_FOT           in number,  --    
    NLAB_FACT_RPT           in number,  --    "   "
    NLAB_PLAN_JOBS          in number   --    -
  )
  is
  begin
    /*   */
    update P8PNL_JB_PERIODS T
       set T.LAB_PLAN_FOT  = NLAB_PLAN_FOT,
           T.LAB_FACT_RPT  = NLAB_FACT_RPT,
           T.LAB_PLAN_JOBS = NLAB_PLAN_JOBS
     where T.RN = NJB_PERIODS;
  end JB_PERIODS_SET_LAB;
  
  /*      */
  procedure JB_PERIODS_BASE_INSERT
  (
    NIDENT                  in number,      --  
    DDATE_FROM              in date,        -- 
    DDATE_TO                in date,        -- 
    NINS_DEPARTMENT         in number,      -- .   
    NFCMANPOWER             in number,      -- .   
    NLAB_PLAN_FOT           in number := 0, --  (,  )
    NLAB_FACT_RPT           in number := 0, --  (,  )
    NLAB_PLAN_JOBS          in number := 0, --  (,  )
    NJB_PERIODS             out number      -- .    
  )
  is
  begin
    /*  .   */
    NJB_PERIODS := GEN_ID();
    /*   */
    insert into P8PNL_JB_PERIODS
      (RN,
       IDENT,
       DATE_FROM,
       DATE_TO,
       INS_DEPARTMENT,
       FCMANPOWER,
       LAB_PLAN_FOT,
       LAB_FACT_RPT,
       LAB_PLAN_JOBS)
    values
      (NJB_PERIODS,
       NIDENT,
       DDATE_FROM,
       DDATE_TO,
       NINS_DEPARTMENT,
       NFCMANPOWER,
       NLAB_PLAN_FOT,
       NLAB_FACT_RPT,
       NLAB_PLAN_JOBS);
  end JB_PERIODS_BASE_INSERT;
  
  /*    */
  procedure JB_PERIODS_CLEAN
  (
    NIDENT                  in number   --  
  )
  is
  begin
    /*    */
    delete from P8PNL_JB_PERIODS T where T.IDENT = NIDENT;
  end JB_PERIODS_CLEAN;
  
  /*    */
  procedure JB_PERIODS_RECALC
  (
    NIDENT                  in number,             --  
    NINITIAL                in number,             --    (0 - , 1 -  )
    NRESOURCE_STATUS        out number             --   (0 -  , 1 -  )
  )
  is
    RJB_PRMS                P8PNL_JB_PRMS%rowtype; --  
    DJB_BEG                 PKG_STD.TLDATE;        --    
    DJB_END                 PKG_STD.TLDATE;        --    
    DBEG                    PKG_STD.TLDATE;        --      
    DEND                    PKG_STD.TLDATE;        --      
    NJB_PERIODS             PKG_STD.TREF;          -- .    
    NLAB_PLAN_FOT           PKG_STD.TLNUMBER;      --         
    NLAB_FACT_RPT           PKG_STD.TLNUMBER;      --    "   "     
    NLAB_PLAN_JOBS          PKG_STD.TLNUMBER;      --    -       
  begin
    /*    */
    RJB_PRMS := JB_PRMS_GET(NIDENT => NIDENT);
    /*    */
    if (NINITIAL = 0) then
      JB_PERIODS_CLEAN(NIDENT => NIDENT);
    end if;
    /* ,    */
    NRESOURCE_STATUS := 0;
    /*    */
    DJB_BEG := RJB_PRMS.DATE_BEGIN;
    DJB_END := JB_GET_END(NIDENT => NIDENT);
    /*     */
    for I in 0 .. FLOOR(MONTHS_BETWEEN(DJB_END, DJB_BEG))
    loop
      DBEG := TRUNC(ADD_MONTHS(DJB_BEG, I), 'mm');
      DEND := LAST_DAY(DBEG);
      /*  ,       */
      for D in (select JMP.FCMANPOWER,
                       JMP.SUBDIV
                  from P8PNL_JB_JOBS    JB,
                       PROJECTJOB       J,
                       PROJECTJOBMANPOW JMP
                 where JB.IDENT = NIDENT
                   and JB.STAGE = 0
                   and ((JB.DATE_FROM between DBEG and DEND) or (JB.DATE_TO between DBEG and DEND) or
                       ((JB.DATE_FROM < DBEG) and (JB.DATE_TO > DEND)))
                   and JB.SOURCE = J.RN
                   and J.RN = JMP.PRN
                   and JMP.SUBDIV is not null
                   and exists (select null from V_USERPRIV UP where UP.CATALOG = J.CRN)
                   and exists (select null
                          from V_USERPRIV UP
                         where UP.JUR_PERS = J.JUR_PERS
                           and UP.UNITCODE = 'Projects')
                   and exists (select null
                          from UNITLIST UL
                         where UL.UNITCODE = 'INS_DEPARTMENT'
                           and UL.CHECK_ACCESS_HIER = 0
                           and exists (select /*+ INDEX(UP I_USERPRIV_COMPANY_ROLEID) */
                                 null
                                  from USERPRIV UP
                                 where UP.COMPANY = JMP.COMPANY
                                   and UP.UNITCODE = 'INS_DEPARTMENT'
                                   and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                                      UR.ROLEID
                                                       from USERROLES UR
                                                      where UR.AUTHID = UTILIZER)
                                union all
                                select /*+ INDEX(UP I_USERPRIV_COMPANY_AUTHID) */
                                 null
                                  from USERPRIV UP
                                 where UP.COMPANY = JMP.COMPANY
                                   and UP.UNITCODE = 'INS_DEPARTMENT'
                                   and UP.AUTHID = UTILIZER)
                        union all
                        select /*+ INDEX(UP I_USERPRIV_HIERARCHY_ROLEID) */
                         null
                          from USERPRIV UP
                         where UP.HIERARCHY = JMP.SUBDIV
                           and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                              UR.ROLEID
                                               from USERROLES UR
                                              where UR.AUTHID = UTILIZER)
                        union all
                        select /*+ INDEX(UP I_USERPRIV_HIERARCHY_AUTHID) */
                         null
                          from USERPRIV UP
                         where UP.HIERARCHY = JMP.SUBDIV
                           and UP.AUTHID = UTILIZER)
                 group by JMP.FCMANPOWER,
                          JMP.SUBDIV)
      loop
        /*     */
        JB_PERIODS_BASE_INSERT(NIDENT          => NIDENT,
                               DDATE_FROM      => DBEG,
                               DDATE_TO        => DEND,
                               NINS_DEPARTMENT => D.SUBDIV,
                               NFCMANPOWER     => D.FCMANPOWER,
                               NLAB_PLAN_FOT   => 0,
                               NLAB_FACT_RPT   => 0,
                               NLAB_PLAN_JOBS  => 0,
                               NJB_PERIODS     => NJB_PERIODS);
        /*     ( ) */
        NLAB_PLAN_FOT := JB_PERIODS_PLAN_FOT_CALC(NJB_PERIODS => NJB_PERIODS);
        /*    "   " */
        NLAB_FACT_RPT := JB_PERIODS_FACT_RPT_CALC(NJB_PERIODS => NJB_PERIODS);
        /*      */
        NLAB_PLAN_JOBS := JB_PERIODS_PLAN_JOBS_CALC(NJB_PERIODS => NJB_PERIODS);
        /*   */
        JB_PERIODS_SET_LAB(NJB_PERIODS    => NJB_PERIODS,
                           NLAB_PLAN_FOT  => NLAB_PLAN_FOT,
                           NLAB_FACT_RPT  => NLAB_FACT_RPT,
                           NLAB_PLAN_JOBS => NLAB_PLAN_JOBS);
        /*         -      */
        if (NLAB_PLAN_JOBS > NLAB_PLAN_FOT) then
          NRESOURCE_STATUS := 1;
        end if;
      end loop;
    end loop;
  end JB_PERIODS_RECALC;
  
  /*    */
  procedure JB_PERIODS_LIST
  (
    NIDENT                  in number,                      --  
    NPAGE_NUMBER            in number,                      --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,                      --     (0 - )
    CORDERS                 in clob,                        --     
    NINCLUDE_DEF            in number,                      --       
    COUT                    out clob                        --   
  )
  is
    RJB_PRMS                P8PNL_JB_PRMS%rowtype;          --  
    RO                      PKG_P8PANELS_VISUAL.TORDERS;    -- 
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
    CSQL                    clob;                           --   
    ICURSOR                 integer;                        --    
    NROW_FROM               PKG_STD.TREF;                   --   
    NROW_TO                 PKG_STD.TREF;                   --   
  begin
    /*    */
    RJB_PRMS := JB_PRMS_GET(NIDENT => NIDENT);
    /*   */
    RO := PKG_P8PANELS_VISUAL.TORDERS_FROM_XML(CORDERS => CORDERS);
    /*            */
    PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                             NPAGE_SIZE   => NPAGE_SIZE,
                                             NROW_FROM    => NROW_FROM,
                                             NROW_TO      => NROW_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SPERIOD',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SINS_DEPARTMENT',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SFCMANPOWER',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLAB_PLAN_FOT',
                                               SCAPTION   => '. (, , ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLAB_FACT_RPT',
                                               SCAPTION   => '. (, , ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => true,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLAB_DIFF_RPT_FOT',
                                               SCAPTION   => '. (-, ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => true,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLAB_PLAN_JOBS',
                                               SCAPTION   => '. (, , ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BORDER     => true,
                                               BFILTER    => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NLAB_DIFF_JOBS_FOT',
                                               SCAPTION   => '. (-, ' || RJB_PRMS.LAB_MEAS_CODE || ')',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BORDER     => true,
                                               BFILTER    => false);
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select P.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       TO_CHAR(P.DATE_FROM, ''YYYY.MM'') SPERIOD,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       INSD.CODE SINS_DEPARTMENT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       MP.CODE SFCMANPOWER,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.LAB_PLAN_FOT NLAB_PLAN_FOT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.LAB_FACT_RPT NLAB_FACT_RPT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.LAB_FACT_RPT - P.LAB_PLAN_FOT NLAB_DIFF_RPT_FOT,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.LAB_PLAN_JOBS NLAB_PLAN_JOBS,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       P.LAB_PLAN_JOBS - P.LAB_PLAN_FOT NLAB_DIFF_JOBS_FOT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from P8PNL_JB_PERIODS P,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       INS_DEPARTMENT   INSD,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       FCMANPOWER       MP');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 where P.IDENT = :NIDENT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and P.INS_DEPARTMENT = INSD.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and P.FCMANPOWER = MP.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and ' || PKG_SQL_BUILD.PKG_NAME(SNAME => 'PKG_P8PANELS_BASE.UTL_DOC_ACCESS_CHECK') ||'(INSD.COMPANY, ' || PKG_SQL_BUILD.WRAP_STR(SVALUE => 'INS_DEPARTMENT') || ', INSD.RN) = 1');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TORDERS_SET_QUERY(RDATA_GRID => RDG, RORDERS => RO, SPATTERN => '%ORDER_BY%', CSQL => CSQL);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => NIDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 10);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     */
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NRN',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 1,
                                              BCLEAR    => true);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SPERIOD', ICURSOR => ICURSOR, NPOSITION => 2);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SINS_DEPARTMENT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 3);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                              SNAME     => 'SFCMANPOWER',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 4);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLAB_PLAN_FOT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 5);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLAB_FACT_RPT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 6);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLAB_DIFF_RPT_FOT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 7);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLAB_PLAN_JOBS',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 8);
        PKG_P8PANELS_VISUAL.TROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                              SNAME     => 'NLAB_DIFF_JOBS_FOT',
                                              ICURSOR   => ICURSOR,
                                              NPOSITION => 9);
        /*     */
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end JB_PERIODS_LIST;
  
  /*    */
  procedure JB_CLEAN
  (
    NIDENT                  in number   --  
  )
  is
  begin
    /*    */
    JB_PRMS_CLEAN(NIDENT => NIDENT);
    /*     */
    delete from P8PNL_JB_JOBSPREV T where T.IDENT = NIDENT;
    /*    */
    for C in (select T.RN
                from P8PNL_JB_JOBS T
               where T.IDENT = NIDENT
              connect by prior T.RN = T.HRN
               start with T.HRN is null
               order by level desc)
    loop
      delete from P8PNL_JB_JOBS T where T.RN = C.RN;
    end loop;
    /*    */
    delete from P8PNL_JB_PRJCTS T where T.IDENT = NIDENT;
    /*    */
    JB_PERIODS_CLEAN(NIDENT => NIDENT);
  end JB_CLEAN;
  
  /*       */
  procedure JB_SAVE
  (
    NIDENT                  in number,    --  
    COUT                    out clob      --  
  )
  is
    NJH                     PKG_STD.TREF; -- .     
  begin
    /*     */
    for P in (select T.*
                from P8PNL_JB_PRJCTS T
               where T.IDENT = NIDENT
                 and T.CHANGED = 1)
    loop
      /*     */
      for J in (select T.*
                  from P8PNL_JB_JOBS T
                 where T.IDENT = NIDENT
                   and T.PRN = P.RN
                   and T.STAGE = 0
                   and T.CHANGED = 1)
      loop
        /*     */
        for PJ in (select T.* from PROJECTJOB T where T.RN = J.SOURCE)
        loop
          P_PROJECTJOB_BASE_UPDATE(NRN                => PJ.RN,
                                   NCOMPANY           => PJ.COMPANY,
                                   NJUR_PERS          => PJ.JUR_PERS,
                                   NPROJECTSTAGE      => PJ.PROJECTSTAGE,
                                   NFACEACC           => PJ.FACEACC,
                                   SNUMB              => PJ.NUMB,
                                   SBUDG_NUMB         => PJ.BUDG_NUMB,
                                   SNAME              => PJ.NAME,
                                   NPRJOB             => PJ.PRJOB,
                                   NPRIORITY          => PJ.PRIORITY,
                                   NRESTRICTION       => PJ.RESTRICTION,
                                   DRESTRICT_DATE     => PJ.RESTRICT_DATE,
                                   NDURATION_CHG      => PJ.DURATION_CHG,
                                   NDURATION_NRM      => PJ.DURATION_NRM,
                                   NDURATION_MEAS     => PJ.DURATION_MEAS,
                                   NDURATION_P        => PJ.DURATION_P,
                                   NDURATION_F        => PJ.DURATION_F,
                                   NSUBDIV            => PJ.SUBDIV,
                                   NPERFORM           => PJ.PERFORM,
                                   NRELEASE           => PJ.RELEASE,
                                   NVOLUME_P          => PJ.VOLUME_P,
                                   NVOLUME_F          => PJ.VOLUME_F,
                                   NPRICE_P           => PJ.PRICE_P,
                                   NPRICE_F           => PJ.PRICE_F,
                                   NCURNAMES          => PJ.CURNAMES,
                                   NFPDARTCL          => PJ.FPDARTCL,
                                   NCOST_PLAN         => PJ.COST_PLAN,
                                   NCOST_FACT         => PJ.COST_FACT,
                                   NCOST_BPRICE       => PJ.COST_BPRICE,
                                   NCOST_CALC         => PJ.COST_CALC,
                                   NSTATE             => PJ.STATE,
                                   NPERFORM_PRC       => PJ.PERFORM_PRC,
                                   NFINDEFLINIT       => PJ.FINDEFLINIT,
                                   DBEGPLAN           => J.DATE_FROM,
                                   DBEGFACT           => PJ.BEGFACT,
                                   DENDPLAN           => J.DATE_TO,
                                   DENDFACT           => PJ.ENDFACT,
                                   SNOTE              => PJ.NOTE,
                                   DDO_ACT_FROM       => sysdate,
                                   NRFLCT_HS          => PJ.RFLCT_HS,
                                   NLAB_NORM          => PJ.LAB_NORM,
                                   NCALC_LAB          => PJ.CALC_LAB,
                                   NLAB_PLAN_I        => PJ.LAB_PLAN,
                                   NLAB_FACT_I        => PJ.LAB_FACT,
                                   NLAB_PART          => PJ.LAB_PART,
                                   NLAB_MEAS          => PJ.LAB_MEAS,
                                   SCHNG_BASE         => PJ.CHNG_BASE,
                                   NFACEACCPERF       => PJ.FACEACCPERF,
                                   NCHECK_DO_ACT_FROM => 0,
                                   NLAB_UNITCOST      => PJ.LAB_UNITCOST,
                                   NLAB_CURRENCY      => PJ.LAB_CURRENCY);
          P_PROJECTJOBHS_MAKE_HIST(NCOMPANY => PJ.COMPANY, NPRN => PJ.RN, NCHECK_HS => 0, NRN => NJH);
        end loop;
        /*        */
        JB_JOBS_SET_CHANGED(NJB_JOBS => J.RN, NCHANGED => 0);
      end loop;
      /*        */
      JB_PRJCTS_SET_CHANGED(NJB_PRJCTS => P.RN, NCHANGED => 0);
    end loop;
    /*     */
    JB_PRJCTS_LIST(NIDENT => NIDENT, COUT => COUT);
  end JB_SAVE;
  
  /*      -  */
  procedure JB_INIT
  (
    DBEGIN                  in out date,                           --      
    DFACT                   in out date,                           --    
    NDURATION_MEAS          out number,                            --    (0 - , 1 - , 2 - , 3 - , 4 - , 5 - )
    SDURATION_MEAS          out varchar2,                          --    ()
    NLAB_MEAS               out number,                            --   
    SLAB_MEAS               out varchar2,                          --    ()
    NIDENT                  in out number,                         --   (null -  , !null -        )
    NRESOURCE_STATUS        out number                             --   (0 -  , 1 -  )
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    SUTILIZER               PKG_STD.TSTRING := UTILIZER();         --  
    NJB_PRJCTS              PKG_STD.TREF;                          -- .      
    NJB_JOBS_STAGE          PKG_STD.TREF;                          -- .       
    NJB_JOBS_JOB            PKG_STD.TREF;                          -- .       
    NJB_JOBS_JOBPREV        PKG_STD.TREF;                          -- .        
    RH_JB_JOBS              P8PNL_JB_JOBS%rowtype;                 --   /   
    RH_JB_JOBS_PREV         P8PNL_JB_JOBS%rowtype;                 --          
    NDURATION               P8PNL_JB_JOBS.DURATION%type;           --   /
    NEDITABLE               PKG_STD.TREF;                          --    
    NPRMS                   PKG_STD.TREF;                          -- .    
  begin
    /*        */
    if (DBEGIN is null) then
      DBEGIN := TRUNC(sysdate, 'yyyy');
    else
      DBEGIN := TRUNC(DBEGIN, 'mm');
    end if;
    /*    */
    if (DFACT is null) then
      select LAST_DAY(TRUNC(COALESCE(max(ENP.ENDDATE), DBEGIN), 'mm'))
        into DFACT
        from PRJDEPLAN T,
             ENPERIOD  ENP
       where T.COMPANY = NCOMPANY
         and T.STATE = 2
         and T.PERIOD = ENP.RN
         and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
         and exists (select null
                from V_USERPRIV UP
               where UP.JUR_PERS = T.JUR_PERS
                 and UP.UNITCODE = 'ProjectDepartmentPlans');
    else
      DFACT := LAST_DAY(TRUNC(DFACT, 'mm'));
    end if;
    /*     ( -     "",  ) */
    NDURATION_MEAS := NJB_DURATION_MEAS;
    SDURATION_MEAS := JB_GET_DURATION_MEAS_CODE(NDURATION_MEAS => NDURATION_MEAS);
    /*     ( -     "/",  ) */
    SLAB_MEAS := SJB_LAB_MEAS;
    FIND_DICMUNTS_BY_MNEMO(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, SMEAS_MNEMO => SLAB_MEAS, NRN => NLAB_MEAS);
    /*    */
    if (NIDENT is null) then
      NIDENT := GEN_IDENT();
    else
      JB_CLEAN(NIDENT => NIDENT);
    end if;
    /*    */
    JB_PRMS_BASE_INSERT(NIDENT              => NIDENT,
                        DDATE_BEGIN         => DBEGIN,
                        DDATE_FACT          => DFACT,
                        NDURATION_MEAS      => NDURATION_MEAS,
                        SDURATION_MEAS_CODE => SDURATION_MEAS,
                        NLAB_MEAS           => NLAB_MEAS,
                        SLAB_MEAS_CODE      => SLAB_MEAS,
                        NRN                 => NPRMS);
    /*   */
    for PRJ in (select P.RN NRN,
                       COALESCE((select 1
                                  from PROJECTJOB   PJ,
                                       PROJECTSTAGE PS
                                 where PJ.PRN = P.RN
                                   and PJ.BEGPLAN is not null
                                   and PJ.ENDPLAN is not null
                                   and PJ.PROJECTSTAGE = PS.RN
                                   and PS.BEGPLAN is not null
                                   and PS.ENDPLAN is not null
                                   and ROWNUM <= 1),
                                0) NJOBS,
                       0 NEDITABLE,
                       P.BEGPLAN DBEGPLAN,
                       P.ENDPLAN DENDPLAN
                  from PROJECT P
                 where P.COMPANY = NCOMPANY
                   and P.STATE not in (3, 5)
                   and exists (select null from V_USERPRIV UP where UP.CATALOG = P.CRN)
                   and exists (select null
                          from V_USERPRIV UP
                         where UP.JUR_PERS = P.JUR_PERS
                           and UP.UNITCODE = 'Projects')
                 order by P.NAME_USL)
    loop
      /*     */
      if (CHECK_RESPONSIBLE(NRN => PRJ.NRN, SAUTHID => SUTILIZER) = 1) then
        PRJ.NEDITABLE := 1;
      end if;
      /*      */
      JB_PRJCTS_BASE_INSERT(NIDENT     => NIDENT,
                            NPROJECT   => PRJ.NRN,
                            NJOBS      => PRJ.NJOBS,
                            NEDITABLE  => PRJ.NEDITABLE,
                            NCHANGED   => 0,
                            NJB_PRJCTS => NJB_PRJCTS);
      /*       */
      for STG in (select PS.COMPANY NCOMPANY,
                         PS.RN NRN,
                         PS.HRN NHRN,
                         trim(PS.NUMB) SNUMB,
                         PS.NAME SNAME,
                         PS.BEGPLAN DBEGPLAN,
                         PS.ENDPLAN DENDPLAN,
                         COALESCE(AG.AGNABBR, DP.CODE) SEXECUTOR
                    from PROJECTSTAGE   PS,
                         AGNLIST        AG,
                         INS_DEPARTMENT DP
                   where PS.PRN = PRJ.NRN
                     and PS.BEGPLAN is not null
                     and PS.ENDPLAN is not null
                     and PS.RESPONSIBLE = AG.RN(+)
                     and PS.SUBDIV_RESP = DP.RN(+)
                  connect by prior PS.RN = PS.HRN
                   start with PS.HRN is null
                   order by level,
                            PS.NUMB,
                            PS.BEGPLAN)
      loop
        /*       */
        if (STG.NHRN is not null) then
          RH_JB_JOBS := JB_JOBS_GET_BY_SOURCE(NIDENT => NIDENT, NPRN => NJB_PRJCTS, NSOURCE => STG.NHRN);
        else
          RH_JB_JOBS := null;
        end if;
        /*    */
        P_PROJECTJOB_GET_DURATION(NCOMPANY       => STG.NCOMPANY,
                                  DBEG_DATE      => STG.DBEGPLAN,
                                  DEND_DATE      => STG.DENDPLAN,
                                  NDURATION_MEAS => NDURATION_MEAS,
                                  NDURATION      => NDURATION);
        /*      */
        JB_JOBS_BASE_INSERT(NIDENT     => NIDENT,
                            NPRN       => NJB_PRJCTS,
                            NHRN       => RH_JB_JOBS.RN,
                            NSOURCE    => STG.NRN,
                            SNUMB      => STG.SNUMB,
                            SNAME      => STG.SNAME,
                            DDATE_FROM => STG.DBEGPLAN,
                            DDATE_TO   => STG.DENDPLAN,
                            NDURATION  => COALESCE(NDURATION, 0),
                            SEXECUTOR  => STG.SEXECUTOR,
                            NSTAGE     => 1,
                            NEDITABLE  => 0,
                            NJB_JOBS   => NJB_JOBS_STAGE);
        /*    */
        for PJ in (select J.COMPANY NCOMPANY,
                          J.RN NRN,
                          trim(J.NUMB) SNUMB,
                          J.NAME SNAME,
                          J.BEGPLAN DBEGPLAN,
                          J.ENDPLAN DENDPLAN,
                          COALESCE(COALESCE(DP.CODE, AG.AGNABBR), STG.SEXECUTOR) SEXECUTOR,
                          J.STATE NSTATE,
                          J.DURATION_CHG NDURATION_CHG
                     from PROJECTJOB     J,
                          AGNLIST        AG,
                          INS_DEPARTMENT DP
                    where J.PRN = PRJ.NRN
                      and J.PROJECTSTAGE = STG.NRN
                      and J.BEGPLAN is not null
                      and J.ENDPLAN is not null
                      and J.SUBDIV = DP.RN(+)
                      and J.PERFORM = AG.RN(+)
                    order by J.NUMB,
                             J.BEGPLAN)
        loop
          /*     */
          NEDITABLE := 1;
          if ((PRJ.NEDITABLE = 0) or (PJ.NSTATE <> 0) or (PJ.NDURATION_CHG <> 2)) then
            NEDITABLE := 0;
          end if;
          /*    */
          P_PROJECTJOB_GET_DURATION(NCOMPANY       => PJ.NCOMPANY,
                                    DBEG_DATE      => PJ.DBEGPLAN,
                                    DEND_DATE      => PJ.DENDPLAN,
                                    NDURATION_MEAS => NDURATION_MEAS,
                                    NDURATION      => NDURATION);
          /*      */
          JB_JOBS_BASE_INSERT(NIDENT     => NIDENT,
                              NPRN       => NJB_PRJCTS,
                              NHRN       => NJB_JOBS_STAGE,
                              NSOURCE    => PJ.NRN,
                              SNUMB      => PJ.SNUMB,
                              SNAME      => PJ.SNAME,
                              DDATE_FROM => PJ.DBEGPLAN,
                              DDATE_TO   => PJ.DENDPLAN,
                              NDURATION  => COALESCE(NDURATION, 0),
                              SEXECUTOR  => PJ.SEXECUTOR,
                              NSTAGE     => 0,
                              NEDITABLE  => NEDITABLE,
                              NJB_JOBS   => NJB_JOBS_JOB);
        end loop;
      end loop;
      /*     ,        */
      for PJ in (select J.RN NRN
                   from PROJECTJOB J
                  where J.PRN = PRJ.NRN
                    and exists (select null
                           from P8PNL_JB_JOBS JB
                          where JB.IDENT = NIDENT
                            and JB.STAGE = 0
                            and JB.SOURCE = J.RN))
      loop
        RH_JB_JOBS := JB_JOBS_GET_BY_SOURCE(NIDENT => NIDENT, NPRN => NJB_PRJCTS, NSOURCE => PJ.NRN);
        /*       */
        for PJPREV in (select JP.PROJECTJOB NPROJECTJOB from PROJECTJOBPREV JP where JP.PRN = PJ.NRN)
        loop
          RH_JB_JOBS_PREV := JB_JOBS_GET_BY_SOURCE(NIDENT => NIDENT, NPRN => NJB_PRJCTS, NSOURCE => PJPREV.NPROJECTJOB);
          JB_JOBSPREV_BASE_INSERT(NIDENT       => NIDENT,
                                  NPRN         => RH_JB_JOBS.RN,
                                  NJB_JOBS     => RH_JB_JOBS_PREV.RN,
                                  NJB_JOBSPREV => NJB_JOBS_JOBPREV);
        end loop;
      end loop;
    end loop;
    /*      */
    JB_PERIODS_RECALC(NIDENT => NIDENT, NINITIAL => 1, NRESOURCE_STATUS => NRESOURCE_STATUS);
  end JB_INIT;

end PKG_P8PANELS_PROJECTS;
/
